<?php
  include ('../accesscontrol.php');

  if ($is_logged_in == False) { exit(); }

  require_once ('../../../mysqli_connect_online_calcs_db_MYSQLI.php');
  require_once ('../../../my_functions_MYSQLI.php');

// check if the form has been submitted
  if (isset($_POST['submitted']) Or isset($_POST['h_sys_submitted']))
  {
    $id1 = safeEscapeString($conn, $_POST["id1"]);

    if (!is_numeric($id1))
    {
      include ('footer.html');
      exit();
    }

    $username = $_SESSION['username'];

    $sql = "SELECT * FROM birth_info WHERE ID='$id1' And entered_by='$username'";

    $result = @mysqli_query($conn, $sql) or error_log(mysqli_error($conn), 0);
    $row = mysqli_fetch_array($result, MYSQLI_ASSOC);
    $num_records = MYSQLI_NUM_rows($result);

    if ($num_records != 1)
    {
      echo "<center><br><br>I cannot find this person in the database. Please try again.</center>";
      include ('footer.html');
      exit();
    }


      // get all variables from database
    $h_sys = safeEscapeString($conn, $_POST["h_sys"]);
    $name = $row['name'];

    $month = $row['month'];
    $day = $row['day'];
    $year = $row['year'];

    $hour = $row['hour'];
    $minute = $row['minute'];
    $second = $row['second'];     //added 19 Mar 2010

    $timezone = $row['timezone'];

    $long_deg = $row['long_deg'];
    $long_min = $row['long_min'];
    $ew = $row['ew'];

    $lat_deg = $row['lat_deg'];
    $lat_min = $row['lat_min'];
    $ns = $row['ns'];

    $cityName = $row['city'];       //added 13 Oct 2009
    $countryName = $row['country'];       //added 06 May 2010

    include ('header_horary.html');       //here because of setting cookies above

    if ($ew < 0)
    {
      $ew_txt = "w";
    }
    else
    {
      $ew_txt = "e";
    }

    if ($ns > 0)
    {
      $ns_txt = "n";
    }
    else
    {
      $ns_txt = "s";
    }

        if ($my_error != "")
    {

    }
    else
    {
      // no errors in filling out form, so process form
      // calculate astronomic data
      $swephsrc = './sweph';    //sweph MUST be in a folder no less than at this level
      $sweph = './sweph';

      // Unset any variables not initialized elsewhere in the program
      unset($PATH,$out,$pl_name,$longitude1,$house_pos,$declination1);

      //assign data from database to local variables
      $inmonth = $month;
      $inday = $day;
      $inyear = $year;

      $_SESSION['inyear'] = $inyear;

      $inhours = $hour;
      $inmins = $minute;
      $insecs = $second;    //modified 19 Mar 2010

      $intz = $timezone;

      $my_longitude = $ew * ($long_deg + ($long_min / 60));
      $my_latitude = $ns * ($lat_deg + ($lat_min / 60));


//here is the new code that works using LMT
      $abs_tz = abs($intz);
      $the_hours = floor($abs_tz);
      $fraction_of_hour = $abs_tz - floor($abs_tz);
      $the_minutes = 60 * $fraction_of_hour;
      $whole_minutes = floor(60 * $fraction_of_hour);
      $fraction_of_minute = $the_minutes -$whole_minutes;
      $whole_seconds = round(60 * $fraction_of_minute);

      if ($intz >= 0)
      {
        $inhours = $inhours - $the_hours;
        $inmins = $inmins - $whole_minutes;
        $insecs =  $insecs - $whole_seconds;
      }
      else
      {
        $inhours = $inhours + $the_hours;
        $inmins = $inmins + $whole_minutes;
        $insecs =  $insecs + $whole_seconds;
      }
//end of modified code


      // adjust date and time for minus hour due to time zone taking the hour negative
      $utdatenow = strftime("%d.%m.%Y", mktime($inhours, $inmins, $insecs, $inmonth, $inday, $inyear));
      $utnow = strftime("%H:%M:%S", mktime($inhours, $inmins, $insecs, $inmonth, $inday, $inyear));

      putenv("PATH=$PATH:$swephsrc");

      // get LAST_PLANET planets and all house cusps
      if (strlen($h_sys) != 1)
      {
      //  $h_sys = "p";
        $h_sys = "r";
      }

      exec ("swetest -edir$sweph -b$utdatenow -ut$utnow -p0123456789ttt -eswe -house$my_longitude,$my_latitude,$h_sys -flsjd -g, -head", $out);

      // Each line of output data from swetest is exploded into array $row, giving these elements:
      // 0 = longitude
      // 1 = speed
      // 2 = house position
      // planets are index 0 - index (LAST_PLANET), house cusps are index (LAST_PLANET + 1) - (LAST_PLANET + 12)
      foreach ($out as $key => $line)
      {
        $row = explode(',',$line);
        $longitude1[$key] = $row[0];
        $speed1[$key] = $row[1];
        $house_pos1[$key] = $row[2];
        $declination1[$key] = $row[3];
      };


      include("horary_constants.php");      // this is here because we must rename the planet names


//calculate Planetary hours
      $starting_JD = gregoriantojd($inmonth, $inday, $inyear) + ($ew * 0.25);

      $intz = round(abs($my_longitude) / 15);

      if ($my_longitude < 0) { $intz = -$intz; }

      $result = exec ("swetest -edir$sweph -bj$starting_JD -eswe -geopos$my_longitude,$my_latitude,400 -rise");

      $first_colon = strpos($result, ":") + 1;
      $rise_hour = mid($result, $first_colon - 2, 2) + $intz;

      if ($rise_hour >= 24) { $rise_hour = $rise_hour - 24; }

      $rise_minute = mid($result, $first_colon + 1, 2);

      $second_colon = strpos($result, ":", $first_colon + 1) + 1;
      $rise_seconds = mid($result, $second_colon + 1, 2);

      $third_colon = strpos($result, ":", $second_colon + 1) + 1;
      $set_hour = mid($result, $third_colon - 2, 2) + $intz;
      if ($set_hour < 0) { $set_hour = $set_hour + 24; }

      $set_minute = mid($result, $third_colon + 1, 2);

      $fourth_colon = strpos($result, ":", $third_colon + 1) + 1;
      $set_seconds = mid($result, $fourth_colon + 1, 2);

      $day_of_week = jddayofweek($starting_JD + 0.5);   //0 = Sunday, 6 = Saturday

      $sunset_time = $set_hour + ($set_minute / 60) + ($set_seconds / 3600);      //in decimal hours, 0 - 23.99
      $sunrise_time = $rise_hour + ($rise_minute / 60) + ($rise_seconds / 3600);
      $birth_time = $hour + ($inmins / 60) + ($insecs / 3600);

      $_SESSION['sunset_time'] = $sunset_time;
      $_SESSION['sunrise_time'] = $sunrise_time;
      $_SESSION['birth_time'] = $birth_time;
      $_SESSION['day_of_week'] = $day_of_week;


      //calculate the South Node
      $longitude1[SE_TSNODE] = $longitude1[SE_TNNODE] + 180;
      if ($longitude1[SE_TSNODE] >= 360) { $longitude1[SE_TSNODE] = $longitude1[SE_TSNODE] - 360; }

      $declination1[SE_TSNODE] = -$declination1[SE_TNNODE];


      //calculate the Part of Fortune
      //is this a day chart or a night chart?
      if ($longitude1[LAST_PLANET + 1] > $longitude1[LAST_PLANET + 7])
      {
        if ($longitude1[0] <= $longitude1[LAST_PLANET + 1] And $longitude1[0] > $longitude1[LAST_PLANET + 7])
        {
          $day_chart = True;
        }
        else
        {
          $day_chart = False;
        }
      }
      else
      {
        if ($longitude1[0] > $longitude1[LAST_PLANET + 1] And $longitude1[0] <= $longitude1[LAST_PLANET + 7])
        {
          $day_chart = False;
        }
        else
        {
          $day_chart = True;
        }
      }

      if ($day_chart == True)
      {
        $longitude1[SE_POF] = $longitude1[LAST_PLANET + 1] + $longitude1[SE_MOON] - $longitude1[SE_SUN];
      }
      else
      {
        $longitude1[SE_POF] = $longitude1[LAST_PLANET + 1] - $longitude1[SE_MOON] + $longitude1[SE_SUN];
      }

      if ($longitude1[SE_POF] >= 360) { $longitude1[SE_POF] = $longitude1[SE_POF] - 360; }

      if ($longitude1[SE_POF] < 0) { $longitude1[SE_POF] = $longitude1[SE_POF] + 360; }



//get house positions of planets here
      for ($x = 1; $x <= 12; $x++)
      {
        for ($y = 0; $y <= LAST_PLANET; $y++)
        {
          $pl = $longitude1[$y] + (1 / 36000);
          if ($x < 12 And $longitude1[$x + LAST_PLANET] > $longitude1[$x + LAST_PLANET + 1])
          {
            If (($pl >= $longitude1[$x + LAST_PLANET] And $pl < 360) Or ($pl < $longitude1[$x + LAST_PLANET + 1] And $pl >= 0))
            {
              $house_pos1[$y] = $x;
              continue;
            }
          }

          if ($x == 12 And ($longitude1[$x + LAST_PLANET] > $longitude1[LAST_PLANET + 1]))
          {
            if (($pl >= $longitude1[$x + LAST_PLANET] And $pl < 360) Or ($pl < $longitude1[LAST_PLANET + 1] And $pl >= 0))
            {
              $house_pos1[$y] = $x;
            }
            continue;
          }

          if (($pl >= $longitude1[$x + LAST_PLANET]) And ($pl < $longitude1[$x + LAST_PLANET + 1]) And ($x < 12))
          {
            $house_pos1[$y] = $x;
            continue;
          }

          if (($pl >= $longitude1[$x + LAST_PLANET]) And ($pl < $longitude1[LAST_PLANET + 1]) And ($x == 12))
          {
            $house_pos1[$y] = $x;
          }
        }
      }

//display natal data
      $secs = "0";
      if ($timezone < 0)
      {
        $tz = $timezone;
      }
      else
      {
        $tz = "+" . $timezone;
      }

     $restored_name = stripslashes($name);

        echo "<center>";

         if ($h_sys == "p")
         {
           $house_system_name = "Placidus";
         }
         elseif ($h_sys == "k")
         {
           $house_system_name = "Koch";
         }
         elseif ($h_sys == "r")
         {
           $house_system_name = "Regiomontanus";
         }
         elseif ($h_sys == "c")
         {
           $house_system_name = "Campanus";
         }
         elseif ($h_sys == "b")
         {
           $house_system_name = "Alcabitus";
         }
         elseif ($h_sys == "o")
         {
           $house_system_name = "Porphyrius";
         }
         elseif ($h_sys == "m")
         {
           $house_system_name = "Morinus";
         }
         elseif ($h_sys == "a")
         {
           $house_system_name = "Equal house";
         }
         elseif ($h_sys == "t")
         {
           $house_system_name = "Topocentric";
         }
         elseif ($h_sys == "v")
         {
           $house_system_name = "Vehlow";
         }

      $line1 = $restored_name . ", - " . strftime("%A, %B %d, %Y", mktime($hour, $minute, $secs, $month, $day, $year));
      $line2 = strftime("%H:%M (time zone = $tz hours)", mktime($hour, $minute, $secs, $month, $day, $year));

      if ($countryName != "")
      {
        $line3 = $long_deg . $ew_txt . $long_min . ", " . $lat_deg . $ns_txt . $lat_min . " - " . $cityName . ", " . $countryName;
      }
      else
      {
        $line3 = $long_deg . $ew_txt . $long_min . ", " . $lat_deg . $ns_txt . $lat_min . " - " . $cityName;
      }

      $line4 = "House system = " . $house_system_name;

?>
      <form action="<?php echo $_SERVER['PHP_SELF']; ?>" method="post">
        <select name="h_sys" size="1">
          <?php
          echo "<option value='r' ";
          if ($h_sys == "r"){ echo " selected"; }
          echo "> Regiomontanus </option>";

          echo "<option value='p' ";
          if ($h_sys == "p"){ echo " selected"; }
          echo "> Placidus </option>";

          echo "<option value='k' ";
          if ($h_sys == "k"){ echo " selected"; }
          echo "> Koch </option>";



          echo "<option value='c' ";
          if ($h_sys == "c"){ echo " selected"; }
          echo "> Campanus </option>";

          echo "<option value='b' ";
          if ($h_sys == "b"){ echo " selected"; }
          echo "> Alcabitus </option>";

          echo "<option value='o' ";
          if ($h_sys == "o"){ echo " selected"; }
          echo "> Porphyrius </option>";

          echo "<option value='m' ";
          if ($h_sys == "m"){ echo " selected"; }
          echo "> Morinus </option>";

          echo "<option value='a' ";
          if ($h_sys == "a"){ echo " selected"; }
          echo "> Equal house - Asc </option>";

          echo "<option value='t' ";
          if ($h_sys == "t"){ echo " selected"; }
          echo "> Topocentric </option>";

          echo "<option value='v' ";
          if ($h_sys == "v"){ echo " selected"; }
          echo "> Vehlow </option>";
          ?>
        </select>


        <input type="hidden" name="id1" value="<?php echo $_POST['id1']; ?>">
        <input type="hidden" name="name" value="<?php echo $_POST['name']; ?>">
        <input type="hidden" name="sex" value="<?php echo $_POST['sex']; ?>">
        <input type="hidden" name="month" value="<?php echo $_POST['month']; ?>">
        <input type="hidden" name="day" value="<?php echo $_POST['day']; ?>">
        <input type="hidden" name="year" value="<?php echo $_POST['year']; ?>">
        <input type="hidden" name="hour" value="<?php echo $_POST['hour']; ?>">
        <input type="hidden" name="minute" value="<?php echo $_POST['minute']; ?>">
        <input type="hidden" name="second" value="<?php echo $_POST['second']; ?>">
        <input type="hidden" name="cityName" value="<?php echo $_POST['cityName']; ?>">
        <input type="hidden" name="timezone" value="<?php echo $_POST['timezone']; ?>">
        <input type="hidden" name="long_deg" value="<?php echo $_POST['long_deg']; ?>">
        <input type="hidden" name="long_min" value="<?php echo $_POST['long_min']; ?>">
        <input type="hidden" name="ew" value="<?php echo $_POST['ew']; ?>">
        <input type="hidden" name="lat_deg" value="<?php echo $_POST['lat_deg']; ?>">
        <input type="hidden" name="lat_min" value="<?php echo $_POST['lat_min']; ?>">
        <input type="hidden" name="ns" value="<?php echo $_POST['ns']; ?>">

        <input type="hidden" name="h_sys_submitted" value="TRUE">
        <INPUT type="submit" name="submit" value="Go" align="middle" style="background-color:#1c1e51;color:#ffffff;font-size:14px;font-weight:bold">
      </form>
<?php
      echo "</center>";

      $hr_ob = $hour;
      $min_ob = $minute;
      $sec_ob = $second;    //added 19 Mar 2010

      $ubt1 = 0;
      if (($hr_ob == 12) And ($min_ob == 0) And ($sec_ob == 0))
      {
        $ubt1 = 1;        // this person has an unknown birth time
      }

      $ubt2 = $ubt1;

      $rx1 = "";
      for ($i = 0; $i <= SE_TSNODE; $i++)
      {
        if ($speed1[$i] < 0)
        {
          $rx1 .= "R";
        }
        else
        {
          $rx1 .= " ";
        }
      }

      $rx2 = $rx1;

      for ($i = 1; $i <= LAST_PLANET; $i++)
      {
        $hc1[$i] = $longitude1[LAST_PLANET + $i];
      }

      $hc1[13] = $hc1[1];

// no need to urlencode unless perhaps magic quotes is ON (??)
      $ser_L1 = serialize($longitude1);
      $ser_L2 = serialize($longitude1);
      $ser_hc1 = serialize($hc1);
      $ser_hpos = serialize($house_pos1);

      $_SESSION['longitude1'] = $longitude1;
      $_SESSION['speed1'] = $speed1;
      $_SESSION['rx1'] = $rx1;
      $_SESSION['declination1'] = $declination1;
      $_SESSION['hc1'] = $hc1;
      $_SESSION['house_pos1'] = $house_pos1;


//30 degree line - calculate maximum number of planets in same degree, because this determines our height
      $temp = $longitude1[LAST_PLANET + 2];

      $longitude1[LAST_PLANET + 2] = $longitude1[LAST_PLANET + 10];

      $deg_filled_idx = array();            //find the maximum number of planets in the same degree

      for ($i = 0; $i <= 30; $i++) { $deg_filled_idx[$i] = 0; }

      $cnt = 0;
      for ($i = 0; $i <= LAST_PLANET + 2; $i++)
      {
        $pl_pos = floor(Reduce_below_30($longitude1[$i]));
        $deg_filled_idx[$pl_pos]++;
      }

      $mx = 0;
      for ($i = 0; $i <= 30; $i++)
      {
        if ($deg_filled_idx[$i] > $mx) { $mx = $deg_filled_idx[$i]; }
      }

      $longitude1[LAST_PLANET + 2] = $temp;


      //get the Moon's aspects
      include("horary_moon_aspects.php");   //calculate Moon's aspects over time here


      $total_width = 792;         //added 10 for left and right margins - was 780 - was 700
      $wheel_width = 640;
      $extra_width_for_graphic_data_table = $total_width - $wheel_width;

      //calculate the height of the graphic, considering chart wheel, graphic data table, and 3-deg line
      $wheel_height = 640;

      $num_active_planets = 15;
      $extra_height_for_graphic_data_table = 140 + (20 * ($num_active_planets - 12)) + 120;

      $L2_height = $mx;
      $L2_height = ($L2_height + 1) * 50;


//calculate how high our table must be
      $num_regular_aspects = Count_regular_aspects($longitude1, $moiety);

      //$pl_asp_height = $num_regular_aspects * 15 + 10;          //use planet aspects as reference
      $pl_asp_height = 40 + (($num_moon_aspects + 4) * 15);         //use the Moon aspects as reference

      $_SESSION['pl_asp_height_planets'] = $pl_asp_height;


      $y_top_margin = 64;
      $wheel_height = $wheel_height + $extra_height_for_graphic_data_table + $y_top_margin + $L2_height + $pl_asp_height;


      echo "<center>";
      echo "<br><br>";

      echo "<img border='0' src='horary_wheel.php?rx1=$rx1&l1=$line1&l2=$line2&l3=$line3&l4=$line4&eh=$extra_height_for_graphic_data_table&eh30d=$L2_height&eh_pdt=$pl_asp_height&ew=$extra_width_for_graphic_data_table&ytm=$y_top_margin' width='$total_width' height='$wheel_height'>";

      echo "<br><br>";


      $hash_x = md5($line1 . $line2 . $line3);
      $_SESSION['hash_x'] = $hash_x;

      $URL = "./downloads/" . $hash_x . ".png";
      echo "<a href='$URL'>Click here</a> to generate a URL to this chart<br><br>";
      echo "<br>";

      echo "</center>";


//display natal data
      echo '<center><table width="75%" cellpadding="0" cellspacing="0" border="0">';
        echo '<tr>';
          echo "<td class='tittlenor'> Planet </td>";
          echo "<td class='tittlenor'> Longitude </td>";
          echo "<td class='tittlenor'> Declination </td>";
          echo "<td class='tittlenor'> House position </td>";
          echo "<td class='tittlenor'> House Cusp </td>";
          echo "<td class='tittlenor'> Longitude </td>";
        echo '</tr>';

      $a1 = LAST_PLANET;
      if ($ubt1 == 1) { $a1 = SE_TSNODE; }

      for ($i = 0; $i <= $a1; $i++)
      {
        echo '<tr>';
        echo "<td class='textnor'>" . $pl_name[$i] . "</td>";
        echo "<td class='textnor'>" . Convert_Longitude($longitude1[$i]) . " " . Mid($rx1, $i + 1, 1) . "</td>";
        echo "<td class='textnor'>" . Convert_Declination($declination1[$i]) . "</td>";

        $hse = floor($house_pos1[$i]);
        if ($hse < 10)
        {
          echo "<td class='textnor'>&nbsp;&nbsp;&nbsp;&nbsp; " . $hse . "</td>";
        }
        else
        {
          echo "<td class='textnor'>&nbsp;&nbsp;&nbsp;" . $hse . "</td>";
        }


          if ($i == 0)
          {
            echo "<td class='textnor'><strong> (Asc)</strong> </td>";
            }
          elseif ($i == 9)
          {
            echo "<td class='textnor'><strong> (MC)</strong> </td>";
          }
          elseif ($i <= 11)
          {
            echo "<td class='textnor'>House " . ($i + 1) . "</td>";
          }
          else
          {
            echo "<td class='textnor'>&nbsp;</td>";
          }

          if ($i <= 11)
          {
            echo "<td class='textnor'>" . Convert_Longitude($longitude1[$i + LAST_PLANET + 1]) . "</td>";
          }
          else
          {
            echo "<td class='textnor'>&nbsp;</td>";
          }
        echo '</tr>';
      }
      echo '</table><br><br>';


      // display natal data - aspect table
      echo '<table width="75%" cellpadding="0" cellspacing="0" border="0">';
      echo '<tr>';
      echo "<td class='tittlenor'> Planet </td>";
      echo "<td class='tittlenor'> Aspect </td>";
      echo "<td class='tittlenor'> Planet </td>";
      echo "<td class='tittlenor'><b> Aspect orb </td>";
      echo '</tr>';

      // include Ascendant and MC
      $longitude1[LAST_PLANET + 1] = $hc1[1];
      $longitude1[LAST_PLANET + 2] = $hc1[10];

      $pl_name[LAST_PLANET + 1] = "Asc";
      $pl_name[LAST_PLANET + 2] = "MC";


      if ($ubt1 == 1)
      {
        $a1 = SE_TSNODE;
      }
      else
      {
        $a1 = LAST_PLANET + 2;
      }


      for ($i = 0; $i <= $a1; $i++)
      {
        echo "<tr><td colspan='4'>&nbsp;</td></tr>";

        for ($j = 0; $j <= $a1; $j++)
        {
          $this_is_special_body = False;

          if ($i == SE_POF Or $j == SE_POF)
          {
            $orb = ASPECT_ORB_SE_POF;
            $this_is_special_body = True;   //so do not use a different orb for any aspect
          }
          elseif ($i == SE_TNNODE Or $j == SE_TNNODE Or $i == SE_TSNODE Or $j == SE_TSNODE)
          {
            $orb = ASPECT_ORB_SE_SE_NODES;
            $this_is_special_body = True;   //so do not use a different orb for any aspect
          }

          $q = -99;
          $da = Abs($longitude1[$i] - $longitude1[$j]);

          // is there an aspect within orb?
          for ($k = 0; $k <= NUM_ASPECTS_SPECIAL - 1; $k++)
          {
            if ($this_is_special_body == False)
            {
              if ($k == 0 Or $k == 2 Or $k == 3 Or $k == 5)     //look for major aspects
              {
                if ($i == SE_SUN Or $i == SE_MOON Or $j == SE_SUN Or $j == SE_MOON)
                {
                  $orb = ASPECT_ORB_MAJOR_LIGHTS;
                }
                else
                {
                  $orb = ASPECT_ORB_MAJOR;
                }
              }
              elseif ($k == 1 Or $k == 4 Or $k >= START_OF_MINOR_ASPECTS)
              {
                $orb = $asp_orb_value[$k];      // look for sextiles and quincunxes as non-MAJOR aspects as well as all minor aspects   was MINOR_ASPECT_ORB;
              }
              else
              {
                $orb = 3;     //catch-all
              }
            }


            if ((($da <= $exact_aspect_special[$k] + $orb) And ($da >= $exact_aspect_special[$k] - $orb)) Or (($da <= 360 - $exact_aspect_special[$k] + $orb) And ($da >= 360 - $exact_aspect_special[$k] - $orb)))
            {
              $q = $k;
              $dax = $da - $exact_aspect_special[$k];

              if (abs($dax) > $orb) { $dax = 360 - $da - $exact_aspect_special[$k]; }

              break;
            }
          }


          if ($q >= 0 And $i != $j)
          {
            // aspect exists
            echo '<tr>';
            echo "<td class='textnor'>" . $pl_name[$i] . "</td>";
            echo "<td class='textnor'>" . $asp_name_special[$q] . "</td>";
            echo "<td class='textnor'>" . $pl_name[$j] . "</td>";
            echo "<td class='textnor'>" . sprintf("%.2f", abs($dax)) . "</td>";
            echo '</tr>';
          }
        }
      }

      echo '</table></center>';
      echo "<br><br>";

      echo '<center>';

      // loop through each planet - calculate how many planets are in each element, Sun - Saturn plus Asc and MC
      // Uranus - Pluto are not counted because they are not personal and are generational. Sun, Moon, Asc get extra count.
      $elements = array();

      $elements[0] = 0;
      $elements[1] = 0;
      $elements[2] = 0;
      $elements[3] = 0;

      for ($i = SE_SUN; $i <= LAST_PLANET + 2; $i++)
      {
        if ($i <= SE_SATURN Or $i > LAST_PLANET)
        {
          $s_pos = floor($longitude1[$i] / 30) + 1;
          $elements[$s_pos % 4]++;

          if ($i == SE_SUN Or $i == SE_MOON Or $i == LAST_PLANET + 1)
          {
            $elements[$s_pos % 4]++;
          }
        }
      }

      echo "<br><br>";
      }
    }

  include ('footer.html');
  exit();


Function left($leftstring, $leftlength)
{
  return(substr($leftstring, 0, $leftlength));
}


Function Reduce_below_30($longitude)
{
  $lng = $longitude;

  while ($lng >= 30)
  {
    $lng = $lng - 30;
  }

  return $lng;
}


Function Convert_Longitude($longitude)
{
  $signs = array (0 => 'Ari', 'Tau', 'Gem', 'Can', 'Leo', 'Vir', 'Lib', 'Sco', 'Sag', 'Cap', 'Aqu', 'Pis');
//  $signs = array (0 => '', '', '', '', '', '', '', '', '', '', '', '');

  $sign_num = floor($longitude / 30);
  $pos_in_sign = $longitude - ($sign_num * 30);
  $deg = floor($pos_in_sign);
  $full_min = ($pos_in_sign - $deg) * 60;
  $min = floor($full_min);
  $full_sec = round(($full_min - $min) * 60);

  if ($deg < 10)
  {
    $deg = "0" . $deg;
  }

  if ($min < 10)
  {
    $min = "0" . $min;
  }

  if ($full_sec < 10)
  {
    $full_sec = "0" . $full_sec;
  }

  //return $deg . " " . $signs[$sign_num] . " " . $min . "' " . $full_sec . chr(34);
  return $signs[$sign_num] . " " . $deg . " " . $min . "' " . $full_sec . chr(34);
}


Function mid($midstring, $midstart, $midlength)
{
  return(substr($midstring, $midstart-1, $midlength));
}



Function Find_Specific_Report_Paragraph($phrase_to_look_for, $file)
{
  return "";

  $string = "";
  $len = strlen($phrase_to_look_for);

  //put entire file contents into an array, line by line
  $file_array = file($file);

  // look through each line searching for $phrase_to_look_for
  for($i = 0; $i < count($file_array); $i++)
  {
    if (left(trim($file_array[$i]), $len) == $phrase_to_look_for)
    {
      $flag = 0;
      while (trim($file_array[$i]) != "*")
      {
        if ($flag == 0)
        {
          $string .= "<b>" . $file_array[$i] . "</b>";
        }
        else
        {
          $string .= $file_array[$i];
        }
        $flag = 1;
        $i++;
      }
      break;
    }
  }

  return $string;
}


Function Print_element_text($phrase_to_look_for, $dir_to_use)
{
  return;

  $file = $dir_to_use . "elements.txt";
  $string = Find_Specific_Report_Paragraph($phrase_to_look_for, $file);
  $string = nl2br($string);

  echo "<span class='tnormal'>" . $string . "</span>";
}


Function Convert_Declination($declination)
{
  if ($declination < 0)
  {
    $d = "S";
  }
  else
  {
    $d = "N";
  }

  $decl = abs($declination);

  $deg = floor($decl);
  $full_min = ($decl - $deg) * 60;
  $min = floor($full_min);
  $full_sec = round(($full_min - $min) * 60);

  if ($deg < 10) { $deg = "0" . $deg; }

  if ($min < 10) { $min = "0" . $min; }

  if ($full_sec < 10) { $full_sec = "0" . $full_sec; }

  return $deg . " " . $d . " " . $min . "' " . $full_sec . chr(34);
}


Function Count_regular_aspects($longitude, $moiety)
{
  $num_regular_aspects = 0;

  for ($i = 0; $i <= 9; $i++)
  {
    for ($j = $i + 1; $j <= 10; $j++)
    {
      $q = 0;
      $da = Abs($longitude[$i] - $longitude[$j]);

      if ($da > 180) { $da = 360 - $da; }

      $orb = $moiety[$i] + $moiety[$j];

      // is there an aspect within orb?
      if ($da <= $orb)
      {
        $q = 1;
      }
      elseif (($da <= (60 + $orb)) And ($da >= (60 - $orb)))
      {
        $q = 6;
      }
      elseif (($da <= (90 + $orb)) And ($da >= (90 - $orb)))
      {
        $q = 4;
      }
      elseif (($da <= (120 + $orb)) And ($da >= (120 - $orb)))
      {
        $q = 3;
      }
      elseif (($da <= (150 + $orb)) And ($da >= (150 - $orb)))
      {
        $q = 5;
      }
      elseif ($da >= (180 - $orb))
      {
        $q = 2;
      }

      if ($q > 0)
      {
        if ($j == 10 And $q != 1) { continue; }

        $num_regular_aspects = $num_regular_aspects + 1;
      }
    }
  }

  return $num_regular_aspects;
}


Function Crunch($x)
{
  if ($x >= 0)
  {
    $y = $x - floor($x / 360) * 360;
  }
  else
  {
    $y = 360 + ($x - ((1 + floor($x / 360)) * 360));
  }

  return $y;
}

?>