<?php
//calculate the aspects of the Moon and VOC
  $num_days = 3;

  $start_month = $inmonth;
  $start_day = $inday;
  $start_year = $inyear;

  $hour2 = $hour;
  $minute2 = $minute;

  // Unset any variables not initialized elsewhere in the program
  unset($out,$t_longitude, $t_speed);

//start of Moon aspectarian routines
  $current_tz = $timezone;

  //find Julian day for transit date (at midnight)
  $starting_JD = gregoriantojd($start_month, $start_day, $start_year) - 0.5;
  $ending_JD = $starting_JD + $num_days - 1;

  unset($moon_asp_details);
  $moon_asp_details = array();
  $num_moon_aspects = 0;


  //find when Moon enters new sign
  for ($x = 0; $x <= 11; $x++)
  {
    $p1_idx = $pl_ephem_number[1];    //Moon index into Swiss ephemeris - for calculating new planet position

    $degr = $x * 30;
    for ($z = $starting_JD; $z <= $ending_JD; $z++)
    {
      $angle = 0;
      $secant_results = Secant_Method_one_degree($z, $z + 1, 0.00007, 100, $angle, $p1_idx, $degr);
      $Result_JD = $secant_results[0];

      $sign_of = floor(($secant_results[1] + 1) / 30);    //add 1 to the longitude so we dont get rounding errors

      $rnd_off = sprintf("%.3f", $Result_JD);
      if ($rnd_off >= $z And $rnd_off < $z + 1)
      {
        $first_date = ConvertJDtoDateandTime($Result_JD, $current_tz);
        $num_moon_aspects = $num_moon_aspects + 1;
        $moon_asp_details[0][$num_moon_aspects] = $Result_JD;

        $moon_asp_details[1][$num_moon_aspects] = "**";
        $moon_asp_details[2][$num_moon_aspects] = 1;        //planet number of Moon
        $moon_asp_details[3][$num_moon_aspects] = "enters";
        $moon_asp_details[4][$num_moon_aspects] = $sign_of + 1;   //sign number of Moon
        $moon_asp_details[10][$num_moon_aspects] = $first_date;   //date and time of exact aspect
      }
    }
  }

  //find when Moon makes an exact aspect to any planet
  for ($y = 0; $y <= 9; $y++)               //FOR DEBUG - use up to Pluto for now
  {
    if ($y != 1 And $y != 11 And $y != 12)
    {
      $p1_idx = $pl_ephem_number[1];      //Moon index into Swiss ephemeris - for calculating new planet position
      $p2_idx = $pl_ephem_number[$y];     //planet index into Swiss ephemeris - for calculating new planet position

      for ($z = $starting_JD; $z <= $ending_JD; $z++)
      {
        //check for any exact aspect - major aspects only
        for ($q = 1; $q <= 7; $q++)         //$q is aspect number
        {
          if ($q != 2 And $q != 6)
          {
            $angle = $aspects_defined[$q];
            $secant_results = Secant_Method($z, $z + 1, 0.00007, 100, $angle, $p1_idx, $p2_idx, $y);
            $Result_JD = $secant_results[0];

            $rnd_off = sprintf("%.3f", $Result_JD);
            if ($rnd_off >= $z And $rnd_off < $z + 1)
            {
              $first_date = ConvertJDtoDateandTime($Result_JD, $current_tz);
              $num_moon_aspects = $num_moon_aspects + 1;
              $moon_asp_details[0][$num_moon_aspects] = $Result_JD;

              //must translate one set of aspect codes to another set of aspect codes for the glyphs
              if ($q == 1) { $qq = 1; }
              elseif ($q == 2) { $qq = 7; }
              elseif ($q == 3) { $qq = 6; }
              elseif ($q == 4) { $qq = 4; }
              elseif ($q == 5) { $qq = 3; }
              elseif ($q == 6) { $qq = 8; }
              elseif ($q == 7) { $qq = 2; }
              elseif ($q == 8) { $qq = 9; }
              elseif ($q == 9) { $qq = 5; }

              $moon_asp_details[2][$num_moon_aspects] = 1;                    //transit Moon planet number
              $moon_asp_details[3][$num_moon_aspects] = "-";
              $moon_asp_details[4][$num_moon_aspects] = floor($secant_results[1] / 30) + 1;   //transit Moon sign number
              $moon_asp_details[5][$num_moon_aspects] = $qq;                  //aspect number
              $moon_asp_details[6][$num_moon_aspects] = $y;                   //transit planet number

              if ($secant_results[4] < 0)
              {
                $moon_asp_details[7][$num_moon_aspects] = 62;                 //glyph number for Rx
              }
              else
              {
                $moon_asp_details[7][$num_moon_aspects] = 32;                 //glyph number for space
              }

              $moon_asp_details[8][$num_moon_aspects] = "-";
              $moon_asp_details[9][$num_moon_aspects] = floor($secant_results[3] / 30) + 1;   //transit planet sign number
              $moon_asp_details[10][$num_moon_aspects] = $first_date;             //date and time of exact aspect

              break;
            }
          }
        }
      }
    }
  }

  //sort the aspects found according to earliest time
  $temp = array();

  for ($x = 1; $x <= $num_moon_aspects - 1; $x++)
  {
    for ($y = $x + 1; $y <= $num_moon_aspects; $y++)
    {
      if ($moon_asp_details[0][$y] < $moon_asp_details[0][$x])
      {
        for ($z = 0; $z <= 10; $z++)
        {
          $temp[$z] = $moon_asp_details[$z][$x];
          $moon_asp_details[$z][$x] = $moon_asp_details[$z][$y];
          $moon_asp_details[$z][$y] = $temp[$z];
        }
      }
    }
  }


  $_SESSION['moon_asp_details'] = $moon_asp_details;
  $_SESSION['num_moon_aspects'] = $num_moon_aspects;



Function Secant_Method($earlier_jd, $later_jd, $e, $m, $angle, $p1_idx, $p2_idx, $p2)
{
  for ($n = 1; $n <= $m; $n++)
  {
    //get positions of both planets on JD = later_jd and JD = earlier_jd
    $result = Get_2_Planets_geo($later_jd, $p1_idx, $p2_idx);
    $y1 = $result[0];
    $speed1 = $result[1];
    $y2 = $result[2];
    $speed2 = $result[3];

    $result = Get_2_Planets_geo($earlier_jd, $p1_idx, $p2_idx);
    $y3 = $result[0];
    $y4 = $result[2];

    //get distance from exact aspect for both planets on JD = later_jd
    $dayy = $y2 - $y1;
    $da = abs($y2 - $y1);
    if ($da > 180)
    {
      $da = 360 - $da;
    }
    $dist1 = $da - $angle;
    if ($dayy <= -180 Or ($dayy >= 0 And $dayy < 180))
    {
      $dist1 = -$dist1;
    }

    //get distance from exact aspect for both planets on JD = earlier_jd
    $dayy = $y4 - $y3;
    $da = abs($y4 - $y3);
    if ($da > 180)
    {
      $da = 360 - $da;
    }
    $dist2 = $da - $angle;
    if ($dayy <= -180 Or ($dayy >= 0 And $dayy < 180))
    {
      $dist2 = -$dist2;
    }

    if ($dist1 - $dist2 == 0)
    {
      $later_jd = ($later_jd + $earlier_jd) / 2;
      $d = 0;
    }
    else
    {
      $d = (($later_jd - $earlier_jd) / ($dist1 - $dist2)) * $dist1;
    }

    if (abs($dist1 - $dist2) > 20 And $n >= 2)
    {
      //keep from looping needlessly AND
      //protect against case where dist1 = -dist2, which gives false aspect
      //example 21 March 2006 - Moon 120 Mars - there is no trine, but an opposition
      $later_jd = 0;
      break;
    }

    if (abs($d) < $e)
    {
      break;
    }

    $earlier_jd = $later_jd;

    if (abs($d) >= 1.001)
    {
      //out of range - there is no aspect in this time frame (1 day)
      $later_jd = 0;
      break;
    }
    else
    {
      $later_jd = $later_jd - $d;
    }
  }

  if ($n > $m)
  {
    $results[0] = 0;
  }
  else
  {
    $results[0] = $later_jd;
  }
  $results[1] = $y1;
  $results[2] = $speed1;
  $results[3] = $y2;
  $results[4] = $speed2;

  return $results;
}


Function Secant_Method_one_degree($earlier_jd, $later_jd, $e, $m, $angle, $p1_idx, $degr)
{
  for ($n = 1; $n <= $m; $n++)
  {
    //get positions of both planets on JD = later_jd and JD = earlier_jd
    $ls = Get_1_Planet_geo($later_jd, $p1_idx);
    $y1 = $ls[0];
    $ls = Get_1_Planet_geo($earlier_jd, $p1_idx);
    $y3 = $ls[0];

    //get distance from exact aspect for both planets on JD = later_jd
    $dayy = $degr - $y1;
    $da = abs($degr - $y1);
    if ($da > 180)
    {
      $da = 360 - $da;
    }
    $dist1 = $da - $angle;
    if ($dayy <= -180 Or ($dayy >= 0 And $dayy < 180))
    {
      $dist1 = -$dist1;
    }

    //get distance from exact aspect for both planets on JD = earlier_jd
    $dayy = $degr - $y3;
    $da = abs($degr - $y3);
    if ($da > 180)
    {
      $da = 360 - $da;
    }
    $dist2 = $da - $angle;
    if ($dayy <= -180 Or ($dayy >= 0 And $dayy < 180))
    {
      $dist2 = -$dist2;
    }

    if ($dist1 - $dist2 == 0)
    {
      $later_jd = ($later_jd + $earlier_jd) / 2;
      $d = 0;
    }
    else
    {
      $d = (($later_jd - $earlier_jd) / ($dist1 - $dist2)) * $dist1;
    }

    if (abs($dist1 - $dist2) > 20 And $n >= 2)
    {
      //keep from looping needlessly AND
      //protect against case where dist1 = -dist2, which gives false aspect
      //example 21 March 2006 - Moon 120 Mars - there is no trine, but an opposition
      $later_jd = 0;
      break;
    }

    if (abs($d) < $e)
    {
      break;
    }

    $earlier_jd = $later_jd;

    if (abs($d) >= 1.001)
    {
      //out of range - there is no aspect in this time frame (1 day)
      $later_jd = 0;
      break;
    }
    else
    {
      $later_jd = $later_jd - $d;
    }
  }

  if ($n > $m)
  {
    $results[0] = 0;
  }
  else
  {
    $results[0] = $later_jd;
  }
  $results[1] = $y1;

  return $results;
}


Function Get_1_Planet_geo($jd, $p_idx)
{
  //get longitude of planet indicated by $p_idx
  $swephsrc = './sweph';    //sweph MUST be in a folder no less than at this level
  $sweph = './sweph';

  unset($out,$t_long);
  exec ("swetest -edir$sweph -bj$jd -ut -p$p_idx -eswe -fls -g, -head", $out);

  // Each line of output data from swetest is exploded into array $row, giving these elements:
  // 0 = longitude
  // 1 = speed
  foreach ($out as $key => $line)
  {
    $row = explode(',',$line);
    $t_long[$key] = $row[0];
    $t_speed[$key] = $row[1];
  };

  $long_speed[0] = $t_long[0];
  $long_speed[1] = $t_speed[0];

  return $long_speed;
}


Function Get_2_Planets_geo($jd, $p1_idx, $p2_idx)
{
  //get longitudes of planets indicated by $p1_idx and $p2_idx
  $swephsrc = './sweph';    //sweph MUST be in a folder no less than at this level
  $sweph = './sweph';

  unset($out,$t_long);
  exec ("swetest -edir$sweph -bj$jd -ut -p$p1_idx$p2_idx -eswe -fls -g, -head", $out);

  // Each line of output data from swetest is exploded into array $row, giving these elements:
  // 0 = longitude
  // 1 = speed
  foreach ($out as $key => $line)
  {
    $row = explode(',',$line);
    $t_long[$key] = $row[0];
    $t_speed[$key] = $row[1];
  };

  $result[0] = $t_long[0];    //planet 1
  $result[1] = $t_speed[0];
  $result[2] = $t_long[1];    //planet 2
  $result[3] = $t_speed[1];

  return $result;
}


Function ConvertJDtoDateandTime($Result_JD, $current_tz)
{
  //returns date and time in local time, e.g. 9/3/2007 4:59 am
  //get calendar day - must adjust for the way the PHP function works by adding 0.5 days to the JD of interest
  $jd_to_use = $Result_JD + $current_tz / 24;

  $JDDate = jdtogregorian($jd_to_use + 0.5);

  //$euro_date = Convert_date_to_European($JDDate);
  
  $fraction = $jd_to_use - floor($jd_to_use);

  if ($fraction < 0.5)
  {
    $am_pm = "pm";
  }
  else
  {
    $fraction = $fraction - 0.5;
    $am_pm = "am";
  }

  $hh = $fraction * 24;
  if ($hh < 1)
  {
    $hh = $hh + 12;
  }

  $mm = $hh - floor($hh);

  if (floor($mm * 60) < 10)
  {
    return date("m.d", strtotime($JDDate)) . " " . floor($hh) . ":0" . floor($mm * 60) . " " . $am_pm;
  }
  else
  {
    return date("m.d", strtotime($JDDate)) . " " . floor($hh) . ":" . floor($mm * 60) . " " . $am_pm;
  }
}


Function Convert_date_to_European($JDDate)
{
  $first_slash = strpos($JDDate, '/');
  $last_slash = strpos($JDDate, '/', $first_slash + 1);
  
  return sprintf("%02d", substr($JDDate, $first_slash + 1, $last_slash - $first_slash - 1)) . "/" . sprintf("%02d", substr($JDDate, 0, $first_slash)) . "/" . substr($JDDate, -4);
}

?>
