<?php
  session_start();

  include("horary_constants.php");
  include("../constants.php");

  require_once ('../../../mysqli_connect_online_calcs_db_MYSQLI.php');
  //require_once ('../../../my_functions_MYSQLI.php');
  
  $copyright1 = "This chart wheel is copyrighted";
  $copyright2 = "and generated at " . YOUR_URL;

  $line1 = safeEscapeString($conn, $_GET["l1"]);
  $line2 = safeEscapeString($conn, $_GET["l2"]);
  $line3 = safeEscapeString($conn, $_GET["l3"]);
  $line4 = safeEscapeString($conn, $_GET["l4"]);

  $retrograde = safeEscapeString($conn, $_GET["rx1"]);

  $extra_height_for_graphic_data_table = safeEscapeString($conn, $_GET["eh"]);
  $extra_height_for_30deg_line = safeEscapeString($conn, $_GET["eh30d"]);
  $extra_height_for_second_data_table = safeEscapeString($conn, $_GET["eh_pdt"]);

  $y_top_margin = safeEscapeString($conn, $_GET["ytm"]);

  $extra_width_for_graphic_data_table = safeEscapeString($conn, $_GET["ew"]);    //graphic is 792 pixels wide, total

  $longitude = $_SESSION['longitude1'];
  $speed = $_SESSION['speed1'];
  $declination = $_SESSION['declination1'];
  $hc = $_SESSION['hc1'];
  $house_pos = $_SESSION['house_pos1'];

  $longitude[LAST_PLANET + 1] = $hc[1];
  $longitude[LAST_PLANET + 2] = $hc[10];

  $Ascendant1 = $hc[1];
  $hc[13] = $hc[1];

// set the content-type
  header("Content-type: image/png");

// create the blank image
  $overall_size = 640;        //size of the wheel itself
  $im = @imagecreatetruecolor($overall_size + $extra_width_for_graphic_data_table, $overall_size + $y_top_margin + $extra_height_for_graphic_data_table + $extra_height_for_30deg_line + $extra_height_for_second_data_table) or die("Cannot initialize new GD image stream");

// specify the colors
  $black = imagecolorallocate($im, 0, 0, 0);
  $white = imagecolorallocate($im, 255, 255, 255);
  $red = imagecolorallocate($im, 255, 0, 0);
  $blue = imagecolorallocate($im, 0, 0, 255);
  $magenta = imagecolorallocate($im, 255, 0, 255);
  $light_yellow = imagecolorallocate($im, 255, 255, 232);
  $orange = imagecolorallocate($im, 255, 128, 64);
  $cyan = imagecolorallocate($im, 0, 255, 255);
  $green = imagecolorallocate($im, 0, 224, 0);
  $light_green = imagecolorallocate($im, 232, 255, 232);
  $another_green = imagecolorallocate($im, 0, 128, 0);
  $grey = imagecolorallocate($im, 142, 142, 142);
  $olive = imagecolorallocate($im, 204, 204, 109);
  $light_blue = imagecolorallocate($im, 240, 240, 255);
  $very_light_blue = imagecolorallocate($im, 217, 255, 255);
  $brown = imagecolorallocate($im, 148, 101, 77);
  $blue_2 = imagecolorallocate($im, 0, 0, 224);
  $green_2 = imagecolorallocate($im, 0, 192, 0);
  $grey_2 = imagecolorallocate($im, 153, 153, 153);
  $red_2 = imagecolorallocate($im, 224, 0, 0);
  $background_color = imagecolorallocate($im, 192, 208, 255);

  $asp_color_special[0] = $blue;
  $asp_color_special[1] = $green;
  $asp_color_special[2] = $red;
  $asp_color_special[3] = $green;
  $asp_color_special[4] = $cyan;
  $asp_color_special[5] = $red;

// specific colors
  $planet_color = $black;   //was $cyan;
  $deg_min_color = $black;    //$white;
  $sign_color = $magenta;

  $size_of_rect = $overall_size;    // size of rectangle in which to draw the wheel
  $diameter = 520;            // diameter of circle drawn
  $outer_outer_diameter = 600;      // diameter of circle drawn
  $outer_diameter_distance = ($outer_outer_diameter - $diameter) / 2; // distance between outer-outer diameter and diameter

  $inner_diameter_offset = 91;      // diameter of inner circle drawn
  $inner_diameter_offset_2 = 91;    // diameter of nextmost inner circle drawn
  $dist_from_diameter1 = 32;      // distance inner planet glyph is from circumference of wheel

  $radius = $diameter / 2;        // radius of circle drawn
  $middle_radius = ($outer_outer_diameter + $diameter) / 4 - 0;   //the radius for the middle of the two outer circles

  $center_pt_x = $extra_width_for_graphic_data_table - 10 + ($size_of_rect / 2) + 20;       // center of circle
  $center_pt_y = 5 + $y_top_margin + ($size_of_rect / 2);   // center of circle

  $last_planet_num = LAST_PLANET;       //add a planet
  $num_planets = $last_planet_num + 1;
  $spacing = 5;     // spacing between planet glyphs around wheel - this number is really one more than shown here

// ------------------------------------------

// create colored rectangle on blank image
  imagefilledrectangle($im, 0, 0, $size_of_rect + $extra_width_for_graphic_data_table, $size_of_rect + $y_top_margin + $extra_height_for_graphic_data_table + $extra_height_for_30deg_line + $extra_height_for_second_data_table, $background_color);

// MUST BE HERE - I DO NOT KNOW WHY - MAYBE TO PRIME THE PUMP
  imagettftext($im, 11, 0, 0, 0, $black, 'arial.ttf', " ");


// ------------------------------------------

// draw the outer-outer circle of the chartwheel
  imagefilledellipse($im, $center_pt_x, $center_pt_y, $outer_outer_diameter, $outer_outer_diameter, $white);
  imageellipse($im, $center_pt_x, $center_pt_y, $outer_outer_diameter, $outer_outer_diameter, $black);

// draw the outer circle of the chartwheel
  imagefilledellipse($im, $center_pt_x, $center_pt_y, $diameter, $diameter, $white);
  imageellipse($im, $center_pt_x, $center_pt_y, $diameter, $diameter, $grey); //was red


// draw the outer-outer border of the chartwheel
  imagefilledellipse($im, $center_pt_x, $center_pt_y, $diameter - ($inner_diameter_offset * 2) - 1, $diameter - ($inner_diameter_offset * 2) - 1, $light_green);  //13 Nov 2010


//shade the areas of complete signs, alternating colors - do not move this code from here
  for ($i = 0; $i <= 330; $i = $i + 30)
  {
    $angle = $i + sprintf("%.0f", $Ascendant1);

    if ($flag == True)
    {
      imagefilledarc($im, $center_pt_x, $center_pt_y, $diameter - ($inner_diameter_offset * 2) - 1, $diameter - ($inner_diameter_offset * 2) - 1, $angle, $angle + 30, $light_blue, IMG_ARC_PIE); //13 Nov 2010
    }
    else
    {
      imagefilledarc($im, $center_pt_x, $center_pt_y, $diameter - ($inner_diameter_offset * 2) - 1, $diameter - ($inner_diameter_offset * 2) - 1, $angle, $angle + 30, $light_blue, IMG_ARC_PIE); //13 Nov 2010
    }

    $flag = !$flag;
  }


// draw the inner circle of the chartwheel
  imagefilledellipse($im, $center_pt_x, $center_pt_y, $diameter - ($inner_diameter_offset * 2) - 40, $diameter - ($inner_diameter_offset * 2) - 40, $white);  //13 Nov 2010

  imageellipse($im, $center_pt_x, $center_pt_y, $diameter - ($inner_diameter_offset_2 * 2), $diameter - ($inner_diameter_offset_2 * 2), $black);
  imageellipse($im, $center_pt_x, $center_pt_y, $diameter - ($inner_diameter_offset_2 * 2) - 40, $diameter - ($inner_diameter_offset_2 * 2) - 40, $black);      //13 Nov 2010


// ------------------------------------------

//data for chart
  drawboldtext($im, 10, 0, 2, 10, $black, 'arial.ttf', $line1, 0);
  drawboldtext($im, 10, 0, 2, 26, $black, 'arial.ttf', $line2, 0);
  drawboldtext($im, 10, 0, 2, 42, $black, 'arial.ttf', $line3, 0);
  drawboldtext($im, 10, 0, 2, 58, $black, 'arial.ttf', $line4, 0);

  drawboldtext($im, 11, 0, 490, 12, $black, 'arial.ttf', $copyright1, 0);
  drawboldtext($im, 11, 0, 490, 28, $black, 'arial.ttf', $copyright2, 0);

  imageline($im, 0, 64, $overall_size + $extra_width_for_graphic_data_table, 64, $olive);   //border

// ------------------------------------------

//draw the horizontal line for the Ascendant
  $x1 = -($radius - $inner_diameter_offset) * cos(deg2rad(0));
  $y1 = -($radius - $inner_diameter_offset) * sin(deg2rad(0));

  $x2 = -$radius * cos(deg2rad(0));
  $y2 = -$radius * sin(deg2rad(0));

  imageline($im, $x1 + $center_pt_x, $y1 + $center_pt_y, $x2 + $center_pt_x, $y2 + $center_pt_y, $black);

//draw the arrow for the Ascendant
  $x1 = -$radius;
  $y1 = 30 * sin(deg2rad(0));

  $x2 = -($radius - 12);
  $y2 = 12 * sin(deg2rad(-15));
  imageline($im, $x1 + $center_pt_x, $y1 + $center_pt_y, $x2 + $center_pt_x, $y2 + $center_pt_y, $black);

  $y2 = 12 * sin(deg2rad(15));
  imageline($im, $x1 + $center_pt_x, $y1 + $center_pt_y, $x2 + $center_pt_x, $y2 + $center_pt_y, $black);

// ------------------------------------------

// draw in the actual house cusp numbers and sign
  for ($i = 1; $i <= 12; $i = $i + 1)
  {
    $angle = -($Ascendant1 - $hc[$i]);

    $sign_pos = floor($hc[$i] / 30) + 1;
    if ($sign_pos == 1 Or $sign_pos == 5 Or $sign_pos == 9)
    {
      $clr_to_use = $red;
    }
    elseif ($sign_pos == 2 Or $sign_pos == 6 Or $sign_pos == 10)
    {
      $clr_to_use = $another_green;
    }
    elseif ($sign_pos == 3 Or $sign_pos == 7 Or $sign_pos == 11)
    {
      $clr_to_use = $orange;
    }
    elseif ($sign_pos == 4 Or $sign_pos == 8 Or $sign_pos == 12)
    {
      $clr_to_use = $blue;
    }

    // sign glyph
    display_house_cusp($i, $angle, $middle_radius, $xy);
    //imagettftext($im, 10, 0, $xy[0] + $center_pt_x, $xy[1] + $center_pt_y, $clr_to_use, 'HamburgSymbols.ttf', chr($sign_glyph[$sign_pos]));
    imagettftext($im, 16, 0, $xy[0] + $center_pt_x, $xy[1] + $center_pt_y, $clr_to_use, 'HamburgSymbols.ttf', chr($sign_glyph[$sign_pos])); //was 14

    if ($i >= 1 And $i <= 6)
    {
      //display_house_cusp($i, $angle - 4, $middle_radius, $xy);
      display_house_cusp($i, $angle - 5, $middle_radius, $xy);
    }
    else
    {
      //display_house_cusp($i, $angle + 5, $middle_radius, $xy);
      display_house_cusp($i, $angle + 6, $middle_radius, $xy);
    }

    $reduced_pos = Reduce_below_30($hc[$i]);
    $int_reduced_pos = floor($reduced_pos);
    if ($int_reduced_pos < 10)
    {
      $t = "0" . $int_reduced_pos;
    }
    else
    {
      $t = $int_reduced_pos;
    }

    imagettftext($im, 10, 0, $xy[0] + $center_pt_x, $xy[1] + $center_pt_y, $black, 'arial.ttf', $t . chr(176)); //was 8

    // house cusp minute
    if ($i >= 1 And $i <= 4)
    {
      //display_house_cusp($i, $angle + 4, $middle_radius, $xy);
      display_house_cusp($i, $angle + 5, $middle_radius, $xy);
    }
    elseif ($i == 5 Or $i == 6)
    {
      //display_house_cusp($i, $angle + 5, $middle_radius, $xy);
      display_house_cusp($i, $angle + 6, $middle_radius, $xy);
    }
    elseif ($i == 7)
    {
      //display_house_cusp($i, $angle - 4, $middle_radius, $xy);
      display_house_cusp($i, $angle - 5, $middle_radius, $xy);
    }
    else
    {
      //display_house_cusp($i, $angle - 5, $middle_radius, $xy);
      display_house_cusp($i, $angle - 6, $middle_radius, $xy);
    }

    $reduced_pos = Reduce_below_30($hc[$i]);
    $int_reduced_pos = floor(60 * ($reduced_pos - floor($reduced_pos)));
    if ($int_reduced_pos < 10)
    {
      $t = "0" . $int_reduced_pos;
    }
    else
    {
      $t = $int_reduced_pos;
    }
    imagettftext($im, 9, 0, $xy[0] + $center_pt_x, $xy[1] + $center_pt_y, $black, 'arial.ttf', $t . " " . chr(39)); //was 8
  }

// ------------------------------------------

// draw the lines for the house cusps
  for ($i = 1; $i <= 12; $i = $i + 1)
  {

    $angle = $Ascendant1 - $hc[$i];

//if ($i == 11) { imagettftext($im, 11, 0, 5, 100, $another_green, 'arial.ttf', $angle); }
//if ($i == 12) { imagettftext($im, 11, 0, 5, 115, $another_green, 'arial.ttf', $angle); }

    $x1 = -$radius * cos(deg2rad($angle));
    $y1 = -$radius * sin(deg2rad($angle));

    $x2 = -($radius - $inner_diameter_offset) * cos(deg2rad($angle));
    $y2 = -($radius - $inner_diameter_offset) * sin(deg2rad($angle));

    if ($i != 1 And $i != 10)
    {
      imageline($im, $x1 + $center_pt_x, $y1 + $center_pt_y, $x2 + $center_pt_x, $y2 + $center_pt_y, $another_green);
    }

    // display the house numbers themselves - 26 March 2010
    $angle_diff = $hc[$i + 1] - $hc[$i];
    if ($angle_diff < -180) { $angle_diff = $angle_diff + 360; }

    $angle_to_use = $angle_sum + ($angle_diff / 2);

    //display_house_number_new($i, $angle_to_use, $radius - $inner_diameter_offset, $xy);
    display_house_number_new($i, $angle_to_use, $radius, $xy);

    // display the house numbers themselves
    imagettftext($im, 11, 0, $xy[0] + $center_pt_x, $xy[1] + $center_pt_y, $another_green, 'arial.ttf', $i); //was 8

    $angle_sum = $angle_sum + $angle_diff;    //26 March 2010
  }

// ------------------------------------------

// draw the little degree marks around of the wheel
  $spoke_length = 9;
  $minor_spoke_length = 4;

  for ($i = 0; $i <= 359; $i = $i + 1)
  {
    $angle = $i + $Ascendant1;

    $x1 = -$radius * cos(deg2rad($angle));
    $y1 = -$radius * sin(deg2rad($angle));

    if ($i % 5 == 0)
    {
      $x2 = -($radius - $spoke_length) * cos(deg2rad($angle));
      $y2 = -($radius - $spoke_length) * sin(deg2rad($angle));
      imageline($im, $x1 + $center_pt_x, $y1 + $center_pt_y, $x2 + $center_pt_x, $y2 + $center_pt_y, $red);
    }
    else
    {
      $x2 = -($radius - $minor_spoke_length) * cos(deg2rad($angle));
      $y2 = -($radius - $minor_spoke_length) * sin(deg2rad($angle));
      imageline($im, $x1 + $center_pt_x, $y1 + $center_pt_y, $x2 + $center_pt_x, $y2 + $center_pt_y, $black);
    }
  }


// ------------------------------------------



// draw the near-vertical line for the MC
  $angle = $Ascendant1 - $hc[10];
  $dist_mc_asc = $angle;

  if ($dist_mc_asc < 0)
  {
    $dist_mc_asc = $dist_mc_asc + 360;
  }

  $value = 90 - $dist_mc_asc;
  $angle1 = 65 - $value;
  $angle2 = 65 + $value;

  $x1 = -($radius - $inner_diameter_offset) * cos(deg2rad($angle));
  $y1 = -($radius - $inner_diameter_offset) * sin(deg2rad($angle));

  $x2 = -$radius * cos(deg2rad($angle));
  $y2 = -$radius * sin(deg2rad($angle));

  imageline($im, $x1 + $center_pt_x, $y1 + $center_pt_y, $x2 + $center_pt_x, $y2 + $center_pt_y, $black);

// draw the arrow for the 10th house cusp (MC)
  $x1 = $x2 + (15 * cos(deg2rad($angle1)));
  $y1 = $y2 + (15 * sin(deg2rad($angle1)));
  imageline($im, $x1 + $center_pt_x, $y1 + $center_pt_y, $x2 + $center_pt_x, $y2 + $center_pt_y, $black);

  $x1 = $x2 - (15 * cos(deg2rad($angle2)));
  $y1 = $y2 + (15 * sin(deg2rad($angle2)));
  imageline($im, $x1 + $center_pt_x, $y1 + $center_pt_y, $x2 + $center_pt_x, $y2 + $center_pt_y, $black);

// ------------------------------------------


// draw the dividing lines between the signs
  for ($i = 0; $i <= 330; $i = $i + 30)
  {
    $angle = $i + sprintf("%.0f", $Ascendant1);

    $x1 = -(150) * cos(deg2rad($angle));    //13 Nov 2010 - was 320
    $y1 = -(150) * sin(deg2rad($angle));

    $x2 = -(168) * cos(deg2rad($angle));    //13 Nov 2010 - was 300
    $y2 = -(168) * sin(deg2rad($angle));

    imageline($im, $x1 + $center_pt_x, $y1 + $center_pt_y, $x2 + $center_pt_x, $y2 + $center_pt_y, $red);
  }


// put signs around chartwheel
  $cw_sign_glyph = 14;
  $ch_sign_glyph = 12;
  $gap_sign_glyph = -44;

  for ($i = 1; $i <= 12; $i++)
  {
    $angle_to_use = deg2rad((($i - 1) * 30) + 15 - $Ascendant1);

    $center_pos_x = -$cw_sign_glyph / 2;
    $center_pos_y = $ch_sign_glyph / 2;

    $offset_pos_x = $center_pos_x * cos($angle_to_use);
    $offset_pos_y = $center_pos_y * sin($angle_to_use);

    $x1 = $center_pos_x + $offset_pos_x + ((-108 + $gap_sign_glyph) * cos($angle_to_use));    //13 Nov 2010 - was 260 instead of 108
    $y1 = $center_pos_y + $offset_pos_y + ((108 - $gap_sign_glyph) * sin($angle_to_use));

    if ($i == 1 Or $i == 5 Or $i == 9)
    {
      $clr_to_use = $red;
    }
    elseif ($i == 2 Or $i == 6 Or $i == 10)
    {
      $clr_to_use = $another_green;
    }
    elseif ($i == 3 Or $i == 7 Or $i == 11)
    {
      $clr_to_use = $orange;
    }
    elseif ($i == 4 Or $i == 8 Or $i == 12)
    {
      $clr_to_use = $blue;
    }

    drawboldtext($im, 10, 0, $x1 + $center_pt_x, $y1 + $center_pt_y, $clr_to_use, 'HamburgSymbols.ttf', chr($sign_glyph[$i]), 0); //used to be boldness of 1 - last number
  }

// ------------------------------------------

// put planets in chartwheel
  // sort longitudes in descending order from 360 down to 0
  Sort_planets_by_descending_longitude($num_planets, $longitude, $sort, $sort_pos);

  // count how many planets are in each house
  Count_planets_in_each_house($num_planets, $house_pos, $sort_pos, $sort, $nopih, $home);

  //find the best planet to start displaying the wheel and reorder the $sort[] array starting with that planet
  Find_best_planet_to_start_with($num_planets, $house_pos, $sort_pos, $sort, $nopih);


  for ($i = 0; $i <= 359; $i++) { $spot_filled[$i] = 0; }

  $house_num = 0;

  // add planet glyphs around circle
  for ($i = $num_planets - 1; $i >= 0; $i--)
  {
    // $sort() holds longitudes in descending order from 360 down to 0
    // $sort_pos() holds the planet number corresponding to that longitude
    $temp = $house_num;
    $house_num = $house_pos[$sort_pos[$i]];              // get the house this planet is in

    if ($temp != $house_num)
    {
      // this planet is in a different house than the last one - this planet is the first one in this house, in other words
      $planets_done = 1;
    }

    // get index for this planet as to where it should be in the possible xx different positions around the wheel
    $from_cusp = Crunch($sort[$i] - $hc[$house_num]);
    $to_next_cusp = Crunch($hc[$house_num + 1] - $sort[$i]);
    $next_cusp = $hc[$house_num + 1];

    $angle = $sort[$i];
    $how_many_more_can_fit_in_this_house = floor($to_next_cusp / ($spacing + 1));

    //if ($nopih[$house_num] - $planets_done > $how_many_more_can_fit_in_this_house)
    if ($nopih[$house_num] - $planets_done >= $how_many_more_can_fit_in_this_house)
    {
      // problem - adjust this planet backwards so others can fit
      $angle = Crunch($next_cusp - (($nopih[$house_num] - $planets_done + 1) * ($spacing + 1)));
    }

    while (Check_for_overlap($angle, $spot_filled, $spacing) == True)
    {
      $angle = $angle + 1;
    }

    // mark this position as being filled
    $spot_filled[round($angle)] = 1;
    $spot_filled[Crunch(round($angle) - 1)] = 1;  // allows for a little better separation between Mars and Sun on 3/13/1966 test example

    // take the above index and convert it into an angle
    $planet_angle[$sort_pos[$i]] = $angle;              // needed for aspect lines
    $angle_to_use = Crunch($angle - $Ascendant1);       // needed for placing info on chartwheel
    $our_angle = $angle_to_use;                     // in degrees

    $angle_to_use = deg2rad($angle_to_use);

    // denote that we have done at least one planet in this house (actually count the planets in this house that we have done)
    $planets_done++;

    display_planet_glyph($our_angle, $angle_to_use, $radius - $dist_from_diameter1, $xy, 0);
    imagettftext($im, 16, 0, $xy[0] + $center_pt_x, $xy[1] + $center_pt_y, $planet_color, 'HamburgSymbols.ttf', chr($pl_glyph[$sort_pos[$i]])); //was 14

    // display degrees of longitude for each planet
    $reduced_pos = Reduce_below_30($sort[$i]);
    $int_reduced_pos = floor($reduced_pos);
    if ($int_reduced_pos < 10)
    {
      $t = "0" . $int_reduced_pos;
    }
    else
    {
      $t = $int_reduced_pos;
    }

    display_planet_glyph($our_angle, $angle_to_use, $radius - $dist_from_diameter1 - 18, $xy, 1);
    imagettftext($im, 9, 0, $xy[0] + $center_pt_x, $xy[1] + $center_pt_y, $planet_color, 'arial.ttf', $t . chr(176));

    // display planet sign
    $sign_pos = floor($sort[$i] / 30) + 1;
    display_planet_glyph($our_angle, $angle_to_use, $radius - $dist_from_diameter1 - 34, $xy, 2);
    if ($sign_pos == 1 Or $sign_pos == 5 Or $sign_pos == 9)
    {
      $clr_to_use = $red;
    }
    elseif ($sign_pos == 2 Or $sign_pos == 6 Or $sign_pos == 10)
    {
      $clr_to_use = $another_green;
    }
    elseif ($sign_pos == 3 Or $sign_pos == 7 Or $sign_pos == 11)
    {
      $clr_to_use = $orange;
    }
    elseif ($sign_pos == 4 Or $sign_pos == 8 Or $sign_pos == 12)
    {
      $clr_to_use = $blue;
    }
    imagettftext($im, 9, 0, $xy[0] + $center_pt_x, $xy[1] + $center_pt_y, $clr_to_use, 'HamburgSymbols.ttf', chr($sign_glyph[$sign_pos]));

    // display minutes of longitude for each planet
    $int_reduced_pos = floor(60 * ($reduced_pos - floor($reduced_pos)));
    if ($int_reduced_pos < 10)
    {
      $t = "0" . $int_reduced_pos;
    }
    else
    {
      $t = $int_reduced_pos;
    }
    display_planet_glyph($our_angle, $angle_to_use, $radius - $dist_from_diameter1 - 52, $xy, 1);
    //imagettftext($im, 8, 0, $xy[0] + $center_pt_x, $xy[1] + $center_pt_y, $planet_color, 'arial.ttf', $t . " " . chr(39));
    imagettftext($im, 9, 0, $xy[0] + $center_pt_x, $xy[1] + $center_pt_y, $planet_color, 'arial.ttf', $t);

    // display Rx symbol
    if ($retrograde[$sort_pos[$i]] == "R")
    {
      display_planet_glyph($our_angle, $angle_to_use, $radius - $dist_from_diameter1 - 65, $xy, 3);
      imagettftext($im, 8, 0, $xy[0] + $center_pt_x, $xy[1] + $center_pt_y, $red, 'HamburgSymbols.ttf', chr(62));
    }
  }

// ------------------------------------------


// draw in the aspect lines
  for ($i = 0; $i <= $last_planet_num - 1; $i++)
  {
    for ($j = $i + 1; $j <= $last_planet_num; $j++)
    {
      $this_is_special_body = False;

      if ($sort_pos[$i] == SE_POF Or $sort_pos[$j] == SE_POF)
      {
        $orb = ASPECT_ORB_SE_POF;
        $this_is_special_body = True;   //so do not use a different orb for any aspect
      }
      elseif ($sort_pos[$i] == SE_TNNODE Or $sort_pos[$j] == SE_TNNODE Or $sort_pos[$i] == SE_TSNODE Or $sort_pos[$j] == SE_TSNODE)
      {
        $orb = ASPECT_ORB_SE_SE_NODES;
        $this_is_special_body = True;   //so do not use a different orb for any aspect
      }

      $q = -99;
      $da = abs($longitude[$sort_pos[$i]] - $longitude[$sort_pos[$j]]);

      // is there an aspect within orb?
      for ($k = 0; $k <= NUM_ASPECTS_SPECIAL - 1; $k++)
      {
        if ($this_is_special_body == False)
        {
          if ($k == 0 Or $k == 2 Or $k == 3 Or $k == 5)     //look for major aspects
          {
            if ($sort_pos[$i] == SE_SUN Or $sort_pos[$i] == SE_MOON Or $sort_pos[$j] == SE_SUN Or $sort_pos[$j] == SE_MOON)
            {
              $orb = ASPECT_ORB_MAJOR_LIGHTS;
            }
            else
            {
              $orb = ASPECT_ORB_MAJOR;
            }
          }
          elseif ($k == 1 Or $k == 4 Or $k >= START_OF_MINOR_ASPECTS)
          {
            $orb = $asp_orb_value[$k];      // look for sextiles and quincunxes as non-MAJOR aspects as well as all minor aspects   was MINOR_ASPECT_ORB;
          }
          else
          {
            $orb = 3;     //catch-all
          }
        }

        if ((($da <= $exact_aspect_special[$k] + $orb) And ($da >= $exact_aspect_special[$k] - $orb)) Or (($da <= 360 - $exact_aspect_special[$k] + $orb) And ($da >= 360 - $exact_aspect_special[$k] - $orb)))
        {
          $q = $k;
          break;
        }
      }

      if ($q >= 0)
      {
        if ($q != 0 And $sort_pos[$i] != SE_POF And $sort_pos[$j] != SE_POF)
        {
          //non-conjunctions
          //$x1 = (-$radius + $inner_diameter_offset) * cos(deg2rad($planet_angle[$sort_pos[$i]] - $Ascendant1));
          //$y1 = ($radius - $inner_diameter_offset) * sin(deg2rad($planet_angle[$sort_pos[$i]] - $Ascendant1));
          //$x2 = (-$radius + $inner_diameter_offset) * cos(deg2rad($planet_angle[$sort_pos[$j]] - $Ascendant1));
          //$y2 = ($radius - $inner_diameter_offset) * sin(deg2rad($planet_angle[$sort_pos[$j]] - $Ascendant1));

          $x1 = (-$radius + 111) * cos(deg2rad($planet_angle[$sort_pos[$i]] - $Ascendant1));      //13 Nov 2010 - the 111 was 91 previously, as per above
          $y1 = ($radius - 111) * sin(deg2rad($planet_angle[$sort_pos[$i]] - $Ascendant1));
          $x2 = (-$radius + 111) * cos(deg2rad($planet_angle[$sort_pos[$j]] - $Ascendant1));
          $y2 = ($radius - 111) * sin(deg2rad($planet_angle[$sort_pos[$j]] - $Ascendant1));

          //set image style
          if ($k >= START_OF_MINOR_ASPECTS)
          {
            $style = array($asp_color_special[$q], $asp_color_special[$q], $asp_color_special[$q], $white, $white, $white, $asp_color_special[$q], $asp_color_special[$q], $asp_color_special[$q], $white, $white, $white);
      }
      else
      {
        $style = array($asp_color_special[$q], $asp_color_special[$q], $asp_color_special[$q], $asp_color_special[$q]);
      }

          imagesetstyle($im, $style);
          imageline($im, $x1 + $center_pt_x, $y1 + $center_pt_y, $x2 + $center_pt_x, $y2 + $center_pt_y, IMG_COLOR_STYLED);

          //draw in aspect glyph
          drawboldtext($im, 15, 0, (($x1 + $x2) / 2) - 7 + $center_pt_x, (($y1 + $y2) / 2) + 7 + $center_pt_y, $asp_color_special[$q], 'HamburgSymbols.ttf', chr($asp_glyph_special[$q]), 0); //thicker
        }
      }
    }
  }





//start of planet listing - list all horary data
  $left_margin = 6;
  $top_of_planet_listing = $y_top_margin + 650;

  $y_spacing = 20;
  $cnt = 0;

  imageline($im, $left_margin, $top_of_planet_listing, $overall_size + $extra_width_for_graphic_data_table - $left_margin, $top_of_planet_listing, $black);       //horizontal line above table - was $olive
  imageline($im, $left_margin, $top_of_planet_listing, $left_margin, $top_of_planet_listing + $extra_height_for_graphic_data_table - 30, $black);   //left side line
  imageline($im, $overall_size + $extra_width_for_graphic_data_table - $left_margin, $top_of_planet_listing, $overall_size + $extra_width_for_graphic_data_table - $left_margin, $top_of_planet_listing + $extra_height_for_graphic_data_table - 30, $black);   //right side line
  imageline($im, $left_margin, $top_of_planet_listing + $extra_height_for_graphic_data_table - 30, $overall_size + $extra_width_for_graphic_data_table - $left_margin, $top_of_planet_listing + $extra_height_for_graphic_data_table - 30, $black);   //horizontal line below table

  imageline($im, $left_margin, $top_of_planet_listing + 24, $overall_size + $extra_width_for_graphic_data_table - $left_margin, $top_of_planet_listing + 24, $black);   //horizontal line under the headings

//display header line
  $top_of_planet_listing = $y_top_margin + 20 + 650;
  imagettftext($im, 9, 0, $left_margin + 22, $top_of_planet_listing + ($cnt * $y_spacing) - 3, $blue, 'arial.ttf', "Longitude    Ruler     Exlt      Trip     Term    Face      Detr     Fall        Scr    Ori         Antiscia       Contra        Declination   Velocity       Spd    Peregr.");


  $top_of_planet_listing = $y_top_margin + 40 + 650;

  $pps = array();

  $peregrine = array();

  for ($i = 0; $i <= $last_planet_num; $i++)
  {
    $peregrine[$i] = 1;
  }

  for ($i = 0; $i <= $last_planet_num; $i++)
  {
    $sign_pos = floor($longitude[$i] / 30) + 1;
    if ($sign_pos == 1 Or $sign_pos == 5 Or $sign_pos == 9)
    {
      $clr_to_use = $red;
    }
    elseif ($sign_pos == 2 Or $sign_pos == 6 Or $sign_pos == 10)
    {
      $clr_to_use = $another_green;
    }
    elseif ($sign_pos == 3 Or $sign_pos == 7 Or $sign_pos == 11)
    {
      $clr_to_use = $orange;
    }
    elseif ($sign_pos == 4 Or $sign_pos == 8 Or $sign_pos == 12)
    {
      $clr_to_use = $blue;
    }

//display table of planet positions, etc.
    drawboldtext($im, 14, 0, $left_margin + 3, $top_of_planet_listing + ($cnt * $y_spacing), $black, 'HamburgSymbols.ttf', chr($pl_glyph[$i]), 0);                  //draw planet glyph


    // display planet data in the right-hand table
    imagettftext($im, 10, 0, $left_margin + 25, $top_of_planet_listing + ($cnt * $y_spacing), $black, 'arial.ttf', Convert_Longitude1($longitude[$i]));           //display longitude degrees
    imagettftext($im, 12, 0, $left_margin + 42, $top_of_planet_listing + ($cnt * $y_spacing), $clr_to_use, 'HamburgSymbols.ttf', chr($sign_glyph[$sign_pos]));            //display sign
    imagettftext($im, 10, 0, $left_margin + 58, $top_of_planet_listing + ($cnt * $y_spacing), $black, 'arial.ttf', Convert_Longitude2($longitude[$i]) . $retrograde[$i]);   //display longitude minutes and Rx


//find ruler of this planet's sign
  if ($sign_pos == 1 Or $sign_pos == 8)
  {
    $ruler = SE_MARS;
  }
  elseif ($sign_pos == 2 Or $sign_pos == 7)
  {
    $ruler = SE_VENUS;
  }
  elseif ($sign_pos == 3 Or $sign_pos == 6)
  {
    $ruler = SE_MERCURY;
  }
  elseif ($sign_pos == 4)
  {
    $ruler = SE_MOON;
  }
  elseif ($sign_pos == 5)
  {
    $ruler = SE_SUN;
  }
  elseif ($sign_pos == 9 Or $sign_pos == 12)
  {
    $ruler = SE_JUPITER;
  }
  elseif ($sign_pos == 10 Or $sign_pos == 11)
  {
    $ruler = SE_SATURN;
  }

    drawboldtext($im, 14, 0, $left_margin + 95, $top_of_planet_listing + ($cnt * $y_spacing), $black, 'HamburgSymbols.ttf', chr($pl_glyph[$ruler]), 0);                 //draw planet glyph
    if ($i == $ruler)
    {
      imagettftext($im, 10, 0, $left_margin + 110, $top_of_planet_listing + ($cnt * $y_spacing), $black, 'arial.ttf', "+");                             //mark a "+"
      $peregrine[$i] = 0;
    }


//find exaltation of this planet's sign
  $exalt = -1;

  if ($sign_pos == 1)
  {
    $exalt = SE_SUN;
  }
  elseif ($sign_pos == 2)
  {
    $exalt = SE_MOON;
  }
  elseif ($sign_pos == 4)
  {
    $exalt = SE_JUPITER;
  }
  elseif ($sign_pos == 6)
  {
    $exalt = SE_MERCURY;
  }
  elseif ($sign_pos == 7)
  {
    $exalt = SE_SATURN;
  }
  elseif ($sign_pos == 10)
  {
    $exalt = SE_MARS;
  }
  elseif ($sign_pos == 12)
  {
    $exalt = SE_VENUS;
  }

    if ($exalt >= 0) { drawboldtext($im, 14, 0, $left_margin + 135, $top_of_planet_listing + ($cnt * $y_spacing), $black, 'HamburgSymbols.ttf', chr($pl_glyph[$exalt]), 0); }     //draw planet glyph

    if ($i == $exalt)
    {
      imagettftext($im, 10, 0, $left_margin + 150, $top_of_planet_listing + ($cnt * $y_spacing), $black, 'arial.ttf', "+");                             //mark a "+"
      $peregrine[$i] = 0;
    }


//find triplicity of this planet's sign
  if ($house_pos[SE_SUN] < 7)
  {
    //night chart
    if ($sign_pos == 1 Or $sign_pos == 5 Or $sign_pos == 9)
    {
      $triplicity = SE_JUPITER;
    }
    elseif ($sign_pos == 2 Or $sign_pos == 6 Or $sign_pos == 10)
    {
      $triplicity = SE_MOON;
    }
    elseif ($sign_pos == 3 Or $sign_pos == 7 Or $sign_pos == 11)
    {
      $triplicity = SE_MERCURY;
    }
    elseif ($sign_pos == 4 Or $sign_pos == 8 Or $sign_pos == 12)
    {
      $triplicity = SE_MARS;
    }
    }
    else
    {
      //day chart
    if ($sign_pos == 1 Or $sign_pos == 5 Or $sign_pos == 9)
    {
      $triplicity = SE_SUN;
    }
    elseif ($sign_pos == 2 Or $sign_pos == 6 Or $sign_pos == 10)
    {
      $triplicity = SE_VENUS;
    }
    elseif ($sign_pos == 3 Or $sign_pos == 7 Or $sign_pos == 11)
    {
      $triplicity = SE_SATURN;
    }
    elseif ($sign_pos == 4 Or $sign_pos == 8 Or $sign_pos == 12)
    {
      $triplicity = SE_MARS;
    }
    }

    drawboldtext($im, 12, 0, $left_margin + 175, $top_of_planet_listing + ($cnt * $y_spacing), $black, 'HamburgSymbols.ttf', chr($pl_glyph[$triplicity]), 0);               //draw planet glyph
    if ($i == $triplicity)
    {
      imagettftext($im, 8, 0, $left_margin + 190, $top_of_planet_listing + ($cnt * $y_spacing), $black, 'arial.ttf', "+");                              //mark a "+"
      $peregrine[$i] = 0;
    }


//find term of this planet's sign
  if ($longitude[$i] >= 0 And $longitude[$i] < 6) { $term = SE_JUPITER; }
  if ($longitude[$i] >= 6 And $longitude[$i] < 14) { $term = SE_VENUS; }
  if ($longitude[$i] >= 14 And $longitude[$i] < 21) { $term = SE_MERCURY; }
  if ($longitude[$i] >= 21 And $longitude[$i] < 26) { $term = SE_MARS; }
  if ($longitude[$i] >= 26 And $longitude[$i] < 30) { $term = SE_SATURN; }
  if ($longitude[$i] >= 30 And $longitude[$i] < 38) { $term = SE_VENUS; }
  if ($longitude[$i] >= 38 And $longitude[$i] < 45) { $term = SE_MERCURY; }
  if ($longitude[$i] >= 45 And $longitude[$i] < 52) { $term = SE_JUPITER; }
  if ($longitude[$i] >= 52 And $longitude[$i] < 56) { $term = SE_SATURN; }
  if ($longitude[$i] >= 56 And $longitude[$i] < 60) { $term = SE_MARS; }
  if ($longitude[$i] >= 60 And $longitude[$i] < 67) { $term = SE_MERCURY; }
  if ($longitude[$i] >= 67 And $longitude[$i] < 74) { $term = SE_JUPITER; }
  if ($longitude[$i] >= 74 And $longitude[$i] < 81) { $term = SE_VENUS; }
  if ($longitude[$i] >= 81 And $longitude[$i] < 85) { $term = SE_SATURN; }
  if ($longitude[$i] >= 85 And $longitude[$i] < 90) { $term = SE_MARS; }
  if ($longitude[$i] >= 90 And $longitude[$i] < 96) { $term = SE_MARS; }
  if ($longitude[$i] >= 96 And $longitude[$i] < 103) { $term = SE_JUPITER; }
  if ($longitude[$i] >= 103 And $longitude[$i] < 110) { $term = SE_MERCURY; }
  if ($longitude[$i] >= 110 And $longitude[$i] < 117) { $term = SE_VENUS; }
  if ($longitude[$i] >= 117 And $longitude[$i] < 120) { $term = SE_SATURN; }
  if ($longitude[$i] >= 120 And $longitude[$i] < 126) { $term = SE_SATURN; }
  if ($longitude[$i] >= 126 And $longitude[$i] < 133) { $term = SE_MERCURY; }
  if ($longitude[$i] >= 133 And $longitude[$i] < 139) { $term = SE_VENUS; }
  if ($longitude[$i] >= 139 And $longitude[$i] < 145) { $term = SE_JUPITER; }
  if ($longitude[$i] >= 145 And $longitude[$i] < 150) { $term = SE_MARS; }
  if ($longitude[$i] >= 150 And $longitude[$i] < 157) { $term = SE_MERCURY; }
  if ($longitude[$i] >= 157 And $longitude[$i] < 163) { $term = SE_VENUS; }
  if ($longitude[$i] >= 163 And $longitude[$i] < 168) { $term = SE_JUPITER; }
  if ($longitude[$i] >= 168 And $longitude[$i] < 174) { $term = SE_SATURN; }
  if ($longitude[$i] >= 174 And $longitude[$i] < 180) { $term = SE_MARS; }
  if ($longitude[$i] >= 180 And $longitude[$i] < 186) { $term = SE_SATURN; }
  if ($longitude[$i] >= 186 And $longitude[$i] < 191) { $term = SE_VENUS; }
  if ($longitude[$i] >= 191 And $longitude[$i] < 199) { $term = SE_JUPITER; }
  if ($longitude[$i] >= 199 And $longitude[$i] < 204) { $term = SE_MERCURY; }
  if ($longitude[$i] >= 204 And $longitude[$i] < 210) { $term = SE_MARS; }
  if ($longitude[$i] >= 210 And $longitude[$i] < 216) { $term = SE_MARS; }
  if ($longitude[$i] >= 216 And $longitude[$i] < 224) { $term = SE_JUPITER; }
  if ($longitude[$i] >= 224 And $longitude[$i] < 231) { $term = SE_VENUS; }
  if ($longitude[$i] >= 231 And $longitude[$i] < 237) { $term = SE_MERCURY; }
  if ($longitude[$i] >= 237 And $longitude[$i] < 240) { $term = SE_SATURN; }
  if ($longitude[$i] >= 240 And $longitude[$i] < 248) { $term = SE_JUPITER; }
  if ($longitude[$i] >= 248 And $longitude[$i] < 254) { $term = SE_VENUS; }
  if ($longitude[$i] >= 254 And $longitude[$i] < 259) { $term = SE_MERCURY; }
  if ($longitude[$i] >= 259 And $longitude[$i] < 265) { $term = SE_SATURN; }
  if ($longitude[$i] >= 265 And $longitude[$i] < 270) { $term = SE_MARS; }
  if ($longitude[$i] >= 270 And $longitude[$i] < 276) { $term = SE_VENUS; }
  if ($longitude[$i] >= 276 And $longitude[$i] < 282) { $term = SE_MERCURY; }
  if ($longitude[$i] >= 282 And $longitude[$i] < 289) { $term = SE_JUPITER; }
  if ($longitude[$i] >= 289 And $longitude[$i] < 295) { $term = SE_MARS; }
  if ($longitude[$i] >= 295 And $longitude[$i] < 300) { $term = SE_SATURN; }
  if ($longitude[$i] >= 300 And $longitude[$i] < 306) { $term = SE_SATURN; }
  if ($longitude[$i] >= 306 And $longitude[$i] < 312) { $term = SE_MERCURY; }
  if ($longitude[$i] >= 312 And $longitude[$i] < 320) { $term = SE_VENUS; }
  if ($longitude[$i] >= 320 And $longitude[$i] < 325) { $term = SE_JUPITER; }
  if ($longitude[$i] >= 325 And $longitude[$i] < 330) { $term = SE_MARS; }
  if ($longitude[$i] >= 330 And $longitude[$i] < 338) { $term = SE_VENUS; }
  if ($longitude[$i] >= 338 And $longitude[$i] < 344) { $term = SE_JUPITER; }
  if ($longitude[$i] >= 344 And $longitude[$i] < 350) { $term = SE_MERCURY; }
  if ($longitude[$i] >= 350 And $longitude[$i] < 356) { $term = SE_MARS; }
  if ($longitude[$i] >= 356 And $longitude[$i] < 360) { $term = SE_SATURN; }

    drawboldtext($im, 12, 0, $left_margin + 215, $top_of_planet_listing + ($cnt * $y_spacing), $black, 'HamburgSymbols.ttf', chr($pl_glyph[$term]), 0);                 //draw planet glyph
    if ($i == $term)
    {
      imagettftext($im, 8, 0, $left_margin + 230, $top_of_planet_listing + ($cnt * $y_spacing), $black, 'arial.ttf', "+");                              //mark a "+"
      $peregrine[$i] = 0;
    }


//find face of this planet's sign
  $t = $longitude[$i];

    while ($t >= 70)
    {
      $t = $t - 70;
    }

  if ($t >= 0 And $t < 10)
  {
    $face = SE_MARS;
  }
  elseif ($t >= 10 And $t < 20)
  {
    $face = SE_SUN;
  }
  elseif ($t >= 20 And $t < 30)
  {
    $face = SE_VENUS;
  }
  elseif ($t >= 30 And $t < 40)
  {
    $face = SE_MERCURY;
  }
  elseif ($t >= 40 And $t < 50)
  {
    $face = SE_MOON;
  }
  elseif ($t >= 50 And $t < 60)
  {
    $face = SE_SATURN;
  }
  elseif ($t >= 60 And $t < 70)
  {
    $face = SE_JUPITER;
  }

    drawboldtext($im, 12, 0, $left_margin + 255, $top_of_planet_listing + ($cnt * $y_spacing), $black, 'HamburgSymbols.ttf', chr($pl_glyph[$face]), 0);                 //draw planet glyph
    if ($i == $face)
    {
      imagettftext($im, 8, 0, $left_margin + 270, $top_of_planet_listing + ($cnt * $y_spacing), $black, 'arial.ttf', "+");                              //mark a "+"
      $peregrine[$i] = 0;
    }


   $_SESSION['peregrine'] = $peregrine;


//find detriment of this planet's sign
  if ($sign_pos == 7 Or $sign_pos == 2)
  {
    $detriment = SE_MARS;
  }
  elseif ($sign_pos == 8 Or $sign_pos == 1)
  {
    $detriment = SE_VENUS;
  }
  elseif ($sign_pos == 9 Or $sign_pos == 12)
  {
    $detriment = SE_MERCURY;
  }
  elseif ($sign_pos == 10)
  {
    $detriment = SE_MOON;
  }
  elseif ($sign_pos == 11)
  {
    $detriment = SE_SUN;
  }
  elseif ($sign_pos == 3 Or $sign_pos == 6)
  {
    $detriment = SE_JUPITER;
  }
  elseif ($sign_pos == 4 Or $sign_pos == 5)
  {
    $detriment = SE_SATURN;
  }

    drawboldtext($im, 14, 0, $left_margin + 295, $top_of_planet_listing + ($cnt * $y_spacing), $black, 'HamburgSymbols.ttf', chr($pl_glyph[$detriment]), 0);                  //draw planet glyph


//find fall of this planet's sign
  $fall = -1;

  if ($sign_pos == 7)
  {
    $fall = SE_SUN;
  }
  elseif ($sign_pos == 8)
  {
    $fall = SE_MOON;
  }
  elseif ($sign_pos == 10)
  {
    $fall = SE_JUPITER;
  }
  elseif ($sign_pos == 12)
  {
    $fall = SE_MERCURY;
  }
  elseif ($sign_pos == 1)
  {
    $fall = SE_SATURN;
  }
  elseif ($sign_pos == 4)
  {
    $fall = SE_MARS;
  }
  elseif ($sign_pos == 6)
  {
    $fall = SE_VENUS;
  }

    drawboldtext($im, 12, 0, $left_margin + 335, $top_of_planet_listing + ($cnt * $y_spacing), $black, 'HamburgSymbols.ttf', chr($pl_glyph[$fall]), 0);                 //draw planet glyph


//display the score here
    Find_planet_strengths($i, $longitude, $hc, $speed, $house_pos, $peregrine, $speed_literal, $ori_occ, $pps, SE_SUN, SE_MOON, SE_MERCURY, SE_VENUS, SE_MARS, SE_JUPITER, SE_SATURN);
  Find_planet_aspects($i, $longitude, $pps);

    if ($i <= SE_SATURN)
    {
      imagettftext($im, 10, 0, $left_margin + 375, $top_of_planet_listing + ($cnt * $y_spacing), $black, 'arial.ttf', $pps[$i]);
    }


//oriental or occidental
    $t = $longitude[SE_SUN] - $longitude[$i];
    $ori_occ = "Ori";

    if ($t < 0) { $t = $t + 360; }

    if ($t > 180) { $ori_occ = "Occ"; }

    if ($i == SE_SUN) { $ori_occ = ""; }

    imagettftext($im, 10, 0, $left_margin + 405, $top_of_planet_listing + ($cnt * $y_spacing), $black, 'arial.ttf', $ori_occ);


//antiscia
    // display planet data in the right-hand table
    $antiscia = Crunch(180 - $longitude[$i]);

    $sign_pos = floor($antiscia / 30) + 1;

    if ($sign_pos == 1 Or $sign_pos == 5 Or $sign_pos == 9)
    {
      $clr_to_use = $red;
    }
    elseif ($sign_pos == 2 Or $sign_pos == 6 Or $sign_pos == 10)
    {
      $clr_to_use = $another_green;
    }
    elseif ($sign_pos == 3 Or $sign_pos == 7 Or $sign_pos == 11)
    {
      $clr_to_use = $orange;
    }
    elseif ($sign_pos == 4 Or $sign_pos == 8 Or $sign_pos == 12)
    {
      $clr_to_use = $blue;
    }

    imagettftext($im, 10, 0, $left_margin + 446, $top_of_planet_listing + ($cnt * $y_spacing), $black, 'arial.ttf', Convert_Longitude1($antiscia));               //display longitude degrees
    imagettftext($im, 12, 0, $left_margin + 463, $top_of_planet_listing + ($cnt * $y_spacing), $clr_to_use, 'HamburgSymbols.ttf', chr($sign_glyph[$sign_pos]));         //display sign
    imagettftext($im, 10, 0, $left_margin + 479, $top_of_planet_listing + ($cnt * $y_spacing), $black, 'arial.ttf', Convert_Longitude2($antiscia));               //display longitude minutes and Rx


//contra-antiscia
    // display planet data in the right-hand table
    $antiscia = Crunch(180 - $longitude[$i] + 180);

    $sign_pos = floor($antiscia / 30) + 1;

    if ($sign_pos == 1 Or $sign_pos == 5 Or $sign_pos == 9)
    {
      $clr_to_use = $red;
    }
    elseif ($sign_pos == 2 Or $sign_pos == 6 Or $sign_pos == 10)
    {
      $clr_to_use = $another_green;
    }
    elseif ($sign_pos == 3 Or $sign_pos == 7 Or $sign_pos == 11)
    {
      $clr_to_use = $orange;
    }
    elseif ($sign_pos == 4 Or $sign_pos == 8 Or $sign_pos == 12)
    {
      $clr_to_use = $blue;
    }

    imagettftext($im, 10, 0, $left_margin + 512, $top_of_planet_listing + ($cnt * $y_spacing), $black, 'arial.ttf', Convert_Longitude1($antiscia));               //display longitude degrees
    imagettftext($im, 12, 0, $left_margin + 529, $top_of_planet_listing + ($cnt * $y_spacing), $clr_to_use, 'HamburgSymbols.ttf', chr($sign_glyph[$sign_pos]));         //display sign
    imagettftext($im, 10, 0, $left_margin + 545, $top_of_planet_listing + ($cnt * $y_spacing), $black, 'arial.ttf', Convert_Longitude2($antiscia));               //display longitude minutes and Rx


//display the declination
    imagettftext($im, 10, 0, $left_margin + 576, $top_of_planet_listing + ($cnt * $y_spacing), $black, 'arial.ttf', Convert_Declination($declination[$i]));


//speed value
  $the_speed = abs($speed[$i]);
  $spd_deg = floor($the_speed);
  $spd_min = ($the_speed - floor($the_speed)) * 60;

  if ($speed[$i] >= 0)
  {
    $t = "+";
  }
  else
  {
    $t = "-";
  }

  $t = $t . sprintf("%02d", $spd_deg) . " " . sprintf("%02d", $spd_min);
    imagettftext($im, 10, 0, $left_margin + 642, $top_of_planet_listing + ($cnt * $y_spacing), $black, 'arial.ttf', $t);


//speed literal
    $speed_literal = "Mean";

    if ($i == SE_SUN And abs($speed[$i]) > .9856103) { $speed_literal = "Fast"; }
    if ($i == SE_MERCURY And abs($speed[$i]) > .9856103) { $speed_literal = "Fast"; }
    if ($i == SE_VENUS And abs($speed[$i]) > .9856103) { $speed_literal = "Fast"; }
    if ($i == SE_MARS And abs($speed[$i]) > .524344) { $speed_literal = "Fast"; }
    if ($i == SE_JUPITER And abs($speed[$i]) > .083251) { $speed_literal = "Fast"; }
    if ($i == SE_SATURN And abs($speed[$i]) > .033697) { $speed_literal = "Fast"; }
    if ($i == SE_MOON And abs($speed[$i]) > 13.176541) { $speed_literal = "Fast"; }

    if ($i == SE_SUN And abs($speed[$i]) < .9856103) { $speed_literal = "Slow"; }
    if ($i == SE_MERCURY And abs($speed[$i]) < .9856103) { $speed_literal = "Slow"; }
    if ($i == SE_VENUS And abs($speed[$i]) < .9856103) { $speed_literal = "Slow"; }
    if ($i == SE_MARS And abs($speed[$i]) < .524344) { $speed_literal = "Slow"; }
    if ($i == SE_JUPITER And abs($speed[$i]) < .083251) { $speed_literal = "Slow"; }
    if ($i == SE_SATURN And abs($speed[$i]) < .033697) { $speed_literal = "Slow"; }
    if ($i == SE_MOON And abs($speed[$i]) < 13.176541) { $speed_literal = "Slow"; }

    if (abs($speed[$i]) < .00833333) { $speed_literal = "stat"; }

    if ($i == SE_URANUS Or $i == SE_NEPTUNE Or $i == SE_PLUTO Or $i == SE_TNNODE Or $i == SE_TSNODE Or $i == SE_POF) { $speed_literal = ""; }

    imagettftext($im, 10, 0, $left_margin + 706, $top_of_planet_listing + ($cnt * $y_spacing), $black, 'arial.ttf', $speed_literal);


//peregrine
    $peregrineX = "";

    if ($peregrine[$i] == 1 And $i <= SE_SATURN) { $peregrineX = "X"; }

    imagettftext($im, 8, 0, $left_margin + 760, $top_of_planet_listing + ($cnt * $y_spacing), $black, 'arial.ttf', $peregrineX);


    $cnt++;
  }


//here is where the 30-deg line starts
  $graphic_width = 780;
  $left_margin = 6;

  $x_dist_per_deg = $graphic_width / 30;        //distance is 24 units
  $start_of_y_axis = $overall_size + $y_top_margin + $extra_height_for_graphic_data_table;
  $y_dist_to_horiz_line = 12;           //where the horizontal line is drawn across the degree line
  $y_dist_to_nick_start = 21;           //where the little 'nick' marks start
  $y_dist_to_deg_text = 40;             //where the little 'nick' marks start
  $y_dist_to_planet_glyph = 65;         //where planet glyph is drawn
  $y_dist_to_sign_glyph = 85;           //where sign glyph is drawn
  $v_length_of_planet_connecting_line = 0;  //length of line that goes from horizontal line pointing to planet sign/glyph
  $y_offset = 50;                       //vertical distance between rows of planet-sign combinations
  $segment_length_of_5_deg = $x_dist_per_deg * 5;       //the distance between every 5 deg marker 'nick'
  $glyph_size = 12;                 //the size of the glyph for planets and signs


// draw the top horizonal line
  imageline($im, $left_margin, $start_of_y_axis + $y_dist_to_horiz_line, $left_margin + $graphic_width, $start_of_y_axis + $y_dist_to_horiz_line, $black);

// ------------------------------------------


// draw deg 'nicks' across the length of the horizontal lines
  $spoke_length = 4;
  $minor_spoke_length = 2;
  for ($i = 0; $i <= 30; $i++)
  {
    if ($i % 5 == 0)
    {
      $y1 = -$spoke_length * 2;
      $y2 = $spoke_length;
    }
    else
    {
      $y1 = -$spoke_length * 2;
      $y2 = $minor_spoke_length - 5;
    }

    imageline($im, $left_margin + ($i * $x_dist_per_deg), $start_of_y_axis + $y1 + $y_dist_to_nick_start, $left_margin + ($i * $x_dist_per_deg), $start_of_y_axis + $y2 + $y_dist_to_nick_start, $black);
  }


// ------------------------------------------


// place the text degrees across the horizontal line
  $cnt = 0;
  for ($i = 0; $i <= 30; $i++)
  {
    $deg_filled_idx[$i] = 0;            //initialize

    $array = imagettfbbox(10, 0, 'arial.ttf', sprintf("%'02d", $cnt));
    $width_of_text = $array[4] - $array[6];

    $x1 = $i * $x_dist_per_deg;

    imagettftext($im, 10, 0, $left_margin + $x1 - ($width_of_text / 2), $start_of_y_axis + $y_dist_to_deg_text, $black, 'arial.ttf', sprintf("%'02d", $cnt));

    $cnt = $cnt + 1;
  }


// ------------------------------------------


// put planet glyphs across line
  // sort longitudes in descending order from 360 down to 0
  Sort_planets_by_descending_longitude_2(LAST_PLANET + 3, $longitude, $sort, $sort_pos);


  for ($i = LAST_PLANET + 2; $i >= 0; $i--)
  {
    $pl_pos = floor($sort[$i]);

    $v_dist = $y_offset * $deg_filled_idx[$pl_pos];
    $deg_filled_idx[$pl_pos]++;

    $x1 = ($pl_pos * $x_dist_per_deg) - ($glyph_size / 2);

    if (substr($retrograde, $sort_pos[$i], 1) == "R")
    {
      imagettftext($im, $glyph_size, 0, $left_margin + $x1, $start_of_y_axis + $y_dist_to_planet_glyph + $v_dist, $red_2, 'HamburgSymbols.ttf', chr($pl_glyph[$sort_pos[$i]]));
    }
    else
    {
      imagettftext($im, $glyph_size, 0, $left_margin + $x1, $start_of_y_axis + $y_dist_to_planet_glyph + $v_dist, $planet_color, 'HamburgSymbols.ttf', chr($pl_glyph[$sort_pos[$i]]));
    }

    $pl_sign = floor($longitude[$sort_pos[$i]] / 30) + 1;
    if ($pl_sign == 1 Or $pl_sign == 5 Or $pl_sign == 9)
    {
      $clr_to_use = $red_2;
    }
    elseif ($pl_sign == 2 Or $pl_sign == 6 Or $pl_sign == 10)
    {
      $clr_to_use = $brown;
    }
    elseif ($pl_sign == 3 Or $pl_sign == 7 Or $pl_sign == 11)
    {
      $clr_to_use = $blue_2;
    }
    elseif ($pl_sign == 4 Or $pl_sign == 8 Or $pl_sign == 12)
    {
      $clr_to_use = $green_2;
    }

    // put the signs across the top and bottom of the horizontal lines
    imagettftext($im, $glyph_size, 0, $left_margin + $x1, $start_of_y_axis + $y_dist_to_sign_glyph + $v_dist, $clr_to_use, 'HamburgSymbols.ttf', chr($sign_glyph[$pl_sign]));
  }


//here is where the graphic "HTML" table appears
  $start_of_y_axis = $overall_size + $y_top_margin + $extra_height_for_graphic_data_table + $extra_height_for_30deg_line + 15;
  $left_col_print_idx = 357;
  $x_text_start = 502;
  $line_cntr = 1;


//besieged planets
  drawboldtext($im, 9, 0, $left_col_print_idx, $start_of_y_axis + (15 * $line_cntr), $red, 'arial.ttf', "Besieged Planets - ", 0);
  $txt = "";
  for ($i = SE_SUN; $i <= SE_TSNODE; $i++)
  {
    if (floor($longitude[SE_MARS] / 30) == floor($longitude[SE_SATURN] / 30))   //Mars and Saturn must be in the same sign
    {
      if ($i != SE_MARS And $i != SE_SATURN)                    //skip Mars and Saturn
      {
        if ($longitude[SE_SATURN] - $longitude[SE_MARS] >= 0)
        {
          if ($longitude[$i] >= $longitude[SE_MARS] And $longitude[$i] <= $longitude[SE_SATURN]) { $txt .= $pl_name[$i] . "   "; }
        }
        else
        {
          if ($longitude[$i] >= $longitude[SE_SATURN] And $longitude[$i] <= $longitude[SE_MARS]) { $txt .= $pl_name[$i] . "   "; }
        }
      }
    }
  }

  imagettftext($im, 9, 0, $x_text_start, $start_of_y_axis + (15 * $line_cntr), $black, 'arial.ttf', $txt);
  $line_cntr++;


//planets in critical degrees - INTERVAL = 12.85714286 DEGREES EVERY DAY
  drawboldtext($im, 9, 0, $left_col_print_idx, $start_of_y_axis + (15 * $line_cntr), $red, 'arial.ttf', "Critical Degrees - ", 0);
  $txt = "";

  for ($i = SE_SUN; $i <= SE_PLUTO; $i++)
  {
    $t = $longitude[$i];

    while ($t >= 90) { $t = $t - 90; }

    if ($t >= 0 And $t <= .5) { $txt .= $pl_name[$i] . "   "; }
    if ($t >= 89.50000 And $t < 90) { $txt .= $pl_name[$i] . "   "; }
    if ($t >= 12.35700 And $t <= 13.35700) { $txt .= $pl_name[$i] . "   "; }
    if ($t >= 25.21400 And $t <= 26.21400) { $txt .= $pl_name[$i] . "   "; }
    if ($t >= 38.07100 And $t <= 39.07100) { $txt .= $pl_name[$i] . "   "; }
    if ($t >= 50.92857 And $t <= 51.92857) { $txt .= $pl_name[$i] . "   "; }
    if ($t >= 63.78570 And $t <= 64.78570) { $txt .= $pl_name[$i] . "   "; }
    if ($t >= 76.64286 And $t <= 77.64286) { $txt .= $pl_name[$i] . "   "; }
  }

  imagettftext($im, 9, 0, $x_text_start, $start_of_y_axis + (15 * $line_cntr), $black, 'arial.ttf', $txt);
  $line_cntr++;


//planets in Via Combusta
  drawboldtext($im, 9, 0, $left_col_print_idx, $start_of_y_axis + (15 * $line_cntr), $red, 'arial.ttf', "Via Combusta - ", 0);
  $txt = "";

  for ($i = SE_SUN; $i <= SE_PLUTO; $i++)
  {
    if ($longitude[$i] >= 195 And $longitude[$i] < 225) { $txt .= $pl_name[$i] . "   "; }
  }

  imagettftext($im, 9, 0, $x_text_start, $start_of_y_axis + (15 * $line_cntr), $black, 'arial.ttf', $txt);
  $line_cntr++;


//cazimi planets
  drawboldtext($im, 9, 0, $left_col_print_idx, $start_of_y_axis + (15 * $line_cntr), $red, 'arial.ttf', "Cazimi Planets - ", 0);
  $txt = "";

  for ($i = SE_MOON; $i <= SE_PLUTO; $i++)
  {
    if (abs($longitude[SE_SUN] - $longitude[$i]) >= 0 And abs($longitude[SE_SUN] - $longitude[$i]) <= .28333) { $txt .= $pl_name[$i] . "   "; }
  }

  imagettftext($im, 9, 0, $x_text_start, $start_of_y_axis + (15 * $line_cntr), $black, 'arial.ttf', $txt);
  $line_cntr++;


//combust planets
  drawboldtext($im, 9, 0, $left_col_print_idx, $start_of_y_axis + (15 * $line_cntr), $red, 'arial.ttf', "Combust Planets - ", 0);
  $txt = "";

  for ($i = SE_MOON; $i <= SE_PLUTO; $i++)
  {
    if (floor($longitude[SE_SUN] / 30) == floor($longitude[$i] / 30) And abs($longitude[SE_SUN] - $longitude[$i]) >= .28333 And abs($longitude[SE_SUN] - $longitude[$i]) <= 8.5) { $txt .= $pl_name[$i] . "   "; }
  }

  imagettftext($im, 9, 0, $x_text_start, $start_of_y_axis + (15 * $line_cntr), $black, 'arial.ttf', $txt);
  $line_cntr++;


//under the Sun's beam planets
  drawboldtext($im, 9, 0, $left_col_print_idx, $start_of_y_axis + (15 * $line_cntr), $red, 'arial.ttf', "Under Sun's Beams - ", 0);
  $txt = "";

  for ($i = SE_MOON; $i <= SE_PLUTO; $i++)
  {
    if (floor($longitude[SE_SUN] / 30) != floor($longitude[$i] / 30) And abs($longitude[SE_SUN] - $longitude[$i]) >= .28333 And abs($longitude[SE_SUN] - $longitude[$i]) <= 8.5)
    {
      $txt .= $pl_name[$i] . "   ";
    }
    elseif (abs($longitude[SE_SUN] - $longitude[$i]) >= 8.5 And abs($longitude[SE_SUN] - $longitude[$i]) <= 17)
    {
      $txt .= $pl_name[$i] . "   ";
    }
  }

  imagettftext($im, 9, 0, $x_text_start, $start_of_y_axis + (15 * $line_cntr), $black, 'arial.ttf', $txt);
  $line_cntr++;


//planets in same degree as the Node
  drawboldtext($im, 9, 0, $left_col_print_idx, $start_of_y_axis + (15 * $line_cntr), $red, 'arial.ttf', "Fateful Degree Planets - ", 0);
  $txt = "";

  $deg_of_Node = floor($longitude[SE_TNNODE]);

  while ($deg_of_Node >= 30) { $deg_of_Node = $deg_of_Node - 30; }

  for ($i = SE_SUN; $i <= SE_POF; $i++)
  {
    if ($i == SE_TNNODE Or $i == SE_TSNODE) { continue; }

    $deg_of_planet = floor($longitude[$i]);

    while ($deg_of_planet >= 30) { $deg_of_planet = $deg_of_planet - 30; }

    if ($deg_of_planet == $deg_of_Node) { $txt .= $pl_name[$i] . "   "; }
  }

  imagettftext($im, 9, 0, $x_text_start, $start_of_y_axis + (15 * $line_cntr), $black, 'arial.ttf', $txt);
  $line_cntr++;


//Arabian Parts
  $x_text_position = 205;
  $line_cntr = 1;
  drawboldtext($im, 9, 0, $x_text_position, $start_of_y_axis + (15 * $line_cntr), $red, 'arial.ttf', "Arabian Part Conjunctions", 0);
  $line_cntr++;

  $cdn = 0;
  if ($house_pos[SE_SUN] < 7) { $cdn = 1; }

  $ap = array();

  $num_aps = 1;

  $ap[0][$num_aps] = "Fortune";
  $ap[1][$num_aps] = Crunch($hc[1] + $longitude[SE_MOON] - $longitude[SE_SUN]);
  if ($cdn == 1) { $ap[1][$num_aps] = Crunch($hc[1] - $longitude[SE_MOON] + $longitude[SE_SUN]); }
  $part_of_fortune = $ap[1][$num_aps];

  $num_aps++;
  $ap[0][$num_aps] = "Spirit";
  $ap[1][$num_aps] = Crunch($hc[1] + $longitude[SE_SUN] - $longitude[SE_MOON]);
  if ($cdn == 1) { $ap[1][$num_aps] = Crunch($hc[1] - $longitude[SE_SUN] + $longitude[SE_MOON]); }
  $part_of_spirit = $ap[1][$num_aps];

  $num_aps++;
  $ap[0][$num_aps] = "Soul";
  $ap[1][$num_aps] = Crunch($hc[4] + $longitude[SE_MOON] - $longitude[SE_SUN]);
  if ($cdn == 1) { $ap[1][$num_aps] = Crunch($hc[4] - $longitude[SE_MOON] + $longitude[SE_SUN]); }

  $num_aps++;
  $ap[0][$num_aps] = "Intelligence";
  $ap[1][$num_aps] = Crunch($longitude[SE_VENUS] + $longitude[SE_MOON] - $longitude[SE_SUN]);

  $num_aps++;
  $ap[0][$num_aps] = "Eros, appetite";
  $ap[1][$num_aps] = Crunch($hc[1] + $longitude[SE_VENUS] - $part_of_spirit);

  $num_aps++;
  $ap[0][$num_aps] = "Illness";
  $ap[1][$num_aps] = Crunch($hc[1] + $longitude[SE_MARS] - $longitude[SE_SATURN]);

  $num_aps++;
  $ap[0][$num_aps] = "Death - traditional";
  $ap[1][$num_aps] = Crunch($hc[1] + $hc[8] - $longitude[SE_MOON]);

  $num_aps++;
  $ap[0][$num_aps] = "Marriage";
  $ap[1][$num_aps] = Crunch($hc[1] + $hc[7] - $longitude[SE_VENUS]);

  $num_aps++;
  $ap[0][$num_aps] = "Fatality";
  $ap[1][$num_aps] = Crunch($hc[1] + $longitude[SE_SATURN] - $longitude[SE_SUN]);

  $num_aps++;
  $ap[0][$num_aps] = "Point of death";
  $ap[1][$num_aps] = Crunch($longitude[SE_MARS] + $longitude[SE_SATURN] - $hc[10]);

  $num_aps++;
  $ap[0][$num_aps] = "Bankruptcy";
  $ap[1][$num_aps] = Crunch($longitude[SE_JUPITER] + $longitude[SE_JUPITER] - $longitude[SE_URANUS]);

  $num_aps++;
  $ap[0][$num_aps] = "Catastrophe";
  $ap[1][$num_aps] = Crunch($hc[1] + $longitude[SE_URANUS] - $longitude[SE_SUN]);

  $num_aps++;
  $ap[0][$num_aps] = "Depression";
  $ap[1][$num_aps] = Crunch($hc[1] + $longitude[SE_NEPTUNE] - $longitude[SE_MARS]);

  $num_aps++;
  $ap[0][$num_aps] = "Divorce";
  $ap[1][$num_aps] = Crunch($hc[1] + $longitude[SE_VENUS] - $hc[7]);
  if ($cdn == 1) { $ap[1][$num_aps] = Crunch($hc[1] - $longitude[SE_VENUS] + $hc[7]); }

  $num_aps++;
  $ap[0][$num_aps] = "Fraud";
  $ap[1][$num_aps] = Crunch($hc[1] + $longitude[SE_NEPTUNE] - $longitude[SE_MERCURY]);

  $num_aps++;
  $ap[0][$num_aps] = "Homosexual";
  $ap[1][$num_aps] = Crunch($hc[1] + $longitude[SE_MARS] - $longitude[SE_URANUS]);

  $num_aps++;
  $ap[0][$num_aps] = "Inheritance";
  $ap[1][$num_aps] = Crunch($hc[1] + $longitude[SE_MOON] - $longitude[SE_SATURN]);

  $num_aps++;
  $ap[0][$num_aps] = "Lawsuits";
  $ap[1][$num_aps] = Crunch($hc[1] + $longitude[SE_MERCURY] - $longitude[SE_MARS]);

  $num_aps++;
  $ap[0][$num_aps] = "Perversion";
  $ap[1][$num_aps] = Crunch($longitude[SE_VENUS] + $longitude[SE_MARS] - $longitude[SE_NEPTUNE]);

  $num_aps++;
  $ap[0][$num_aps] = "Self-undoing";
  $ap[1][$num_aps] = Crunch($hc[1] + $hc[12] - $longitude[SE_NEPTUNE]);

  $num_aps++;
  $ap[0][$num_aps] = "Speculation";
  $ap[1][$num_aps] = Crunch($hc[1] + $hc[5] - $longitude[SE_JUPITER]);

  $num_aps++;
  $ap[0][$num_aps] = "Surgery";
  $ap[1][$num_aps] = Crunch($hc[1] + $longitude[SE_SATURN] - $longitude[SE_MARS]);

  $num_aps++;
  $ap[0][$num_aps] = "Treachery";
  $ap[1][$num_aps] = Crunch($hc[1] + $longitude[SE_NEPTUNE] - $longitude[SE_SUN]);

  $num_aps++;
  $ap[0][$num_aps] = "Violence";
  $ap[1][$num_aps] = Crunch($longitude[SE_MARS] + $longitude[SE_URANUS] - $longitude[SE_SATURN]);

  for ($z = 2; $z <= $num_aps; $z++)
  {
    for ($i = SE_SUN; $i <= SE_POF; $i++)
    {
      $da = abs($longitude[$i] - $ap[1][$z]);

      if ($da <= 1 Or $da >= 359)
      {
        imagettftext($im, 9, 0, $x_text_position, $start_of_y_axis + (15 * $line_cntr), $black, 'arial.ttf', $pl_name[$i] . " - " . $ap[0][$z]);
        $line_cntr++;
      }
    }
  }

  $line_cntr++;


//fixed star conjunctions
  drawboldtext($im, 9, 0, $x_text_position, $start_of_y_axis + (15 * $line_cntr), $red, 'arial.ttf', "Fixed Star Conjunctions", 0);
  $line_cntr++;

  $inyear = $_SESSION['inyear'];

  $dyr = $inyear - 1990;                //$dyr = delta year - fixed star positions in 1990
  $dfsp = $dyr * 50.23 / 3600;              //fixed star movement since 1990 = $dfsp
  $dfsp2000 = ($inyear - 2000) * 50.23 / 3600;      //fixed star movement since 2000 = $dfsp2000

  for ($i = SE_SUN; $i <= SE_POF; $i++)
  {
    if ($longitude[$i] >= ($dfsp + 56.03000 - 5) And $longitude[$i] <= ($dfsp + 56.03000 + 5)) { imagettftext($im, 9, 0, $x_text_position, $start_of_y_axis + (15 * $line_cntr), $black, 'arial.ttf', $pl_name[$i] . " - Algol"); $line_cntr++; }
    if ($longitude[$i] >= ($dfsp + 58.85000) And $longitude[$i] <= ($dfsp + 60.85000)) { imagettftext($im, 9, 0, $x_text_position, $start_of_y_axis + (15 * $line_cntr), $black, 'arial.ttf', $pl_name[$i] . " - Alcyone"); $line_cntr++; }
    if ($longitude[$i] >= ($dfsp + 68.65000) And $longitude[$i] <= ($dfsp + 70.65000)) { imagettftext($im, 9, 0, $x_text_position, $start_of_y_axis + (15 * $line_cntr), $black, 'arial.ttf', $pl_name[$i] . " - Aldebaran"); $line_cntr++; }
    if ($longitude[$i] >= ($dfsp + 148.70000) And $longitude[$i] <= ($dfsp + 150.70000)) { imagettftext($im, 9, 0, $x_text_position, $start_of_y_axis + (15 * $line_cntr), $black, 'arial.ttf', $pl_name[$i] . " - Regulus"); $line_cntr++; }
    if ($longitude[$i] >= ($dfsp + 202.70000) And $longitude[$i] <= ($dfsp + 204.70000)) { imagettftext($im, 9, 0, $x_text_position, $start_of_y_axis + (15 * $line_cntr), $black, 'arial.ttf', $pl_name[$i] . " - Spica"); $line_cntr++; }
    if ($longitude[$i] >= ($dfsp + 230.95000) And $longitude[$i] <= ($dfsp + 232.95000)) { imagettftext($im, 9, 0, $x_text_position, $start_of_y_axis + (15 * $line_cntr), $black, 'arial.ttf', $pl_name[$i] . " - Unuk"); $line_cntr++; }
    if ($longitude[$i] >= ($dfsp + 248.63300) And $longitude[$i] <= ($dfsp + 250.63300)) { imagettftext($im, 9, 0, $x_text_position, $start_of_y_axis + (15 * $line_cntr), $black, 'arial.ttf', $pl_name[$i] . " - Antares"); $line_cntr++; }
    if ($longitude[$i] >= ($dfsp + 332.71667) And $longitude[$i] <= ($dfsp + 334.71667)) { imagettftext($im, 9, 0, $x_text_position, $start_of_y_axis + (15 * $line_cntr), $black, 'arial.ttf', $pl_name[$i] . " - Fomalhaut"); $line_cntr++; }
    if ($longitude[$i] >= ($dfsp + 352.35000) And $longitude[$i] <= ($dfsp + 354.35000)) { imagettftext($im, 9, 0, $x_text_position, $start_of_y_axis + (15 * $line_cntr), $black, 'arial.ttf', $pl_name[$i] . " - Markab"); $line_cntr++; }
    if (($longitude[$i] >= ($dfsp + 358.23333) And $longitude[$i] <= ($dfsp + 360.23333)) Or ($longitude[$i] >= ($dfsp - 2.23333) And $longitude[$i] <= ($dfsp + 0.23333))) { imagettftext($im, 9, 0, $x_text_position, $start_of_y_axis + (15 * $line_cntr), $black, 'arial.ttf', $pl_name[$i] . " - Scheat"); $line_cntr++; }

    if ($longitude[$i] >= ($dfsp + 87.616667) And $longitude[$i] <= ($dfsp + 89.61667)) { imagettftext($im, 9, 0, $x_text_position, $start_of_y_axis + (15 * $line_cntr), $black, 'arial.ttf', $pl_name[$i] . " - Betelgeuze"); $line_cntr++; }
    if ($longitude[$i] >= ($dfsp + 109.11667) And $longitude[$i] <= ($dfsp + 111.11667)) { imagettftext($im, 9, 0, $x_text_position, $start_of_y_axis + (15 * $line_cntr), $black, 'arial.ttf', $pl_name[$i] . " - Castor"); $line_cntr++; }
    if ($longitude[$i] >= ($dfsp + 126.40000) And $longitude[$i] <= ($dfsp + 128.40000)) { imagettftext($im, 9, 0, $x_text_position, $start_of_y_axis + (15 * $line_cntr), $black, 'arial.ttf', $pl_name[$i] . " - N. Ascelli"); $line_cntr++; }
    if ($longitude[$i] >= ($dfsp + 127.58333) And $longitude[$i] <= ($dfsp + 129.58333)) { imagettftext($im, 9, 0, $x_text_position, $start_of_y_axis + (15 * $line_cntr), $black, 'arial.ttf', $pl_name[$i] . " - S. Ascelli"); $line_cntr++; }
    if ($longitude[$i] >= ($dfsp + 188.81667) And $longitude[$i] <= ($dfsp + 190.81667)) { imagettftext($im, 9, 0, $x_text_position, $start_of_y_axis + (15 * $line_cntr), $black, 'arial.ttf', $pl_name[$i] . " - Vindemiatrix"); $line_cntr++; }
    if ($longitude[$i] >= ($dfsp + 264.60000) And $longitude[$i] <= ($dfsp + 266.60000)) { imagettftext($im, 9, 0, $x_text_position, $start_of_y_axis + (15 * $line_cntr), $black, 'arial.ttf', $pl_name[$i] . " - Aculeus"); $line_cntr++; }
    if ($longitude[$i] >= ($dfsp + 267.61667) And $longitude[$i] <= ($dfsp + 269.61667)) { imagettftext($im, 9, 0, $x_text_position, $start_of_y_axis + (15 * $line_cntr), $black, 'arial.ttf', $pl_name[$i] . " - Acumen"); $line_cntr++; }
    if ($longitude[$i] >= ($dfsp + 284.18333) And $longitude[$i] <= ($dfsp + 286.18333)) { imagettftext($im, 9, 0, $x_text_position, $start_of_y_axis + (15 * $line_cntr), $black, 'arial.ttf', $pl_name[$i] . " - Vega"); $line_cntr++; }

    if ($longitude[$i] >= ($dfsp2000 + 13.30000) And $longitude[$i] <= ($dfsp2000 + 15.30000)) { imagettftext($im, 9, 0, $x_text_position, $start_of_y_axis + (15 * $line_cntr), $black, 'arial.ttf', $pl_name[$i] . " - Alpheratz"); $line_cntr++; }
    if ($longitude[$i] >= ($dfsp2000 + 20.95000) And $longitude[$i] <= ($dfsp2000 + 22.95000)) { imagettftext($im, 9, 0, $x_text_position, $start_of_y_axis + (15 * $line_cntr), $black, 'arial.ttf', $pl_name[$i] . " - Baten Kaitos"); $line_cntr++; }
    if ($longitude[$i] >= ($dfsp2000 + 32.96667) And $longitude[$i] <= ($dfsp2000 + 34.96667)) { imagettftext($im, 9, 0, $x_text_position, $start_of_y_axis + (15 * $line_cntr), $black, 'arial.ttf', $pl_name[$i] . " - Sharatan"); $line_cntr++; }
    if ($longitude[$i] >= ($dfsp2000 + 36.66667) And $longitude[$i] <= ($dfsp2000 + 38.78333)) { imagettftext($im, 9, 0, $x_text_position, $start_of_y_axis + (15 * $line_cntr), $black, 'arial.ttf', $pl_name[$i] . " - Hamal"); $line_cntr++; }
    if ($longitude[$i] >= ($dfsp2000 + 36.78333) And $longitude[$i] <= ($dfsp2000 + 38.78333)) { imagettftext($im, 9, 0, $x_text_position, $start_of_y_axis + (15 * $line_cntr), $black, 'arial.ttf', $pl_name[$i] . " - Schedir"); $line_cntr++; }
    if ($longitude[$i] >= ($dfsp2000 + 43.23333) And $longitude[$i] <= ($dfsp2000 + 45.23333)) { imagettftext($im, 9, 0, $x_text_position, $start_of_y_axis + (15 * $line_cntr), $black, 'arial.ttf', $pl_name[$i] . " - Almach"); $line_cntr++; }
    if ($longitude[$i] >= ($dfsp2000 + 64.80000) And $longitude[$i] <= ($dfsp2000 + 66.80000)) { imagettftext($im, 9, 0, $x_text_position, $start_of_y_axis + (15 * $line_cntr), $black, 'arial.ttf', $pl_name[$i] . " - Hyades"); $line_cntr++; }
    if ($longitude[$i] >= ($dfsp2000 + 67.46667) And $longitude[$i] <= ($dfsp2000 + 69.46667)) { imagettftext($im, 9, 0, $x_text_position, $start_of_y_axis + (15 * $line_cntr), $black, 'arial.ttf', $pl_name[$i] . " - N. Bull's Eye"); $line_cntr++; }
    if ($longitude[$i] >= ($dfsp2000 + 75.83333) And $longitude[$i] <= ($dfsp2000 + 77.83333)) { imagettftext($im, 9, 0, $x_text_position, $start_of_y_axis + (15 * $line_cntr), $black, 'arial.ttf', $pl_name[$i] . " - Rigel"); $line_cntr++; }
    if ($longitude[$i] >= ($dfsp2000 + 79.95000) And $longitude[$i] <= ($dfsp2000 + 81.95000)) { imagettftext($im, 9, 0, $x_text_position, $start_of_y_axis + (15 * $line_cntr), $black, 'arial.ttf', $pl_name[$i] . " - Bellatrix"); $line_cntr++; }
    if ($longitude[$i] >= ($dfsp2000 + 80.85000) And $longitude[$i] <= ($dfsp2000 + 82.85000)) { imagettftext($im, 9, 0, $x_text_position, $start_of_y_axis + (15 * $line_cntr), $black, 'arial.ttf', $pl_name[$i] . " - Capella"); $line_cntr++; }
    if ($longitude[$i] >= ($dfsp2000 + 81.16667) And $longitude[$i] <= ($dfsp2000 + 83.16667)) { imagettftext($im, 9, 0, $x_text_position, $start_of_y_axis + (15 * $line_cntr), $black, 'arial.ttf', $pl_name[$i] . " - Phact"); $line_cntr++; }
    if ($longitude[$i] >= ($dfsp2000 + 81.58333) And $longitude[$i] <= ($dfsp2000 + 83.58333)) { imagettftext($im, 9, 0, $x_text_position, $start_of_y_axis + (15 * $line_cntr), $black, 'arial.ttf', $pl_name[$i] . " - El Nath"); $line_cntr++; }
    if ($longitude[$i] >= ($dfsp2000 + 82.46667) And $longitude[$i] <= ($dfsp2000 + 84.46667)) { imagettftext($im, 9, 0, $x_text_position, $start_of_y_axis + (15 * $line_cntr), $black, 'arial.ttf', $pl_name[$i] . " - Alnilaml"); $line_cntr++; }
    if ($longitude[$i] >= ($dfsp2000 + 83.78333) And $longitude[$i] <= ($dfsp2000 + 85.78333)) { imagettftext($im, 9, 0, $x_text_position, $start_of_y_axis + (15 * $line_cntr), $black, 'arial.ttf', $pl_name[$i] . " - Al Hecka"); $line_cntr++; }
    if ($longitude[$i] >= ($dfsp2000 + 103.08333) And $longitude[$i] <= ($dfsp2000 + 105.08333)) { imagettftext($im, 9, 0, $x_text_position, $start_of_y_axis + (15 * $line_cntr), $black, 'arial.ttf', $pl_name[$i] . " - Sirius"); $line_cntr++; }
    if ($longitude[$i] >= ($dfsp2000 + 103.96667) And $longitude[$i] <= ($dfsp2000 + 105.96667)) { imagettftext($im, 9, 0, $x_text_position, $start_of_y_axis + (15 * $line_cntr), $black, 'arial.ttf', $pl_name[$i] . " - Canopus"); $line_cntr++; }
    if ($longitude[$i] >= ($dfsp2000 + 112.21667) And $longitude[$i] <= ($dfsp2000 + 114.21667)) { imagettftext($im, 9, 0, $x_text_position, $start_of_y_axis + (15 * $line_cntr), $black, 'arial.ttf', $pl_name[$i] . " - Pollux"); $line_cntr++; }
    if ($longitude[$i] >= ($dfsp2000 + 114.78333) And $longitude[$i] <= ($dfsp2000 + 116.78333)) { imagettftext($im, 9, 0, $x_text_position, $start_of_y_axis + (15 * $line_cntr), $black, 'arial.ttf', $pl_name[$i] . " - Procyon"); $line_cntr++; }
    if ($longitude[$i] >= ($dfsp2000 + 126.33333) And $longitude[$i] <= ($dfsp2000 + 128.33333)) { imagettftext($im, 9, 0, $x_text_position, $start_of_y_axis + (15 * $line_cntr), $black, 'arial.ttf', $pl_name[$i] . " - Praesaepe"); $line_cntr++; }
    if ($longitude[$i] >= ($dfsp2000 + 132.63333) And $longitude[$i] <= ($dfsp2000 + 134.63333)) { imagettftext($im, 9, 0, $x_text_position, $start_of_y_axis + (15 * $line_cntr), $black, 'arial.ttf', $pl_name[$i] . " - Acubens"); $line_cntr++; }
    if ($longitude[$i] >= ($dfsp2000 + 134.20000) And $longitude[$i] <= ($dfsp2000 + 136.20000)) { imagettftext($im, 9, 0, $x_text_position, $start_of_y_axis + (15 * $line_cntr), $black, 'arial.ttf', $pl_name[$i] . " - Dubhe"); $line_cntr++; }
    if ($longitude[$i] >= ($dfsp2000 + 146.28333) And $longitude[$i] <= ($dfsp2000 + 148.28333)) { imagettftext($im, 9, 0, $x_text_position, $start_of_y_axis + (15 * $line_cntr), $black, 'arial.ttf', $pl_name[$i] . " - Alphard"); $line_cntr++; }
    if ($longitude[$i] >= ($dfsp2000 + 146.90000) And $longitude[$i] <= ($dfsp2000 + 148.90000)) { imagettftext($im, 9, 0, $x_text_position, $start_of_y_axis + (15 * $line_cntr), $black, 'arial.ttf', $pl_name[$i] . " - Al Jabhah"); $line_cntr++; }
    if ($longitude[$i] >= ($dfsp2000 + 160.31667) And $longitude[$i] <= ($dfsp2000 + 162.31667)) { imagettftext($im, 9, 0, $x_text_position, $start_of_y_axis + (15 * $line_cntr), $black, 'arial.ttf', $pl_name[$i] . " - Zosma"); $line_cntr++; }
    if ($longitude[$i] >= ($dfsp2000 + 170.61667) And $longitude[$i] <= ($dfsp2000 + 172.61667)) { imagettftext($im, 9, 0, $x_text_position, $start_of_y_axis + (15 * $line_cntr), $black, 'arial.ttf', $pl_name[$i] . " - Denebolal"); $line_cntr++; }
    if ($longitude[$i] >= ($dfsp2000 + 172.86667) And $longitude[$i] <= ($dfsp2000 + 174.86667)) { imagettftext($im, 9, 0, $x_text_position, $start_of_y_axis + (15 * $line_cntr), $black, 'arial.ttf', $pl_name[$i] . " - Coma Berenices"); $line_cntr++; }
    if ($longitude[$i] >= ($dfsp2000 + 175.68333) And $longitude[$i] <= ($dfsp2000 + 177.68333)) { imagettftext($im, 9, 0, $x_text_position, $start_of_y_axis + (15 * $line_cntr), $black, 'arial.ttf', $pl_name[$i] . " - Labrum"); $line_cntr++; }
    if ($longitude[$i] >= ($dfsp2000 + 192.45000) And $longitude[$i] <= ($dfsp2000 + 194.45000)) { imagettftext($im, 9, 0, $x_text_position, $start_of_y_axis + (15 * $line_cntr), $black, 'arial.ttf', $pl_name[$i] . " - Algorab"); $line_cntr++; }
    if ($longitude[$i] >= ($dfsp2000 + 196.66667) And $longitude[$i] <= ($dfsp2000 + 198.66667)) { imagettftext($im, 9, 0, $x_text_position, $start_of_y_axis + (15 * $line_cntr), $black, 'arial.ttf', $pl_name[$i] . " - Seginus"); $line_cntr++; }
    if ($longitude[$i] >= ($dfsp2000 + 201.15000) And $longitude[$i] <= ($dfsp2000 + 203.15000)) { imagettftext($im, 9, 0, $x_text_position, $start_of_y_axis + (15 * $line_cntr), $black, 'arial.ttf', $pl_name[$i] . " - Foramen"); $line_cntr++; }
    if ($longitude[$i] >= ($dfsp2000 + 203.23333) And $longitude[$i] <= ($dfsp2000 + 205.23333)) { imagettftext($im, 9, 0, $x_text_position, $start_of_y_axis + (15 * $line_cntr), $black, 'arial.ttf', $pl_name[$i] . " - Arcturus"); $line_cntr++; }
    if ($longitude[$i] >= ($dfsp2000 + 212.15000) And $longitude[$i] <= ($dfsp2000 + 214.15000)) { imagettftext($im, 9, 0, $x_text_position, $start_of_y_axis + (15 * $line_cntr), $black, 'arial.ttf', $pl_name[$i] . " - Princeps"); $line_cntr++; }
    if ($longitude[$i] >= ($dfsp2000 + 221.30000) And $longitude[$i] <= ($dfsp2000 + 223.30000)) { imagettftext($im, 9, 0, $x_text_position, $start_of_y_axis + (15 * $line_cntr), $black, 'arial.ttf', $pl_name[$i] . " - Alphecca"); $line_cntr++; }
    if ($longitude[$i] >= ($dfsp2000 + 224.08333) And $longitude[$i] <= ($dfsp2000 + 226.08330)) { imagettftext($im, 9, 0, $x_text_position, $start_of_y_axis + (15 * $line_cntr), $black, 'arial.ttf', $pl_name[$i] . " - S. Scale"); $line_cntr++; }
    if ($longitude[$i] >= ($dfsp2000 + 228.36667) And $longitude[$i] <= ($dfsp2000 + 230.36667)) { imagettftext($im, 9, 0, $x_text_position, $start_of_y_axis + (15 * $line_cntr), $black, 'arial.ttf', $pl_name[$i] . " - N. Scale"); $line_cntr++; }
    if ($longitude[$i] >= ($dfsp2000 + 232.80000) And $longitude[$i] <= ($dfsp2000 + 234.80000)) { imagettftext($im, 9, 0, $x_text_position, $start_of_y_axis + (15 * $line_cntr), $black, 'arial.ttf', $pl_name[$i] . " - Agena"); $line_cntr++; }
    if ($longitude[$i] >= ($dfsp2000 + 238.61667) And $longitude[$i] <= ($dfsp2000 + 240.61667)) { imagettftext($im, 9, 0, $x_text_position, $start_of_y_axis + (15 * $line_cntr), $black, 'arial.ttf', $pl_name[$i] . " - Bungula"); $line_cntr++; }
    if ($longitude[$i] >= ($dfsp2000 + 241.30000) And $longitude[$i] <= ($dfsp2000 + 243.30000)) { imagettftext($im, 9, 0, $x_text_position, $start_of_y_axis + (15 * $line_cntr), $black, 'arial.ttf', $pl_name[$i] . " - Yed Prior"); $line_cntr++; }
    if ($longitude[$i] >= ($dfsp2000 + 250.96667) And $longitude[$i] <= ($dfsp2000 + 252.96667)) { imagettftext($im, 9, 0, $x_text_position, $start_of_y_axis + (15 * $line_cntr), $black, 'arial.ttf', $pl_name[$i] . " - Rastaban"); $line_cntr++; }
    if ($longitude[$i] >= ($dfsp2000 + 255.15000) And $longitude[$i] <= ($dfsp2000 + 257.15000)) { imagettftext($im, 9, 0, $x_text_position, $start_of_y_axis + (15 * $line_cntr), $black, 'arial.ttf', $pl_name[$i] . " - Algethi"); $line_cntr++; }
    if ($longitude[$i] >= ($dfsp2000 + 268.75000) And $longitude[$i] <= ($dfsp2000 + 270.75000)) { imagettftext($im, 9, 0, $x_text_position, $start_of_y_axis + (15 * $line_cntr), $black, 'arial.ttf', $pl_name[$i] . " - Sinistra"); $line_cntr++; }
    if ($longitude[$i] >= ($dfsp2000 + 277.30000) And $longitude[$i] <= ($dfsp2000 + 279.30000)) { imagettftext($im, 9, 0, $x_text_position, $start_of_y_axis + (15 * $line_cntr), $black, 'arial.ttf', $pl_name[$i] . " - Facies"); $line_cntr++; }
    if ($longitude[$i] >= ($dfsp2000 + 282.63333) And $longitude[$i] <= ($dfsp2000 + 284.63333)) { imagettftext($im, 9, 0, $x_text_position, $start_of_y_axis + (15 * $line_cntr), $black, 'arial.ttf', $pl_name[$i] . " - Ascella"); $line_cntr++; }
    if ($longitude[$i] >= ($dfsp2000 + 284.00000) And $longitude[$i] <= ($dfsp2000 + 286.00000)) { imagettftext($im, 9, 0, $x_text_position, $start_of_y_axis + (15 * $line_cntr), $black, 'arial.ttf', $pl_name[$i] . " - Manubrium"); $line_cntr++; }
    if ($longitude[$i] >= ($dfsp2000 + 288.80000) And $longitude[$i] <= ($dfsp2000 + 290.80000)) { imagettftext($im, 9, 0, $x_text_position, $start_of_y_axis + (15 * $line_cntr), $black, 'arial.ttf', $pl_name[$i] . " - Deneb"); $line_cntr++; }
    if ($longitude[$i] >= ($dfsp2000 + 294.85000) And $longitude[$i] <= ($dfsp2000 + 296.85000)) { imagettftext($im, 9, 0, $x_text_position, $start_of_y_axis + (15 * $line_cntr), $black, 'arial.ttf', $pl_name[$i] . " - Terebellum"); $line_cntr++; }

    if ($longitude[$i] >= ($dfsp2000 + 300.78333) And $longitude[$i] <= ($dfsp2000 + 302.78333)) { imagettftext($im, 9, 0, $x_text_position, $start_of_y_axis + (15 * $line_cntr), $black, 'arial.ttf', $pl_name[$i] . " - Altair"); $line_cntr++; }
    if ($longitude[$i] >= ($dfsp2000 + 303.71667) And $longitude[$i] <= ($dfsp2000 + 305.71667)) { imagettftext($im, 9, 0, $x_text_position, $start_of_y_axis + (15 * $line_cntr), $black, 'arial.ttf', $pl_name[$i] . " - Oculus"); $line_cntr++; }
    if ($longitude[$i] >= ($dfsp2000 + 304.16667) And $longitude[$i] <= ($dfsp2000 + 306.16667)) { imagettftext($im, 9, 0, $x_text_position, $start_of_y_axis + (15 * $line_cntr), $black, 'arial.ttf', $pl_name[$i] . " - Bos"); $line_cntr++; }
    if ($longitude[$i] >= ($dfsp2000 + 320.78333) And $longitude[$i] <= ($dfsp2000 + 322.78333)) { imagettftext($im, 9, 0, $x_text_position, $start_of_y_axis + (15 * $line_cntr), $black, 'arial.ttf', $pl_name[$i] . " - Nashira"); $line_cntr++; }
    if ($longitude[$i] >= ($dfsp2000 + 322.55000) And $longitude[$i] <= ($dfsp2000 + 324.55000)) { imagettftext($im, 9, 0, $x_text_position, $start_of_y_axis + (15 * $line_cntr), $black, 'arial.ttf', $pl_name[$i] . " - Deneb Algedi"); $line_cntr++; }
    if ($longitude[$i] >= ($dfsp2000 + 322.81667) And $longitude[$i] <= ($dfsp2000 + 324.81667)) { imagettftext($im, 9, 0, $x_text_position, $start_of_y_axis + (15 * $line_cntr), $black, 'arial.ttf', $pl_name[$i] . " - Sadalsuud"); $line_cntr++; }
    if ($longitude[$i] >= ($dfsp2000 + 334.33333) And $longitude[$i] <= ($dfsp2000 + 336.33333)) { imagettftext($im, 9, 0, $x_text_position, $start_of_y_axis + (15 * $line_cntr), $black, 'arial.ttf', $pl_name[$i] . " - Deneb Adige"); $line_cntr++; }
    if ($longitude[$i] >= ($dfsp2000 + 337.86667) And $longitude[$i] <= ($dfsp2000 + 339.86667)) { imagettftext($im, 9, 0, $x_text_position, $start_of_y_axis + (15 * $line_cntr), $black, 'arial.ttf', $pl_name[$i] . " - Skat"); $line_cntr++; }
    if ($longitude[$i] >= ($dfsp2000 + 344.31667) And $longitude[$i] <= ($dfsp2000 + 346.31667)) { imagettftext($im, 9, 0, $x_text_position, $start_of_y_axis + (15 * $line_cntr), $black, 'arial.ttf', $pl_name[$i] . " - Achernar"); $line_cntr++; }
  }

  $line_cntr++;


//planetary day and hour rulers start here, then strictures and warnings - we put these to the left of the wheel, at the top
  $left_col_print_idx = 2;

  drawboldtext($im, 12, 0, $left_col_print_idx - 2, $y_top_margin + 20, $red, 'arial.ttf', "Strictures, Warnings, Etc.", 0);

  $line_cntr = 1;

  $sunset_time = $_SESSION['sunset_time'];
  $sunrise_time = $_SESSION['sunrise_time'];
  $birth_time = $_SESSION['birth_time'];

  $day_num = $_SESSION['day_of_week'];

  if ($birth_time < $sunrise_time) { $day_num = $day_num - 1; }
  if ($day_num == -1) { $day_num = 6; }

  //print various horary information here
  if ($day_num == 0) { imagettftext($im, 10, 0, $left_col_print_idx, $y_top_margin + 20 + (15 * $line_cntr), $black, 'arial.ttf', "Planetary Day = Sun"); $line_cntr++; }
  if ($day_num == 1) { imagettftext($im, 10, 0, $left_col_print_idx, $y_top_margin + 20 + (15 * $line_cntr), $black, 'arial.ttf', "Planetary Day = Moon"); $line_cntr++; }
  if ($day_num == 2) { imagettftext($im, 10, 0, $left_col_print_idx, $y_top_margin + 20 + (15 * $line_cntr), $black, 'arial.ttf', "Planetary Day = Mars"); $line_cntr++; }
  if ($day_num == 3) { imagettftext($im, 10, 0, $left_col_print_idx, $y_top_margin + 20 + (15 * $line_cntr), $black, 'arial.ttf', "Planetary Day = Mercury"); $line_cntr++; }
  if ($day_num == 4) { imagettftext($im, 10, 0, $left_col_print_idx, $y_top_margin + 20 + (15 * $line_cntr), $black, 'arial.ttf', "Planetary Day = Jupiter"); $line_cntr++; }
  if ($day_num == 5) { imagettftext($im, 10, 0, $left_col_print_idx, $y_top_margin + 20 + (15 * $line_cntr), $black, 'arial.ttf', "Planetary Day = Venus"); $line_cntr++; }
  if ($day_num == 6) { imagettftext($im, 10, 0, $left_col_print_idx, $y_top_margin + 20 + (15 * $line_cntr), $black, 'arial.ttf', "Planetary Day = Saturn"); $line_cntr++; }

  $hour_num = 1;
  $the_base = $sunrise_time;
  $adder = 0;
  $the_interval = ($sunset_time - $sunrise_time) / 12;

  if ($birth_time >= $sunset_time Or $birth_time < $sunrise_time)
  {
    $the_base = $sunset_time;
    $adder = 12;
    $the_interval = (24 + $sunrise_time - $sunset_time) / 12;
  }

  $flag1 = 0;

  for ($ii = 0; $ii <= 99; $ii++)
  {
    $the_base = $the_base + $the_interval;

    if ($birth_time > 22 And $the_base >= 24 And $flag1 == 1) { $the_base = $the_base - 24; }

    if ($birth_time < 2.4 And $the_base >= 24 And $flag1 == 0)
    {
      $the_base = $the_base - 24;
      $flag1 = 1;
    }

    if ($the_base >= $birth_time And $birth_time >= $sunrise_time) { break; }
    if ($the_base >= $birth_time And $birth_time < $sunrise_time And $the_base < 12) { break; }

    $hour_num++;

    if ($the_base >= 24 And $flag1 == 0)
    {
      $the_base = $the_base - 24;
      $flag1 = 1;
    }
  }


  $the_index = $day_num * 24 + $hour_num + $adder;

  while ($the_index > 7)
  {
    $the_index = $the_index - 7;
  }

  if ($the_index == 1) { imagettftext($im, 10, 0, $left_col_print_idx, $y_top_margin + 20 + (15 * $line_cntr), $black, 'arial.ttf', "Planetary Hour = Sun"); $line_cntr++; }
  if ($the_index == 2) { imagettftext($im, 10, 0, $left_col_print_idx, $y_top_margin + 20 + (15 * $line_cntr), $black, 'arial.ttf', "Planetary Hour = Venus"); $line_cntr++; }
  if ($the_index == 3) { imagettftext($im, 10, 0, $left_col_print_idx, $y_top_margin + 20 + (15 * $line_cntr), $black, 'arial.ttf', "Planetary Hour = Mercury"); $line_cntr++; }
  if ($the_index == 4) { imagettftext($im, 10, 0, $left_col_print_idx, $y_top_margin + 20 + (15 * $line_cntr), $black, 'arial.ttf', "Planetary Hour = Moon"); $line_cntr++; }
  if ($the_index == 5) { imagettftext($im, 10, 0, $left_col_print_idx, $y_top_margin + 20 + (15 * $line_cntr), $black, 'arial.ttf', "Planetary Hour = Saturn"); $line_cntr++; }
  if ($the_index == 6) { imagettftext($im, 10, 0, $left_col_print_idx, $y_top_margin + 20 + (15 * $line_cntr), $black, 'arial.ttf', "Planetary Hour = Jupiter"); $line_cntr++; }
  if ($the_index == 7) { imagettftext($im, 10, 0, $left_col_print_idx, $y_top_margin + 20 + (15 * $line_cntr), $black, 'arial.ttf', "Planetary Hour = Mars"); $line_cntr++; }


  //strictures and warnings now follow
  $t = $hc[1];

  while ($t >= 30) { $t = $t - 30; }

  if ($t >= 0 And $t < 3) { imagettftext($im, 10, 0, $left_col_print_idx, $y_top_margin + 20 + (15 * $line_cntr), $black, 'arial.ttf', "Ascendant is early."); $line_cntr++; }
  if ($t >= 27 And $t < 30) { imagettftext($im, 10, 0, $left_col_print_idx, $y_top_margin + 20 + (15 * $line_cntr), $black, 'arial.ttf', "Ascendant is late."); $line_cntr++; }
  if ($house_pos1[SE_SATURN] == 1) { imagettftext($im, 10, 0, $left_col_print_idx, $y_top_margin + 20 + (15 * $line_cntr), $black, 'arial.ttf', "Saturn is in the 1st house."); $line_cntr++; }
  if ($house_pos1[SE_SATURN] == 7) { imagettftext($im, 10, 0, $left_col_print_idx, $y_top_margin + 20 + (15 * $line_cntr), $black, 'arial.ttf', "Saturn is in the 7th house."); $line_cntr++; }
  if ($hc[7] >= 270 And $hc[7] < 330) { imagettftext($im, 10, 0, $left_col_print_idx, $y_top_margin + 20 + (15 * $line_cntr), $black, 'arial.ttf', "Saturn is the ruler of the 7th house."); $line_cntr++; }


  $t = $longitude[SE_MOON];

  while ($t >= 30) { $t = $t - 30; }

  if ($t >= 27) { imagettftext($im, 10, 0, $left_col_print_idx, $y_top_margin + 20 + (15 * $line_cntr), $black, 'arial.ttf', "Moon is in later degree."); $line_cntr++; }
  if ($longitude[SE_MOON] >= 195 And $longitude[SE_MOON] < 225) { imagettftext($im, 10, 0, $left_col_print_idx, $y_top_margin + 20 + (15 * $line_cntr), $black, 'arial.ttf', "Moon is in Via Combusta."); $line_cntr++; }
  if ($hc[1] >= 195 And $hc[1] < 225) { imagettftext($im, 10, 0, $left_col_print_idx, $y_top_margin + 20 + (15 * $line_cntr), $black, 'arial.ttf', "Ascendant is in Via Combusta."); $line_cntr++; }

  $sign_of_7th = floor($hc[7] / 30) + 1;

  if (($sign_of_7th == 1 Or $sign_of_7th == 8) And $speed1[SE_MARS] < 0) { imagettftext($im, 10, 0, $left_col_print_idx, $y_top_margin + 20 + (15 * $line_cntr), $black, 'arial.ttf', "Ruler of the 7th house [Mars] is Rx."); $line_cntr++; }
  if (($sign_of_7th == 2 Or $sign_of_7th == 7) And $speed1[SE_VENUS] < 0) { imagettftext($im, 10, 0, $left_col_print_idx, $y_top_margin + 20 + (15 * $line_cntr), $black, 'arial.ttf', "Ruler of the 7th house [Venus] is Rx."); $line_cntr++; }
  if (($sign_of_7th == 3 Or $sign_of_7th == 6) And $speed1[SE_MERCURY] < 0) { imagettftext($im, 10, 0, $left_col_print_idx, $y_top_margin + 20 + (15 * $line_cntr), $black, 'arial.ttf', "Ruler of the 7th house [Mercury] is Rx."); $line_cntr++; }
  if (($sign_of_7th == 9 Or $sign_of_7th == 12) And $speed1[SE_JUPITER] < 0) { imagettftext($im, 10, 0, $left_col_print_idx, $y_top_margin + 20 + (15 * $line_cntr), $black, 'arial.ttf', "Ruler of the 7th house [Jupiter] is Rx."); $line_cntr++; }
  if (($sign_of_7th == 10 Or $sign_of_7th == 11) And $speed1[SE_SATURN] < 0) { imagettftext($im, 10, 0, $left_col_print_idx, $y_top_margin + 20 + (15 * $line_cntr), $black, 'arial.ttf', "Ruler of the 7th house [Saturn] is Rx."); $line_cntr++; }

  $line_cntr++;



//here is where is will list the aspects found - this is to the left of the chartwheel
//display planet aspects
  drawboldtext($im, 12, 0, $left_col_print_idx, $y_top_margin + 20 + (15 * $line_cntr), $red, 'arial.ttf', "W. Lilly Aspects", 0);

  $line_cntr++;

  for ($i = SE_SUN; $i <= SE_PLUTO; $i++)
  {
    for ($j = $i + 1; $j <= SE_TNNODE; $j++)
    {
      $xbuf = "";
      $q = 0;
      $dayy = $longitude[$i] - $longitude[$j];
      $da = abs($longitude[$i] - $longitude[$j]);

      if ($da > 180) { $da = 360 - $da; }

      $orb = $moiety[$i] + $moiety[$j];

      // is there an aspect within orb?
      if ($da <= $orb)
      {
        $q = 1;
        $da = $da;
      }
      elseif (($da <= (60 + $orb)) And ($da >= (60 - $orb)))
      {
        $q = 6;
        $da = $da - 60;
      }
      elseif (($da <= (90 + $orb)) And ($da >= (90 - $orb)))
      {
        $q = 4;
        $da = $da - 90;
      }
      elseif (($da <= (120 + $orb)) And ($da >= (120 - $orb)))
      {
        $q = 3;
        $da = $da - 120;
      }
//      elseif (($da <= (150 + $orb)) And ($da >= (150 - $orb)))
//      {
//        $q = 5;
//        $da = $da - 150;
//      }
      elseif ($da >= (180 - $orb))
      {
        $q = 2;
        $da = 180 - $da;
      }

      $daxx = $da;
      $da = abs($da);

      if ($q > 0)
      {
    //determine applying or separating here
        $da1 = $da;               //save for later restoration
        $daxx1 = $daxx;
        $dayy1 = $dayy;

        $p1 = $longitude[$i] + $speed[$i];
        $p2 = $longitude[$j] + $speed[$j];

        $dayy = $p1 - $p2;
        $da = abs($p1 - $p2);

        if ($da > 180) { $da = 360 - $da; }

        if ($q == 6)
        {
          $da = $da - 60;
        }
        elseif ($q == 4)
        {
          $da = $da - 90;
        }
        elseif ($q == 3)
        {
          $da = $da - 120;
        }
        elseif ($q == 5)
        {
          $da = $da - 150;
        }
        elseif ($q == 2)
        {
          $da = $da - 180;
        }

        $daxx = $da;
        $da = abs($da);

        if (abs($da) <= abs($da1))
        {
          $xbuf .= "app";
        }
        elseif ((sgnx($daxx1) <= 0 And sgnx($daxx) >= 0) Or (sgnx($daxx1) >= 0 And sgnx($daxx) <= 0))
        {
          $xbuf .= "app";
        }
        elseif (($dayy > 350 And $dayy1 < 10) Or ($dayy < 10 And $dayy1 > 350))
        {
          $xbuf .= "app";
        }
        elseif ((sgnx($dayy1) <= 0 And sgnx($dayy) >= 0) Or (sgnx($dayy1) >= 0 And sgnx($dayy) <= 0))
        {
          $xbuf .= "app";
        }
        elseif ($q == 2 And ((abs($dayy1) < 180 And abs($dayy) >= 180) Or (abs($dayy1) >= 180 And abs($dayy) < 180)))
        {
          $xbuf .= "app";
        }
        else
        {
          $xbuf .= "sep";
        }

        $da = $da1;
        $daxx = $daxx1;
        $dayy = $dayy1;


        if ($daxx >= -.0166666 And $daxx <= .0166666)
        {
          $xbuf .= "partile";
        }
        elseif ($q != 1 And (($dayy < 0 And abs($dayy) < 180) Or ($dayy > 0 And abs($dayy) > 180)))
        {
          $xbuf .= ", sin ";
        }
        elseif ($q != 1 And (($dayy > 0 And abs($dayy) < 180) Or ($dayy < 0 And abs($dayy) > 180)))
        {
          $xbuf .= ", dex ";
        }


        // aspect exists
        if ($j == SE_TNNODE And $q != 1) { continue; }

        $t = chr($pl_glyph[$i]) . "   " . chr($asp_glyph[$q]) . "   " . chr($pl_glyph[$j]) . "   " . sprintf("%.2f", $da);
        imagettftext($im, 10, 0, $left_col_print_idx, $y_top_margin + 20 + (15 * $line_cntr), $black, 'HamburgSymbols.ttf', $t);
        imagettftext($im, 10, 0, 110, $y_top_margin + 20 + (15 * $line_cntr), $black, 'arial.ttf', $xbuf);

        $line_cntr++;
      }
    }
  }

  $line_cntr++;
  $end_of_aspect_listing_height = $y_top_margin + 20 + (15 * $line_cntr);

//  imagettftext($im, 10, 0, $left_col_print_idx, $end_of_aspect_listing_height, $black, 'arial.ttf', "end of aspect listing");


//start the mutual reception listing here
  $end_of_aspect_listing_height = $end_of_aspect_listing_height;

//mutual receptions - by sign
  imagettftext($im, 12, 0, $left_col_print_idx, $end_of_aspect_listing_height, $red, 'arial.ttf', "Mutual Receptions");
  $end_of_aspect_listing_height = $end_of_aspect_listing_height + 15;

  for ($i = SE_SUN; $i <= SE_SATURN; $i++)
  {
    $t = floor($longitude[$i] / 30) + 1;      //get the sign of the first planet

    if ($t == 1 Or $t == 8) { $x = SE_MARS; }
    if ($t == 2 Or $t == 7) { $x = SE_VENUS; }
    if ($t == 3 Or $t == 6) { $x = SE_MERCURY; }
    if ($t == 4) { $x = SE_MOON; }
    if ($t == 5) { $x = SE_SUN; }
    if ($t == 9 Or $t == 12) { $x = SE_JUPITER; }
    if ($t == 10 Or $t == 11) { $x = SE_SATURN; }

    $t = floor($longitude[$x] / 30) + 1;      //get the sign of the second planet

    if ($i == SE_SUN And $x > $i And $t == 5)
    {
      imagettftext($im, 9, 0, $left_col_print_idx, $end_of_aspect_listing_height, $black, 'arial.ttf', $pl_name[$i] . "-" . $pl_name[$x] . " by sign");
      $end_of_aspect_listing_height = $end_of_aspect_listing_height + 15;
    }

    if ($i == SE_MOON And $x > $i And $t == 4)
    {
      imagettftext($im, 9, 0, $left_col_print_idx, $end_of_aspect_listing_height, $black, 'arial.ttf', $pl_name[$i] . "-" . $pl_name[$x] . " by sign");
      $end_of_aspect_listing_height = $end_of_aspect_listing_height + 15;
    }

    if ($i == SE_MERCURY And $x > $i And ($t == 3 Or $t == 6))
    {
      imagettftext($im, 9, 0, $left_col_print_idx, $end_of_aspect_listing_height, $black, 'arial.ttf', $pl_name[$i] . "-" . $pl_name[$x] . " by sign");
      $end_of_aspect_listing_height = $end_of_aspect_listing_height + 15;
    }

    if ($i == SE_VENUS And $x > $i And ($t == 2 Or $t == 7))
    {
      imagettftext($im, 9, 0, $left_col_print_idx, $end_of_aspect_listing_height, $black, 'arial.ttf', $pl_name[$i] . "-" . $pl_name[$x] . " by sign");
      $end_of_aspect_listing_height = $end_of_aspect_listing_height + 15;
    }

    if ($i == SE_MARS And $x > $i And ($t == 1 Or $t == 8))
    {
      imagettftext($im, 9, 0, $left_col_print_idx, $end_of_aspect_listing_height, $black, 'arial.ttf', $pl_name[$i] . "-" . $pl_name[$x] . " by sign");
      $end_of_aspect_listing_height = $end_of_aspect_listing_height + 15;
    }

    if ($i == SE_JUPITER And $x > $i And ($t == 9 Or $t == 12))
    {
      imagettftext($im, 9, 0, $left_col_print_idx, $end_of_aspect_listing_height, $black, 'arial.ttf', $pl_name[$i] . "-" . $pl_name[$x] . " by sign");
      $end_of_aspect_listing_height = $end_of_aspect_listing_height + 15;
    }

    if ($i == SE_SATURN And $x > $i And ($t == 10 Or $t == 11))
    {
      imagettftext($im, 9, 0, $left_col_print_idx, $end_of_aspect_listing_height, $black, 'arial.ttf', $pl_name[$i] . "-" . $pl_name[$x] . " by sign");
      $end_of_aspect_listing_height = $end_of_aspect_listing_height + 15;
    }
  }


//mutual receptions - by exaltation
  for ($i = SE_SUN; $i <= SE_SATURN; $i++)
  {
    $t = floor($longitude[$i] / 30) + 1;      //get the sign of the first planet

    if ($t == 3 Or $t == 5 Or $t == 8 Or $t == 9 Or $t == 11) { continue; }

    if ($t == 1) { $x = SE_SUN; }
    if ($t == 2) { $x = SE_MOON; }
    if ($t == 4) { $x = SE_JUPITER; }
    if ($t == 6) { $x = SE_MERCURY; }
    if ($t == 7) { $x = SE_SATURN; }
    if ($t == 10) { $x = SE_MARS; }
    if ($t == 12) { $x = SE_VENUS; }

    $t = floor($longitude[$x] / 30) + 1;      //get the sign of the second planet

    if ($i == SE_SUN And $x > $i And $t == 1)
    {
      imagettftext($im, 9, 0, $left_col_print_idx, $end_of_aspect_listing_height, $black, 'arial.ttf', $pl_name[$i] . "-" . $pl_name[$x] . " by exaltation");
      $end_of_aspect_listing_height = $end_of_aspect_listing_height + 15;
    }

    if ($i == SE_MOON And $x > $i And $t == 2)
    {
      imagettftext($im, 9, 0, $left_col_print_idx, $end_of_aspect_listing_height, $black, 'arial.ttf', $pl_name[$i] . "-" . $pl_name[$x] . " by exaltation");
      $end_of_aspect_listing_height = $end_of_aspect_listing_height + 15;
    }

    if ($i == SE_MERCURY And $x > $i And $t == 6)
    {
      imagettftext($im, 9, 0, $left_col_print_idx, $end_of_aspect_listing_height, $black, 'arial.ttf', $pl_name[$i] . "-" . $pl_name[$x] . " by exaltation");
      $end_of_aspect_listing_height = $end_of_aspect_listing_height + 15;
    }

    if ($i == SE_VENUS And $x > $i And $t == 12)
    {
      imagettftext($im, 9, 0, $left_col_print_idx, $end_of_aspect_listing_height, $black, 'arial.ttf', $pl_name[$i] . "-" . $pl_name[$x] . " by exaltation");
      $end_of_aspect_listing_height = $end_of_aspect_listing_height + 15;
    }

    if ($i == SE_MARS And $x > $i And $t == 10)
    {
      imagettftext($im, 9, 0, $left_col_print_idx, $end_of_aspect_listing_height, $black, 'arial.ttf', $pl_name[$i] . "-" . $pl_name[$x] . " by exaltation");
      $end_of_aspect_listing_height = $end_of_aspect_listing_height + 15;
    }

    if ($i == SE_JUPITER And $x > $i And $t == 4)
    {
      imagettftext($im, 9, 0, $left_col_print_idx, $end_of_aspect_listing_height, $black, 'arial.ttf', $pl_name[$i] . "-" . $pl_name[$x] . " by exaltation");
      $end_of_aspect_listing_height = $end_of_aspect_listing_height + 15;
    }

    if ($i == SE_SATURN And $x > $i And $t == 7)
    {
      imagettftext($im, 9, 0, $left_col_print_idx, $end_of_aspect_listing_height, $black, 'arial.ttf', $pl_name[$i] . "-" . $pl_name[$x] . " by exaltation");
      $end_of_aspect_listing_height = $end_of_aspect_listing_height + 15;
    }
  }


//mutual receptions - by sign/exaltation
  for ($i = SE_SUN; $i <= SE_SATURN; $i++)
  {
    $t = floor($longitude[$i] / 30) + 1;      //get the sign of the first planet

    if ($t == 3 Or $t == 5 Or $t == 8 Or $t == 9 Or $t == 11) { continue; }

    if ($t == 1) { $x = SE_SUN; }
    if ($t == 2) { $x = SE_MOON; }
    if ($t == 4) { $x = SE_JUPITER; }
    if ($t == 6) { $x = SE_MERCURY; }
    if ($t == 7) { $x = SE_SATURN; }
    if ($t == 10) { $x = SE_MARS; }
    if ($t == 12) { $x = SE_VENUS; }

    $t = floor($longitude[$x] / 30) + 1;      //get the sign of the second planet

    if ($i == SE_SUN And $t == 5)
    {
      imagettftext($im, 9, 0, $left_col_print_idx, $end_of_aspect_listing_height, $black, 'arial.ttf', $pl_name[$i] . "-" . $pl_name[$x] . " by sign/exaltation");
      $end_of_aspect_listing_height = $end_of_aspect_listing_height + 15;
    }

    if ($i == SE_MOON And $t == 4)
    {
      imagettftext($im, 9, 0, $left_col_print_idx, $end_of_aspect_listing_height, $black, 'arial.ttf', $pl_name[$i] . "-" . $pl_name[$x] . " by sign/exaltation");
      $end_of_aspect_listing_height = $end_of_aspect_listing_height + 15;
    }

    if ($i == SE_MERCURY And ($t == 3 Or $t == 6))
    {
      imagettftext($im, 9, 0, $left_col_print_idx, $end_of_aspect_listing_height, $black, 'arial.ttf', $pl_name[$i] . "-" . $pl_name[$x] . " by sign/exaltation");
      $end_of_aspect_listing_height = $end_of_aspect_listing_height + 15;
    }

    if ($i == SE_VENUS And ($t == 2 Or $t == 7))
    {
      imagettftext($im, 9, 0, $left_col_print_idx, $end_of_aspect_listing_height, $black, 'arial.ttf', $pl_name[$i] . "-" . $pl_name[$x] . " by sign/exaltation");
      $end_of_aspect_listing_height = $end_of_aspect_listing_height + 15;
    }

    if ($i == SE_MARS And ($t == 1 Or $t == 8))
    {
      imagettftext($im, 9, 0, $left_col_print_idx, $end_of_aspect_listing_height, $black, 'arial.ttf', $pl_name[$i] . "-" . $pl_name[$x] . " by sign/exaltation");
      $end_of_aspect_listing_height = $end_of_aspect_listing_height + 15;
    }

    if ($i == SE_JUPITER And ($t == 9 Or $t == 12))
    {
      imagettftext($im, 9, 0, $left_col_print_idx, $end_of_aspect_listing_height, $black, 'arial.ttf', $pl_name[$i] . "-" . $pl_name[$x] . " by sign/exaltation");
      $end_of_aspect_listing_height = $end_of_aspect_listing_height + 15;
    }

    if ($i == SE_SATURN And ($t == 10 Or $t == 11))
    {
      imagettftext($im, 9, 0, $left_col_print_idx, $end_of_aspect_listing_height, $black, 'arial.ttf', $pl_name[$i] . "-" . $pl_name[$x] . " by sign/exaltation");
      $end_of_aspect_listing_height = $end_of_aspect_listing_height + 15;
    }
  }


//mutual receptions (outer planets) - by sign
  for ($i = SE_SUN; $i <= SE_PLUTO; $i++)
  {
    $t = floor($longitude[$i] / 30) + 1;      //get the sign of the first planet

    $x = 0;

    if ($t == 8) { $x = SE_PLUTO; }
    if ($t == 12) { $x = SE_NEPTUNE; }
    if ($t == 11) { $x = SE_URANUS; }

    $t = floor($longitude[$x] / 30) + 1;      //get the sign of the second planet

    if ($i == SE_SUN And $x > $i And $t == 5)
    {
      imagettftext($im, 9, 0, $left_col_print_idx, $end_of_aspect_listing_height, $black, 'arial.ttf', $pl_name[$i] . "-" . $pl_name[$x] . " by sign");
      $end_of_aspect_listing_height = $end_of_aspect_listing_height + 15;
    }

    if ($i == SE_MOON And $x > $i And $t == 4)
    {
      imagettftext($im, 9, 0, $left_col_print_idx, $end_of_aspect_listing_height, $black, 'arial.ttf', $pl_name[$i] . "-" . $pl_name[$x] . " by sign");
      $end_of_aspect_listing_height = $end_of_aspect_listing_height + 15;
    }

    if ($i == SE_MERCURY And $x > $i And ($t == 3 Or $t == 6))
    {
      imagettftext($im, 9, 0, $left_col_print_idx, $end_of_aspect_listing_height, $black, 'arial.ttf', $pl_name[$i] . "-" . $pl_name[$x] . " by sign");
      $end_of_aspect_listing_height = $end_of_aspect_listing_height + 15;
    }

    if ($i == SE_VENUS And $x > $i And ($t == 2 Or $t == 7))
    {
      imagettftext($im, 9, 0, $left_col_print_idx, $end_of_aspect_listing_height, $black, 'arial.ttf', $pl_name[$i] . "-" . $pl_name[$x] . " by sign");
      $end_of_aspect_listing_height = $end_of_aspect_listing_height + 15;
    }

    if ($i == SE_MARS And $x > $i And ($t == 1 Or $t == 8))
    {
      imagettftext($im, 9, 0, $left_col_print_idx, $end_of_aspect_listing_height, $black, 'arial.ttf', $pl_name[$i] . "-" . $pl_name[$x] . " by sign");
      $end_of_aspect_listing_height = $end_of_aspect_listing_height + 15;
    }

    if ($i == SE_JUPITER And $x > $i And ($t == 9 Or $t == 12))
    {
      imagettftext($im, 9, 0, $left_col_print_idx, $end_of_aspect_listing_height, $black, 'arial.ttf', $pl_name[$i] . "-" . $pl_name[$x] . " by sign");
      $end_of_aspect_listing_height = $end_of_aspect_listing_height + 15;
    }

    if ($i == SE_SATURN And $x > $i And ($t == 10 Or $t == 11))
    {
      imagettftext($im, 9, 0, $left_col_print_idx, $end_of_aspect_listing_height, $black, 'arial.ttf', $pl_name[$i] . "-" . $pl_name[$x] . " by sign");
      $end_of_aspect_listing_height = $end_of_aspect_listing_height + 15;
    }

    if ($i == SE_URANUS And $x > $i And $t == 11)
    {
      imagettftext($im, 9, 0, $left_col_print_idx, $end_of_aspect_listing_height, $black, 'arial.ttf', $pl_name[$i] . "-" . $pl_name[$x] . " by sign");
      $end_of_aspect_listing_height = $end_of_aspect_listing_height + 15;
    }

    if ($i == SE_NEPTUNE And $x > $i And $t == 12)
    {
      imagettftext($im, 9, 0, $left_col_print_idx, $end_of_aspect_listing_height, $black, 'arial.ttf', $pl_name[$i] . "-" . $pl_name[$x] . " by sign");
      $end_of_aspect_listing_height = $end_of_aspect_listing_height + 15;
    }

    if ($i == SE_PLUTO And $x > $i And $t == 8)
    {
      imagettftext($im, 9, 0, $left_col_print_idx, $end_of_aspect_listing_height, $black, 'arial.ttf', $pl_name[$i] . "-" . $pl_name[$x] . " by sign");
      $end_of_aspect_listing_height = $end_of_aspect_listing_height + 15;
    }
  }


//draw the border around the whole table
  imageline($im, $left_col_print_idx, $start_of_y_axis, $overall_size + $extra_width_for_graphic_data_table - $left_col_print_idx, $start_of_y_axis, $black);       //horizontal line above table
  imageline($im, $left_col_print_idx, $start_of_y_axis, $left_col_print_idx, $start_of_y_axis + $_SESSION['pl_asp_height_planets'] - 30, $black);             //left side line
  imageline($im, $overall_size + $extra_width_for_graphic_data_table - $left_col_print_idx, $start_of_y_axis, $overall_size + $extra_width_for_graphic_data_table - $left_col_print_idx, $start_of_y_axis + $_SESSION['pl_asp_height_planets'] - 30, $black);   //right side line
  imageline($im, $left_col_print_idx, $start_of_y_axis, $overall_size + $extra_width_for_graphic_data_table - $left_col_print_idx, $start_of_y_axis, $black);       //horizontal line above table
  imageline($im, $left_col_print_idx, $start_of_y_axis + $_SESSION['pl_asp_height_planets'] - 30, $overall_size + $extra_width_for_graphic_data_table - $left_col_print_idx, $start_of_y_axis + $_SESSION['pl_asp_height_planets'] - 30, $black);   //horizontal line below table


//display the Moon's aspects
  $moon_asp_details = $_SESSION['moon_asp_details'];
  $num_moon_aspects = $_SESSION['num_moon_aspects'];

  $x_text_start = 7;
  $line_num = 2;
  $new_y_pos = $start_of_y_axis;

  drawboldtext($im, 10, 0, $x_text_start + 22, $start_of_y_axis + 15, $red, 'arial.ttf', "Moon Aspectarian", 0);

  // display the aspects of the Moon
  for ($x = 1; $x <= $num_moon_aspects; $x++)
  {
    $flag = 0;
    if ($x < $num_moon_aspects)
    {
      if (stristr($moon_asp_details[1][$x + 1], chr(42) . chr(42)) == True)   //look for '**'
      {
        //next entry after the present one is ** Moon entering a new sign - that makes this entry VC
        imagettftext($im, 8, 0, $x_text_start + 5, $new_y_pos + 15 * $line_num, $blue, 'verdana.ttf', "VC");
        imagettftext($im, 10, 0, $x_text_start + 20, $new_y_pos + 15 * $line_num, $black, 'HamburgSymbols.ttf', chr($pl_glyph[$moon_asp_details[2][$x]]));
        imagettftext($im, 10, 0, $x_text_start + 39, $new_y_pos + 15 * $line_num, $black, 'HamburgSymbols.ttf', chr($asp_glyph[$moon_asp_details[5][$x]]));
        imagettftext($im, 10, 0, $x_text_start + 56, $new_y_pos + 15 * $line_num, $black, 'HamburgSymbols.ttf', chr($pl_glyph[$moon_asp_details[6][$x]]));
        imagettftext($im, 10, 0, $x_text_start + 72, $new_y_pos + 15 * $line_num, $black, 'HamburgSymbols.ttf', chr($moon_asp_details[7][$x]));
        imagettftext($im, 8, 0, $x_text_start + 87, $new_y_pos + 15 * $line_num, $black, 'verdana.ttf', "- " . $moon_asp_details[10][$x]);

        $line_num = $line_num + 1;

        $flag = 1;
      }
      else
      {
        if (stristr($moon_asp_details[1][$x], chr(42) . chr(42)) == False)    //look for '**'
        {
          imagettftext($im, 10, 0, $x_text_start + 20, $new_y_pos + 15 * $line_num, $black, 'HamburgSymbols.ttf', chr($pl_glyph[$moon_asp_details[2][$x]]));
          imagettftext($im, 10, 0, $x_text_start + 39, $new_y_pos + 15 * $line_num, $black, 'HamburgSymbols.ttf', chr($asp_glyph[$moon_asp_details[5][$x]]));
          imagettftext($im, 10, 0, $x_text_start + 56, $new_y_pos + 15 * $line_num, $black, 'HamburgSymbols.ttf', chr($pl_glyph[$moon_asp_details[6][$x]]));
          imagettftext($im, 10, 0, $x_text_start + 72, $new_y_pos + 15 * $line_num, $black, 'HamburgSymbols.ttf', chr($moon_asp_details[7][$x]));
          imagettftext($im, 8, 0, $x_text_start + 87, $new_y_pos + 15 * $line_num, $black, 'verdana.ttf', "- " . $moon_asp_details[10][$x]);
        }
        else
        {
          imagettftext($im, 8, 0, $x_text_start + 5, $new_y_pos + 15 * $line_num, $black, 'verdana.ttf', chr(42) . chr(42));
          imagettftext($im, 10, 0, $x_text_start + 20, $new_y_pos + 15 * $line_num, $black, 'HamburgSymbols.ttf', chr($pl_glyph[$moon_asp_details[2][$x]]));
          imagettftext($im, 8, 0, $x_text_start + 33, $new_y_pos + 15 * $line_num, $black, 'verdana.ttf', "enters");
          imagettftext($im, 10, 0, $x_text_start + 72, $new_y_pos + 15 * $line_num, $black, 'HamburgSymbols.ttf', chr($sign_glyph[$moon_asp_details[4][$x]]));
          imagettftext($im, 8, 0, $x_text_start + 87, $new_y_pos + 15 * $line_num, $black, 'verdana.ttf', "- " . $moon_asp_details[10][$x]);
        }
      }
    }
    else
    {
      if (stristr($moon_asp_details[1][$x], chr(42) . chr(42)) == False)
      {
        imagettftext($im, 10, 0, $x_text_start + 20, $new_y_pos + 15 * $line_num, $black, 'HamburgSymbols.ttf', chr($pl_glyph[$moon_asp_details[2][$x]]));
        imagettftext($im, 10, 0, $x_text_start + 39, $new_y_pos + 15 * $line_num, $black, 'HamburgSymbols.ttf', chr($asp_glyph[$moon_asp_details[5][$x]]));
        imagettftext($im, 10, 0, $x_text_start + 56, $new_y_pos + 15 * $line_num, $black, 'HamburgSymbols.ttf', chr($pl_glyph[$moon_asp_details[6][$x]]));
        imagettftext($im, 10, 0, $x_text_start + 72, $new_y_pos + 15 * $line_num, $black, 'HamburgSymbols.ttf', chr($moon_asp_details[7][$x]));
        imagettftext($im, 8, 0, $x_text_start + 87, $new_y_pos + 15 * $line_num, $black, 'verdana.ttf', "- " . $moon_asp_details[10][$x]);
      }
      else
      {
        imagettftext($im, 8, 0, $x_text_start + 5, $new_y_pos + 15 * $line_num, $black, 'verdana.ttf', chr(42) . chr(42));
        imagettftext($im, 10, 0, $x_text_start + 20, $new_y_pos + 15 * $line_num, $black, 'HamburgSymbols.ttf', chr($pl_glyph[$moon_asp_details[2][$x]]));
        imagettftext($im, 8, 0, $x_text_start + 33, $new_y_pos + 15 * $line_num, $black, 'verdana.ttf', "enters");
        imagettftext($im, 10, 0, $x_text_start + 72, $new_y_pos + 15 * $line_num, $black, 'HamburgSymbols.ttf', chr($sign_glyph[$moon_asp_details[4][$x]]));
        imagettftext($im, 8, 0, $x_text_start + 87, $new_y_pos + 15 * $line_num, $black, 'verdana.ttf', "- " . $moon_asp_details[10][$x]);
      }
    }

    $line_num = $line_num + 1;

    if ($flag == 0)
    {
      if (jdtogregorian($moon_asp_details[0][$x] + 0.5) != jdtogregorian($moon_asp_details[0][$x + 1] + 0.5))
      {
        $line_num = $line_num + 1;
      }
    }
  }


// draw the image in png format - using imagepng() results in clearer text compared with imagejpeg()
  $hash_x = $_SESSION['hash_x'];

  imagepng($im);

  imagepng($im, "./downloads/" . $hash_x . ".png");     //output image to a file

  imagedestroy($im);
  exit();


Function mid($midstring, $midstart, $midlength)
{
  return(substr($midstring, $midstart-1, $midlength));
}


Function Reduce_below_30($longitude)
{
  $lng = $longitude;

  while ($lng >= 30)
  {
    $lng = $lng - 30;
  }

  return $lng;
}


Function safeEscapeString($conn, $string)
{
// replace HTML tags '<>' with '[]'
  $temp1 = str_replace("<", "[", $string);
  $temp2 = str_replace(">", "]", $temp1);

// but keep <br> or <br />
// turn <br> into <br /> so later it will be turned into ""
// using just <br> will add extra blank lines
  $temp1 = str_replace("[br]", "<br />", $temp2);
  $temp2 = str_replace("[br /]", "<br />", $temp1);

  if (get_magic_quotes_gpc())
  {
    return $temp2;
  }
  else
  {
    return mysqli_real_escape_string($conn, $temp2);
  }
}


Function Sort_planets_by_descending_longitude($num_planets, $longitude, &$sort, &$sort_pos)
{
// load all $longitude() into sort() and keep track of the planet numbers in $sort_pos()
  for ($i = 0; $i <= $num_planets - 1; $i++)
  {
    $sort[$i] = $longitude[$i];
    $sort_pos[$i] = $i;
  }

// do the actual sort
  for ($i = 0; $i <= $num_planets - 2; $i++)
  {
    for ($j = $i + 1; $j <= $num_planets - 1; $j++)
    {
      if ($sort[$j] > $sort[$i])
      {
        $temp = $sort[$i];
        $temp1 = $sort_pos[$i];

        $sort[$i] = $sort[$j];
        $sort_pos[$i] = $sort_pos[$j];

        $sort[$j] = $temp;
        $sort_pos[$j] = $temp1;
      }
    }
  }
}


Function Count_planets_in_each_house($num_planets, $house_pos, &$sort_pos, &$sort, &$nopih, &$home)
{
// reset and count the number of planets in each house
  for ($i = 1; $i <= 12; $i++)
  {
    $nopih[$i] = 0;
  }

// run through all the planets and see how many planets are in each house
  for ($i = 0; $i <= $num_planets - 1; $i++)
  {
    $temp = $house_pos[$sort_pos[$i]];

    // get house planet is in
    $nopih[$temp]++;

    $home[$i] = $temp;
  }

  // now check for Aries planets in same house as Pisces planets that do not start a new house
  while ($home[$num_planets - 1] == $home[0])
  {
    $temp1 = $sort[$num_planets - 1];
    $temp2 = $sort_pos[$num_planets - 1];
    $temp3 = $home[$num_planets - 1];

    for ($i = $num_planets - 1; $i >= 1; $i--)
    {
      $sort[$i] = $sort[$i - 1];
      $sort_pos[$i] = $sort_pos[$i - 1];
      $home[$i] = $home[$i - 1];
    }

    $sort[0] = $temp1;
    $sort_pos[0] = $temp2;
    $home[0] = $temp3;
  }
}


Function display_house_number_new($num, $angle, $radii, &$xy)
{
  if ($num < 10)
  {
    $char_width = 10;
  }
  else
  {
    $char_width = 18;
  }
  $half_char_width = $char_width / 2;
  $char_height = 12;
  $half_char_height = $char_height / 2;
  $quarter_char_height = $char_height / 4;

//puts center of character right on circumference of imaginary circle
  $xpos0 = -$half_char_width;
  $ypos0 = $char_height;

  if ($num == 1)
  {
    $radii = $radii + 1;

    $x_adj = -cos(deg2rad($angle)) * $half_char_width;
    $ypos0 = $half_char_height - ($half_char_height / 2);
    $y_adj = sin(deg2rad($angle)) * $char_height;
  }
  elseif ($num == 2)
  {
    $radii = $radii + 3;

    $x_adj = -cos(deg2rad($angle));
    $ypos0 = $half_char_height - ($half_char_height / 2);
    $y_adj = sin(deg2rad($angle)) * $char_height;
  }
  elseif ($num == 3)
  {
    $xpos0 = -$half_char_width;
    $x_adj = -cos(deg2rad($angle)) * $half_char_width;
    $ypos0 = $char_height - 4;
    $y_adj = sin(deg2rad($angle)) * $half_char_height;
  }
  elseif ($num == 4)
  {
    $xpos0 = -$half_char_width;
    $x_adj = -cos(deg2rad($angle)) * $half_char_width;
    $ypos0 = $char_height - 2;
    $y_adj = sin(deg2rad($angle)) * $half_char_height;
  }
  elseif ($num == 5)
  {
    $xpos0 = 3;
    $x_adj = -cos(deg2rad($angle)) * $half_char_width;
    $ypos0 = $half_char_height;
    $y_adj = sin(deg2rad($angle)) * $half_char_height;
  }
  elseif ($num == 6)
  {
    $radii = $radii + 5;

    $xpos0 = $half_char_width / 2;
    $x_adj = -cos(deg2rad($angle));
    $ypos0 = $half_char_height;
    $y_adj = sin(deg2rad($angle)) * char_height;
  }
  elseif ($num == 7)
  {
    $radii = $radii + 3;

    $x_adj = -cos(deg2rad($angle)) * $char_width;
    $ypos0 = 0;
    $y_adj = -sin(deg2rad($angle)) * $char_height;
  }
  elseif ($num == 8)
  {
    $radii = $radii - 2;

    $xpos0 = $half_char_width;
    $x_adj = -cos(deg2rad($angle));
    $ypos0 = $half_char_height;
    $y_adj = sin(deg2rad($angle)) * $char_height;
  }
  elseif ($num == 9)
  {
    $xpos0 = 0;
    $x_adj = -cos(deg2rad($angle)) * $char_width;
    $ypos0 = 2;
    $y_adj = sin(deg2rad($angle)) * $half_char_height;
  }
  elseif ($num == 10)
  {
    $xpos0 = -2;
    $x_adj = -cos(deg2rad($angle)) * $char_width;
    $ypos0 = 2;
    $y_adj = sin(deg2rad($angle)) * $half_char_height;
  }
  elseif ($num == 11)
  {
    $radii = $radii + 7;

    $xpos0 = 0;
    $x_adj = -cos(deg2rad($angle)) * $half_char_width;
    $y_adj = sin(deg2rad($angle)) * $char_height;
  }
  elseif ($num == 12)
  {
    $radii = $radii + 2;

    $xpos0 = -$half_char_width;
    $x_adj = -cos(deg2rad($angle)) * $half_char_width / 2;
    $ypos0 = $half_char_height;
    $y_adj = sin(deg2rad($angle));
  }

  $xy[0] = $xpos0 + $x_adj - ($radii * cos(deg2rad($angle)));
  $xy[1] = $ypos0 + $y_adj + ($radii * sin(deg2rad($angle)));;

  return ($xy);
}


Function drawboldtext($image, $size, $angle, $x_cord, $y_cord, $clr_to_use, $fontfile, $text, $boldness)
{
  $_x = array(1, 0, 1, 0, -1, -1, 1, 0, -1);
  $_y = array(0, -1, -1, 0, 0, -1, 1, 1, 1);

  for ($n = 0; $n <= $boldness; $n++)
  {
    imagettftext($image, $size, $angle, $x_cord+$_x[$n], $y_cord+$_y[$n], $clr_to_use, $fontfile, $text);
  }
}


Function display_planet_glyph($our_angle, $angle_to_use, $radii, &$xy, $code)
{
// $code = 0 for planet glyph, 1 for text, 2 for sign glyph, 3 for Rx symbol
// $our_angle in degree, $angle_to_use in radians
  $this_angle = Crunch($our_angle);

  if ($this_angle >= 1 And $this_angle <= 181)
  {
    if ($code == 0)
    {
      $cw_pl_glyph = 15;
      $ch_pl_glyph = 15;
    }
    elseif ($code == 1)
    {
      $cw_pl_glyph = 12;
      $ch_pl_glyph = 10;
    }
    elseif ($code == 2)
    {
      $cw_pl_glyph = 12;
      $ch_pl_glyph = 10;
    }
    else
    {
      $cw_pl_glyph = 8;
      $ch_pl_glyph = 10;
    }
  }
  else
  {
    if ($code == 0)
    {
      $cw_pl_glyph = 13;
      $ch_pl_glyph = 17;
    }
    elseif ($code == 1)
    {
      $cw_pl_glyph = 10;
      $ch_pl_glyph = 10;
    }
    elseif ($code == 2)
    {
      $cw_pl_glyph = 8;
      $ch_pl_glyph = 8;
    }
    else
    {
      $cw_pl_glyph = 6;
      $ch_pl_glyph = 10;
    }
  }

  $gap_pl_glyph = -8;

// take into account the width and height of the glyph, defined below
// get distance we need to shift the glyph so that the absolute middle of the glyph is the start point
  $center_pos_x = -$cw_pl_glyph / 2;
  $center_pos_y = $ch_pl_glyph / 2;

// get the offset we have to move the center point to in order to be properly placed
  $offset_pos_x = $center_pos_x * cos($angle_to_use);
  $offset_pos_y = $center_pos_y * sin($angle_to_use);

// now get the final X, Y coordinates
  $xy[0] = $center_pos_x + $offset_pos_x + ((-$radii + $gap_pl_glyph) * cos($angle_to_use));
  $xy[1] = $center_pos_y + $offset_pos_y + (($radii - $gap_pl_glyph) * sin($angle_to_use));

  return ($xy);
}


Function display_house_cusp($num, $angle, $radii, &$xy)
{
  $char_width = 18;       //16;
  $half_char_width = $char_width / 2;
  $char_height = 14;      //10;
  $half_char_height = $char_height / 2;

//puts center of character right on circumference of circle
  $xpos0 = -$half_char_width;
  $ypos0 = $half_char_height;

  $x_adj = -cos(deg2rad($angle));
  $y_adj = sin(deg2rad($angle));

  $xy[0] = $xpos0 + $x_adj - ($radii * cos(deg2rad($angle)));
  $xy[1] = $ypos0 + $y_adj + ($radii * sin(deg2rad($angle)));

  return ($xy);
}


Function Crunch($x)
{
  if ($x >= 0)
  {
    $y = $x - floor($x / 360) * 360;
  }
  else
  {
    $y = 360 + ($x - ((1 + floor($x / 360)) * 360));
  }

  return $y;
}


Function Check_for_overlap($angle, $spot_filled, $spacing)
{
// spacing is really 1 more than we enter with, but we use assign $spacing = 1 less for easier math below
  $result = False;

  for ($i = $angle - $spacing; $i <= $angle + $spacing; $i++)
  {
    if ($spot_filled[Crunch(round($i))] == 1)
    {
      $result = True;
      break;
    }
  }

  return $result;
}


Function Convert_Declination($declination)
{
  if ($declination < 0)
  {
    $d = "S";
  }
  else
  {
    $d = "N";
  }

  $decl = abs($declination);

  $deg = floor($decl);
  $full_min = ($decl - $deg) * 60;
  $min = floor($full_min);
  $full_sec = round(($full_min - $min) * 60);

  if ($deg < 10) { $deg = "0" . $deg; }

  if ($min < 10) { $min = "0" . $min; }

  if ($full_sec < 10) { $full_sec = "0" . $full_sec; }

  return $deg . " " . $d . " " . $min . "'";
}


Function Convert_Longitude1($longitude)
{
  $sign_num = floor($longitude / 30);
  $pos_in_sign = $longitude - ($sign_num * 30);
  $deg = floor($pos_in_sign);
  $full_min = ($pos_in_sign - $deg) * 60;
  $min = floor($full_min);
  $full_sec = round(($full_min - $min) * 60);

  if ($deg < 10) { $deg = "0" . $deg; }

  if ($min < 10) { $min = "0" . $min; }

  if ($full_sec < 10) { $full_sec = "0" . $full_sec; }

  return $deg;
}


Function Convert_Longitude2($longitude)
{
  $sign_num = floor($longitude / 30);
  $pos_in_sign = $longitude - ($sign_num * 30);
  $deg = floor($pos_in_sign);
  $full_min = ($pos_in_sign - $deg) * 60;
  $min = floor($full_min);
  $full_sec = round(($full_min - $min) * 60);

  if ($deg < 10) { $deg = "0" . $deg; }

  if ($min < 10) { $min = "0" . $min; }

  if ($full_sec < 10) { $full_sec = "0" . $full_sec; }

  return $min . "' ";
}


Function left($leftstring, $leftlength)
{
  return(substr($leftstring, 0, $leftlength));
}


Function Find_planet_strengths($i, $longitude, $hc, $speed, $house_pos, $peregrine, $speed_literal, $ori_occ, &$pps, $p0, $p1, $p2, $p3, $p4, $p5, $p6)
{
  define(SE_SUN, $p0);
  define(SE_MOON, $p1);
  define(SE_MERCURY, $p2);
  define(SE_VENUS, $p3);
  define(SE_MARS, $p4);
  define(SE_JUPITER, $p5);
  define(SE_SATURN, $p6);

  if ($i > SE_SATURN) { return; }

//find ruler of this planet's sign
  $sign_pos = floor($longitude[$i] / 30) + 1;

  if ($sign_pos == 1 Or $sign_pos == 8)
  {
    $ruler = SE_MARS;
  }
  elseif ($sign_pos == 2 Or $sign_pos == 7)
  {
    $ruler = SE_VENUS;
  }
  elseif ($sign_pos == 3 Or $sign_pos == 6)
  {
    $ruler = SE_MERCURY;
  }
  elseif ($sign_pos == 4)
  {
    $ruler = SE_MOON;
  }
  elseif ($sign_pos == 5)
  {
    $ruler = SE_SUN;
  }
  elseif ($sign_pos == 9 Or $sign_pos == 12)
  {
    $ruler = SE_JUPITER;
  }
  elseif ($sign_pos == 10 Or $sign_pos == 11)
  {
    $ruler = SE_SATURN;
  }

    if ($i == $ruler) { $pps[$i] = $pps[$i] + 5; }

//return;

//find exaltation of this planet's sign
  $exalt = -1;

  if ($sign_pos == 1)
  {
    $exalt = SE_SUN;
  }
  elseif ($sign_pos == 2)
  {
    $exalt = SE_MOON;
  }
  elseif ($sign_pos == 4)
  {
    $exalt = SE_JUPITER;
  }
  elseif ($sign_pos == 6)
  {
    $exalt = SE_MERCURY;
  }
  elseif ($sign_pos == 7)
  {
    $exalt = SE_SATURN;
  }
  elseif ($sign_pos == 10)
  {
    $exalt = SE_MARS;
  }
  elseif ($sign_pos == 12)
  {
    $exalt = SE_VENUS;
  }

    if ($i == $exalt) { $pps[$i] = $pps[$i] + 4; }

//return;

//find triplicity of this planet's sign
  if ($house_pos[SE_SUN] < 7)
  {
    //night chart
    if ($sign_pos == 1 Or $sign_pos == 5 Or $sign_pos == 9)
    {
      $triplicity = SE_JUPITER;
    }
    elseif ($sign_pos == 2 Or $sign_pos == 6 Or $sign_pos == 10)
    {
      $triplicity = SE_MOON;
    }
    elseif ($sign_pos == 3 Or $sign_pos == 7 Or $sign_pos == 11)
    {
      $triplicity = SE_MERCURY;
    }
    elseif ($sign_pos == 4 Or $sign_pos == 8 Or $sign_pos == 12)
    {
      $triplicity = SE_MARS;
    }
    }
    else
    {
      //day chart
    if ($sign_pos == 1 Or $sign_pos == 5 Or $sign_pos == 9)
    {
      $triplicity = SE_SUN;
    }
    elseif ($sign_pos == 2 Or $sign_pos == 6 Or $sign_pos == 10)
    {
      $triplicity = SE_VENUS;
    }
    elseif ($sign_pos == 3 Or $sign_pos == 7 Or $sign_pos == 11)
    {
      $triplicity = SE_SATURN;
    }
    elseif ($sign_pos == 4 Or $sign_pos == 8 Or $sign_pos == 12)
    {
      $triplicity = SE_MARS;
    }
    }

    if ($i == $triplicity) { $pps[$i] = $pps[$i] + 3; }


//find Lilly's house strength values - do Lilly's 5 degree rule
    $t = $house_pos[$i];              //get house number

//skip this section if you do not want the Lilly 5-degree rule - start
    $a3 = $t + 1;
    if ($a3 == 13) { $a3 = 1; }

    $distanceahead = $hc[$a3] - $longitude[$i];

    if ($distanceahead < 0) { $distanceahead = $distanceahead + 360; }

    if ($distanceahead <= 5)
    {
        $t++;

        if ($t == 13) { $t = 1; }
    }
//skip this section if you do not want the lilly 5-degree rule - end


    if ($t == 1 Or $t == 10)
    {
      $pps[$i] = $pps[$i] + 5;
    }
    elseif ($t == 4 Or $t == 7 Or $t == 11)
    {
      $pps[$i] = $pps[$i] + 4;
    }
    elseif ($t == 2 Or $t == 5)
    {
      $pps[$i] = $pps[$i] + 3;
    }
    elseif ($t == 9)
    {
      $pps[$i] = $pps[$i] + 2;
    }
    elseif ($t == 3)
    {
      $pps[$i] = $pps[$i] + 1;
    }
    elseif ($t == 6 Or $t == 8)
    {
      $pps[$i] = $pps[$i] - 2;
    }
    elseif ($t == 12)
    {
      $pps[$i] = $pps[$i] - 5;
    }


//find term of this planet's sign
  if ($longitude[$i] >= 0 And $longitude[$i] < 6) { $term = SE_JUPITER; }
  if ($longitude[$i] >= 6 And $longitude[$i] < 14) { $term = SE_VENUS; }
  if ($longitude[$i] >= 14 And $longitude[$i] < 21) { $term = SE_MERCURY; }
  if ($longitude[$i] >= 21 And $longitude[$i] < 26) { $term = SE_MARS; }
  if ($longitude[$i] >= 26 And $longitude[$i] < 30) { $term = SE_SATURN; }
  if ($longitude[$i] >= 30 And $longitude[$i] < 38) { $term = SE_VENUS; }
  if ($longitude[$i] >= 38 And $longitude[$i] < 45) { $term = SE_MERCURY; }
  if ($longitude[$i] >= 45 And $longitude[$i] < 52) { $term = SE_JUPITER; }
  if ($longitude[$i] >= 52 And $longitude[$i] < 56) { $term = SE_SATURN; }
  if ($longitude[$i] >= 56 And $longitude[$i] < 60) { $term = SE_MARS; }
  if ($longitude[$i] >= 60 And $longitude[$i] < 67) { $term = SE_MERCURY; }
  if ($longitude[$i] >= 67 And $longitude[$i] < 74) { $term = SE_JUPITER; }
  if ($longitude[$i] >= 74 And $longitude[$i] < 81) { $term = SE_VENUS; }
  if ($longitude[$i] >= 81 And $longitude[$i] < 85) { $term = SE_SATURN; }
  if ($longitude[$i] >= 85 And $longitude[$i] < 90) { $term = SE_MARS; }
  if ($longitude[$i] >= 90 And $longitude[$i] < 96) { $term = SE_MARS; }
  if ($longitude[$i] >= 96 And $longitude[$i] < 103) { $term = SE_JUPITER; }
  if ($longitude[$i] >= 103 And $longitude[$i] < 110) { $term = SE_MERCURY; }
  if ($longitude[$i] >= 110 And $longitude[$i] < 117) { $term = SE_VENUS; }
  if ($longitude[$i] >= 117 And $longitude[$i] < 120) { $term = SE_SATURN; }
  if ($longitude[$i] >= 120 And $longitude[$i] < 126) { $term = SE_SATURN; }
  if ($longitude[$i] >= 126 And $longitude[$i] < 133) { $term = SE_MERCURY; }
  if ($longitude[$i] >= 133 And $longitude[$i] < 139) { $term = SE_VENUS; }
  if ($longitude[$i] >= 139 And $longitude[$i] < 145) { $term = SE_JUPITER; }
  if ($longitude[$i] >= 145 And $longitude[$i] < 150) { $term = SE_MARS; }
  if ($longitude[$i] >= 150 And $longitude[$i] < 157) { $term = SE_MERCURY; }
  if ($longitude[$i] >= 157 And $longitude[$i] < 163) { $term = SE_VENUS; }
  if ($longitude[$i] >= 163 And $longitude[$i] < 168) { $term = SE_JUPITER; }
  if ($longitude[$i] >= 168 And $longitude[$i] < 174) { $term = SE_SATURN; }
  if ($longitude[$i] >= 174 And $longitude[$i] < 180) { $term = SE_MARS; }
  if ($longitude[$i] >= 180 And $longitude[$i] < 186) { $term = SE_SATURN; }
  if ($longitude[$i] >= 186 And $longitude[$i] < 191) { $term = SE_VENUS; }
  if ($longitude[$i] >= 191 And $longitude[$i] < 199) { $term = SE_JUPITER; }
  if ($longitude[$i] >= 199 And $longitude[$i] < 204) { $term = SE_MERCURY; }
  if ($longitude[$i] >= 204 And $longitude[$i] < 210) { $term = SE_MARS; }
  if ($longitude[$i] >= 210 And $longitude[$i] < 216) { $term = SE_MARS; }
  if ($longitude[$i] >= 216 And $longitude[$i] < 224) { $term = SE_JUPITER; }
  if ($longitude[$i] >= 224 And $longitude[$i] < 231) { $term = SE_VENUS; }
  if ($longitude[$i] >= 231 And $longitude[$i] < 237) { $term = SE_MERCURY; }
  if ($longitude[$i] >= 237 And $longitude[$i] < 240) { $term = SE_SATURN; }
  if ($longitude[$i] >= 240 And $longitude[$i] < 248) { $term = SE_JUPITER; }
  if ($longitude[$i] >= 248 And $longitude[$i] < 254) { $term = SE_VENUS; }
  if ($longitude[$i] >= 254 And $longitude[$i] < 259) { $term = SE_MERCURY; }
  if ($longitude[$i] >= 259 And $longitude[$i] < 265) { $term = SE_SATURN; }
  if ($longitude[$i] >= 265 And $longitude[$i] < 270) { $term = SE_MARS; }
  if ($longitude[$i] >= 270 And $longitude[$i] < 276) { $term = SE_VENUS; }
  if ($longitude[$i] >= 276 And $longitude[$i] < 282) { $term = SE_MERCURY; }
  if ($longitude[$i] >= 282 And $longitude[$i] < 289) { $term = SE_JUPITER; }
  if ($longitude[$i] >= 289 And $longitude[$i] < 295) { $term = SE_MARS; }
  if ($longitude[$i] >= 295 And $longitude[$i] < 300) { $term = SE_SATURN; }
  if ($longitude[$i] >= 300 And $longitude[$i] < 306) { $term = SE_SATURN; }
  if ($longitude[$i] >= 306 And $longitude[$i] < 312) { $term = SE_MERCURY; }
  if ($longitude[$i] >= 312 And $longitude[$i] < 320) { $term = SE_VENUS; }
  if ($longitude[$i] >= 320 And $longitude[$i] < 325) { $term = SE_JUPITER; }
  if ($longitude[$i] >= 325 And $longitude[$i] < 330) { $term = SE_MARS; }
  if ($longitude[$i] >= 330 And $longitude[$i] < 338) { $term = SE_VENUS; }
  if ($longitude[$i] >= 338 And $longitude[$i] < 344) { $term = SE_JUPITER; }
  if ($longitude[$i] >= 344 And $longitude[$i] < 350) { $term = SE_MERCURY; }
  if ($longitude[$i] >= 350 And $longitude[$i] < 356) { $term = SE_MARS; }
  if ($longitude[$i] >= 356 And $longitude[$i] < 360) { $term = SE_SATURN; }

    if ($i == $term) { $pps[$i] = $pps[$i] + 2; }



//find face of this planet's sign
  $t = $longitude[$i];

    while ($t >= 70)
    {
      $t = $t - 70;
    }

  if ($t >= 0 And $t < 10)
  {
    $face = SE_MARS;
  }
  elseif ($t >= 10 And $t < 20)
  {
    $face = SE_SUN;
  }
  elseif ($t >= 20 And $t < 30)
  {
    $face = SE_VENUS;
  }
  elseif ($t >= 30 And $t < 40)
  {
    $face = SE_MERCURY;
  }
  elseif ($t >= 40 And $t < 50)
  {
    $face = SE_MOON;
  }
  elseif ($t >= 50 And $t < 60)
  {
    $face = SE_SATURN;
  }
  elseif ($t >= 60 And $t < 70)
  {
    $face = SE_JUPITER;
  }

    if ($i == $face) { $pps[$i] = $pps[$i] + 1; }


//return;


//retrograde, speed, oriental/occidental
  if ($speed[$i] < 0)
  {
    $pps[$i] = $pps[$i] - 5;                        //retrograde
  }
  else
  {
    if ($i >= SE_MERCURY And $speed[$i] > 0) { $pps[$i] = $pps[$i] + 4; }             //direct

    if ($speed_literal == "Fast") { $pps[$i] = $pps[$i] + 2; }                  //fast
    if ($speed_literal == "Slow" Or $speed_literal == "stat") { $pps[$i] = $pps[$i] - 2; }    //slow or stationary
  }

//return;

  if ($i == SE_MOON And $ori_occ == "ori") { $pps[$i] = $pps[$i] - 2; }             //oriental/occidental
  if ($i == SE_MERCURY And $ori_occ == "ori") { $pps[$i] = $pps[$i] - 2; }            //oriental/occidental
  if ($i == SE_VENUS And $ori_occ == "ori") { $pps[$i] = $pps[$i] - 2; }            //oriental/occidental

  if ($i == SE_MARS And $ori_occ == "occ") { $pps[$i] = $pps[$i] - 2; }             //oriental/occidental
  if ($i == SE_JUPITER And $ori_occ == "occ") { $pps[$i] = $pps[$i] - 2; }            //oriental/occidental
  if ($i == SE_SATURN And $ori_occ == "occ") { $pps[$i] = $pps[$i] - 2; }           //oriental/occidental

  if ($i == SE_MOON And $ori_occ == "occ") { $pps[$i] = $pps[$i] + 2; }             //oriental/occidental
  if ($i == SE_MERCURY And $ori_occ == "occ") { $pps[$i] = $pps[$i] + 2; }            //oriental/occidental
  if ($i == SE_VENUS And $ori_occ == "occ") { $pps[$i] = $pps[$i] + 2; }            //oriental/occidental

  if ($i == SE_MARS And $ori_occ == "ori") { $pps[$i] = $pps[$i] + 2; }             //oriental/occidental
  if ($i == SE_JUPITER And $ori_occ == "ori") { $pps[$i] = $pps[$i] + 2; }            //oriental/occidental
  if ($i == SE_SATURN And $ori_occ == "ori") { $pps[$i] = $pps[$i] + 2; }           //oriental/occidental

//return;

//get peregrine
    if ($peregrine[$i] == 1) { $pps[$i] = $pps[$i] - 5; }

//return;

//find detriment of this planet's sign
  if ($sign_pos == 7 Or $sign_pos == 2)
  {
    $detriment = SE_MARS;
  }
  elseif ($sign_pos == 8 Or $sign_pos == 1)
  {
    $detriment = SE_VENUS;
  }
  elseif ($sign_pos == 9 Or $sign_pos == 12)
  {
    $detriment = SE_MERCURY;
  }
  elseif ($sign_pos == 10)
  {
    $detriment = SE_MOON;
  }
  elseif ($sign_pos == 11)
  {
    $detriment = SE_SUN;
  }
  elseif ($sign_pos == 3 Or $sign_pos == 6)
  {
    $detriment = SE_JUPITER;
  }
  elseif ($sign_pos == 4 Or $sign_pos == 5)
  {
    $detriment = SE_SATURN;
  }

    if ($i == $detriment) { $pps[$i] = $pps[$i] - 5; }

//return;

//find fall of this planet's sign
  $fall = -1;

  if ($sign_pos == 7)
  {
    $fall = SE_SUN;
  }
  elseif ($sign_pos == 8)
  {
    $fall = SE_MOON;
  }
  elseif ($sign_pos == 10)
  {
    $fall = SE_JUPITER;
  }
  elseif ($sign_pos == 12)
  {
    $fall = SE_MERCURY;
  }
  elseif ($sign_pos == 1)
  {
    $fall = SE_SATURN;
  }
  elseif ($sign_pos == 4)
  {
    $fall = SE_MARS;
  }
  elseif ($sign_pos == 6)
  {
    $fall = SE_VENUS;
  }

    if ($i == $fall) { $pps[$i] = $pps[$i] - 4; }

//return;

//mutual receptions - by sign
  $t = floor($longitude[$i] / 30) + 1;      //get the sign of the first planet

  if ($t == 1 Or $t == 8) { $x = SE_MARS; }
  if ($t == 2 Or $t == 7) { $x = SE_VENUS; }
  if ($t == 3 Or $t == 6) { $x = SE_MERCURY; }
  if ($t == 4) { $x = SE_MOON; }
  if ($t == 5) { $x = SE_SUN; }
  if ($t == 9 Or $t == 12) { $x = SE_JUPITER; }
  if ($t == 10 Or $t == 11) { $x = SE_SATURN; }

  $t = floor($longitude[$x] / 30) + 1;      //get the sign of the second planet

  if ($i == SE_SUN And $x > $i And $t == 5) { $pps[$i] = $pps[$i] + 5; $pps[$x] = $pps[$x] + 5; }
  if ($i == SE_MOON And $x > $i And $t == 4) { $pps[$i] = $pps[$i] + 5; $pps[$x] = $pps[$x] + 5; }
  if ($i == SE_MERCURY And $x > $i And ($t == 3 Or $t == 6)) { $pps[$i] = $pps[$i] + 5; $pps[$x] = $pps[$x] + 5; }
  if ($i == SE_VENUS And $x > $i And ($t == 2 Or $t == 7)) { $pps[$i] = $pps[$i] + 5; $pps[$x] = $pps[$x] + 5; }
  if ($i == SE_MARS And $x > $i And ($t == 1 Or $t == 8)) { $pps[$i] = $pps[$i] + 5; $pps[$x] = $pps[$x] + 5; }
  if ($i == SE_JUPITER And $x > $i And ($t == 9 Or $t == 12)) { $pps[$i] = $pps[$i] + 5; $pps[$x] = $pps[$x] + 5; }
  if ($i == SE_SATURN And $x > $i And ($t == 10 Or $t == 11)) { $pps[$i] = $pps[$i] + 5; $pps[$x] = $pps[$x] + 5; }

//return;

//mutual receptions - by exaltation
  $t = floor($longitude[$i] / 30) + 1;      //get the sign of the first planet

  if ($t != 3 And $t != 5 And $t != 8 And $t != 9 And $t != 11)
  {
    if ($t == 1) { $x = SE_SUN; }
    if ($t == 2) { $x = SE_MOON; }
    if ($t == 4) { $x = SE_JUPITER; }
    if ($t == 6) { $x = SE_MERCURY; }
    if ($t == 7) { $x = SE_SATURN; }
    if ($t == 10) { $x = SE_MARS; }
    if ($t == 12) { $x = SE_VENUS; }

    $t = floor($longitude[$x] / 30) + 1;      //get the sign of the second planet

    if ($i == SE_SUN And $x > $i And $t == 1) { $pps[$i] = $pps[$i] + 4; $pps[$x] = $pps[$x] + 4; }
    if ($i == SE_MOON And $x > $i And $t == 2) { $pps[$i] = $pps[$i] + 4; $pps[$x] = $pps[$x] + 4; }
    if ($i == SE_MERCURY And $x > $i And $t == 6) { $pps[$i] = $pps[$i] + 4; $pps[$x] = $pps[$x] + 4; }
    if ($i == SE_VENUS And $x > $i And $t == 12) { $pps[$i] = $pps[$i] + 4; $pps[$x] = $pps[$x] + 4; }
    if ($i == SE_MARS And $x > $i And $t == 10) { $pps[$i] = $pps[$i] + 4; $pps[$x] = $pps[$x] + 4; }
    if ($i == SE_JUPITER And $x > $i And $t == 4) { $pps[$i] = $pps[$i] + 4; $pps[$x] = $pps[$x] + 4; }
    if ($i == SE_SATURN And $x > $i And $t == 7) { $pps[$i] = $pps[$i] + 4; $pps[$x] = $pps[$x] + 4; }
  }

//return;

//cazimi planets
  if ($i > SE_SUN)
  {
    if (abs($longitude[SE_SUN] - $longitude[$i]) >= 0 And abs($longitude[SE_SUN] - $longitude[$i]) <= .28333) { $pps[$i] = $pps[$i] + 5; }
    if (abs($longitude[SE_SUN] - $longitude[$i]) > 17) { $pps[$i] = $pps[$i] + 5; }                 //not under Sun's beams
  }

//combust planets
  if ($i > SE_SUN)
  {
    if (floor($longitude[SE_SUN] / 30) == floor($longitude[$i] / 30) And abs($longitude[SE_SUN] - $longitude[$i]) >= .28333 And abs($longitude[SE_SUN] - $longitude[$i]) <= 8.5) { $pps[$i] = $pps[$i] - 5; }
  }


//under the Sun's beam planets
  if ($i > SE_SUN)
  {
    if (floor($longitude[SE_SUN] / 30) != floor($longitude[$i] / 30) And abs($longitude[SE_SUN] - $longitude[$i]) >= .28333 And abs($longitude[SE_SUN] - $longitude[$i]) <= 8.5)
    {
      $pps[$i] = $pps[$i] - 4;
    }
    elseif (abs($longitude[SE_SUN] - $longitude[$i]) >= 8.5 And abs($longitude[SE_SUN] - $longitude[$i]) <= 17)
    {
      $pps[$i] = $pps[$i] - 4;
    }
  }


//besieged planets
  if (floor($longitude[SE_MARS] / 30) == floor($longitude[SE_SATURN] / 30))   //Mars and Saturn must be in the same sign
  {
    if ($i != 4 And $i < 6)                           //skip Mars and Saturn
    {
      if ($longitude[SE_SATURN] - $longitude[SE_MARS] >= 0)
      {
        if ($longitude[$i] >= $longitude[SE_MARS] And $longitude[$i] <= $longitude[SE_SATURN]) { $pps[$i] = $pps[$i] - 5; }
      }
      else
      {
        if ($longitude[$i] >= $longitude[SE_SATURN] And $longitude[$i] <= $longitude[SE_MARS]) { $pps[$i] = $pps[$i] - 5; }
      }
    }
  }

//return;

//conjunct Algol, Regulus
  $dyr = $_SESSION['inyear'] - 1990;          //$dyr = delta year - fixed star positions in 1990
  $dfsp = $dyr * 50.23 / 3600;            //fixed star movement since 1990 = $dfsp

  if ($longitude[$i] >= ($dfsp + 56.03000 - 5) And $longitude[$i] <= ($dfsp + 56.03000 + 5)) { $pps[$i] = $pps[$i] - 5; }   //Algol
  if ($longitude[$i] >= ($dfsp + 148.70000) And $longitude[$i] <= ($dfsp + 150.70000)) { $pps[$i] = $pps[$i] + 6; }       //Regulus
  if ($longitude[$i] >= ($dfsp + 202.70000) And $longitude[$i] <= ($dfsp + 204.70000)) { $pps[$i] = $pps[$i] + 5; }       //Spica
}


Function Find_planet_aspects($i ,$longitude, &$pps)
{
//get strengths by aspect
  $moiety[0] = 8.5;     //planet moiety (1/2 the orb)
  $moiety[1] = 6.25;
  $moiety[2] = 3.5;
  $moiety[3] = 4;
  $moiety[4] = 3.75;
  $moiety[5] = 6;
  $moiety[6] = 5;
  $moiety[7] = 3;
  $moiety[8] = 3;
  $moiety[9] = 3;
  $moiety[10] = 3;
  $moiety[11] = 3;
  $moiety[12] = 3;

  for ($j = 0; $j <= 11; $j++)
  {
    if ($j == $i) { continue; }

    $q = 0;
    $da = abs($longitude[$j] - $longitude[$i]);

    if ($da > 180) { $da = 360 - $da; }

    $orb = $moiety[$j] + $moiety[$i];

    // is there an aspect within orb?
    if ($da <= $orb)
    {
      $q = 1;
    }
    elseif (($da <= (60 + $orb)) And ($da >= (60 - $orb)))
    {
      $q = 6;
    }
    elseif (($da <= (90 + $orb)) And ($da >= (90 - $orb)))
    {
      $q = 4;
    }
    elseif (($da <= (120 + $orb)) And ($da >= (120 - $orb)))
    {
      $q = 3;
    }
    elseif (($da <= (150 + $orb)) And ($da >= (150 - $orb)))
    {
      $q = 5;
    }
    elseif ($da >= (180 - $orb))
    {
      $q = 2;
    }


    if ($q > 0)
    {
      // aspect exists
      if (floor($longitude[$i] - (floor($longitude[$i] / 30) * 30)) == floor($longitude[$j] - (floor($longitude[$j] / 30) * 30)))
      {
        if ($q == 1 And $j == 3) { $pps[$i] = $pps[$i] + 5; }
        if ($q == 1 And $j == 5) { $pps[$i] = $pps[$i] + 5; }
        if ($q == 1 And $j == 11) { $pps[$i] = $pps[$i] + 4; }
        if ($q == 6 And $j == 3) { $pps[$i] = $pps[$i] + 3; }
        if ($q == 6 And $j == 5) { $pps[$i] = $pps[$i] + 3; }
        if ($q == 3 And $j == 3) { $pps[$i] = $pps[$i] + 4; }
        if ($q == 3 And $j == 5) { $pps[$i] = $pps[$i] + 4; }
        if ($q == 1 And $j == 4) { $pps[$i] = $pps[$i] - 5; }
        if ($q == 1 And $j == 6) { $pps[$i] = $pps[$i] - 5; }
        if ($q == 1 And $j == 12) { $pps[$i] = $pps[$i] - 4; }
        if ($q == 4 And $j == 4) { $pps[$i] = $pps[$i] - 3; }
        if ($q == 4 And $j == 6) { $pps[$i] = $pps[$i] - 3; }
        if ($q == 2 And $j == 4) { $pps[$i] = $pps[$i] - 4; }
        if ($q == 2 And $j == 6) { $pps[$i] = $pps[$i] - 4; }
      }
    }
  }
}


Function Sort_planets_by_descending_longitude_2($num_planets, $longitude, &$sort, &$sort_pos)
{
// load all $longitude[] into sort[] and keep track of the planet numbers in $sort_pos[]
  for ($i = 0; $i <= $num_planets - 1; $i++)
  {
    $sort[$i] = Reduce_below_30($longitude[$i]);
    $sort_pos[$i] = $i;
  }

// do the actual sort
  for ($i = 0; $i <= $num_planets - 2; $i++)
  {
    for ($j = $i + 1; $j <= $num_planets - 1; $j++)
    {
      if ($sort[$j] > $sort[$i])
      {
        $temp = $sort[$i];
        $temp1 = $sort_pos[$i];

        $sort[$i] = $sort[$j];
        $sort_pos[$i] = $sort_pos[$j];

        $sort[$j] = $temp;
        $sort_pos[$j] = $temp1;
      }
    }
  }
}


Function sgnx($x)
{
  if ($x > 0)
  {
    return 1;
  }
  elseif ($x < 0)
  {
    return -1;
  }
  elseif ($x == 0)
  {
    return 0;
  }
}


Function Find_best_planet_to_start_with($num_planets, $house_pos, &$sort_pos, &$sort, $nopih)
{
  
  //step 1 - find planets which have at least 20 deg clearance between themselves and the next lower planet in the array
  for ($i = $num_planets - 2; $i >= 0; $i--)
  {
    if ($sort[$i] - $sort[$i + 1] >= 20)
    {
      //step 2 - is this planet the first (and only) planet in the house?
      $pl_num = $sort_pos[$i];
      $house_of_pl = $house_pos[$pl_num];
      if ($nopih[$house_of_pl] == 1)
      {
        $start_planet = $pl_num;
        $start_planet_idx = $i;
        break;
      }
    }
  }
  
  if ($i < 0) { return; }       //we did not find a planet that meets our needs so do not change the $sort[] array
  
  //here we reorder the $sort[] and $sort_pos[] arrays so that we start with the indicated planet, which is $start_planet
  $sp = array();
  $s = array();
  
  $cnt = $num_planets - 1;
  for ($i = $start_planet_idx; $i >= 0; $i--)
  {
    $sp[$cnt] = $sort_pos[$i];
    $s[$cnt] = $sort[$i];
    $cnt--;
  } 

  for ($i = $num_planets - 1; $i > $start_planet_idx; $i--)
  {
    $sp[$cnt] = $sort_pos[$i];
    $s[$cnt] = $sort[$i];
    $cnt--;
  } 

  $sort_pos = $sp;
  $sort = $s;
}

?>